{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


procedure tAnalyse.TTkommu(Term:PTermTyp); inline;         // KOMMUTATIVGESETZ
var ZwSp:PTermTyp;
begin
  If (Term^.Opera=4)or(Term^.Opera=5) then
  begin
    ZwSp:=Term^.Arg1;
    Term^.Arg1:=Term^.Arg2;
    Term^.Arg2:=ZwSp;
  end;
end; // TTkommu


procedure tAnalyse.TTassoz(Term:PTermTyp;ArgNr:byte);      // ASSOZIATIVGESETZ
var Opera:cardinal;
    ZwSp:PTermTyp;
begin
  Opera:=Term^.Opera;
  If (Opera=4)or(Opera=5) then
  begin
    If (ArgNr=1) then if Term^.Arg1^.Opera=Opera then      // (a+b)+c --> a+(b+c)
    begin
      ZwSp:=Term^.Arg2;
      Term^.Arg2:=Term^.Arg1;
      Term^.Arg1:=Term^.Arg2^.Arg1;
      Term^.Arg2^.Arg1:=ZwSp;
      TTkommu(Term^.Arg2);
    end;
    If (ArgNr=2) then if Term^.Arg2^.Opera=Opera then      // a+(b+c) --> (a+b)+c
    begin
      ZwSp:=Term^.Arg1;
      Term^.Arg1:=Term^.Arg2;
      Term^.Arg2:=Term^.Arg1^.Arg2;
      Term^.Arg1^.Arg2:=ZwSp;
      TTkommu(Term^.Arg1);
    end;
  end;
end; // TTassoz


procedure tAnalyse.TTdistri(Term:PTermTyp; ArgNr:byte);    //DISTRIBUTIVGESETZ
var ZwSp:PTermTyp;
begin
  If Term^.Opera=5 then
  begin
    If (ArgNr=1)and(Term^.Arg1^.Opera=4) then              // (a+b)*c --> a*c+b*c
    begin
      ZwSp:=Term^.Arg1^.Arg2;
      Term^.Arg1^.Arg2:=Term^.Arg2;
      Term^.Arg1^.Opera:=5;
      Term^.Arg2:=nil;
      new(Term^.Arg2);
      Term^.Arg2^.Opera:=5;
      Term^.Arg2^.Arg1:=ZwSp;
      Term^.Arg2^.Arg2:=TTKopieVon(Term^.Arg1^.Arg2);
      Term^.Opera:=4;
    end;
    If (ArgNr=2)and(Term^.Arg2^.Opera=4) then              // a*(b+c) --> a*b+a*c
    begin
      ZwSp:=Term^.Arg2^.Arg1;
      Term^.Arg2^.Arg1:=Term^.Arg1;
      Term^.Arg2^.Opera:=5;
      Term^.Arg1:=nil;
      new(Term^.Arg1);
      Term^.Arg1^.Opera:=5;                                // <-- BUG ???
      Term^.Arg1^.Arg1:=TTKopieVon(Term^.Arg2^.Arg1);
      Term^.Arg1^.Arg2:=ZwSp;
      Term^.Opera:=4;
    end;
  end; // Opera=5
end; // TTdistri


procedure tAnalyse.TTVereinfachung(var Term:PTermTyp);
var Kopf,Fuss,ZwSp,Faktor,Basis,Exponent,Summand:PTermTyp;
    VorfaktorGRaZ: GRaZTyp;
    ZwSpGNZ: GNZTyp;
    AbbruchBed, nochmal:boolean;
begin
  // showmessage(TermtypToStr(Term,0));
  nochmal:=false;                                                                                             //nochmal dient der Vermeidung von Bug a+b-b --> a+0: Die gesamte Routine wird nochmals aufgerufen.
  CASE Term^.Opera OF
    004:      begin
                // Rekursion, damit alle Terme sortiert werden:
                Kopf:=Term;
                while Kopf^.Arg2^.Opera=004 do
                begin
                  TTVereinfachung(Kopf^.Arg1);
                  Kopf:=Kopf^.Arg2;
                end;
                TTVereinfachung(Kopf^.Arg1);
                TTVereinfachung(Kopf^.Arg2);

                // Term wird jetzt auf eine Form gebracht, mit der der Sortierungsalgorithmus umgehen kann. Dazu wird der Term so umgeformt, dass die Operation 004 jeweils nur noch im Arg2 stattfindet.
                // In den Arg1 und im letzten Arg2 befinden sich dann also nur noch die einzelnen Summanden.
                Kopf:=Term;
                while (Kopf^.Arg1^.Opera=004)or(Kopf^.Arg2^.Opera=004) do
                begin
                  while Kopf^.Arg1^.Opera=004 do TTAssoz(Kopf,1);
                  If Kopf^.Arg2^.Opera=004 then Kopf:=Kopf^.Arg2;
                end;

                // Nun wird sortiert:
                AbbruchBed:=false;
                while not AbbruchBed do
                begin
                  Kopf:=Term;
                  AbbruchBed:=true;
                  while Kopf^.Arg2^.Opera=004 do
                  begin
                    If TTakleinerb(Kopf^.Arg2^.Arg1,Kopf^.Arg1) then
                    begin                                                                                     // Vertauschen von Kopf^.Arg1 und Kopf^.Arg2^.Arg1
                      ZwSp:=Kopf^.Arg2^.Arg1;                                                                 // Bem.: Da sich TTVereinfachung oben rekursiv aufruft, tauscht er auch d+c+b+a --> a+b+c+d korrekt, obwohl dies beim Einfachen durchlauf dieser Schleife nicht der Fall wäre.
                      Kopf^.Arg2^.Arg1:=Kopf^.Arg1;
                      Kopf^.Arg1:=ZwSp;
                      ZwSp:=nil;
                      AbbruchBed:=false;
                    end;
                    Kopf:=Kopf^.Arg2;
                  end; //while Kopf
                  If TTakleinerb(Kopf^.Arg2,Kopf^.Arg1) then
                  begin
                    TTkommu(Kopf);
                    AbbruchBed:=false;
                  end;
                end; //while not AbbruchBed

                // NUN WIRD VEREINFACHT:
                If Term^.Arg1^.Opera=001 then                                                                 // 1+3+2+5+a = 11+a --> Vereinfachungen bzgl. Summanden der Opera=001
                begin
                  AbbruchBed:=false;
                  while (not AbbruchBed)and(Term^.Arg2^.Opera=004) do
                  begin
                    AbbruchBed := Term^.Arg2^.Arg1^.Opera<>001;
                    If not AbbruchBed then
                    begin
                      Term^.Arg1^.ZahlGRaZ:=GRaZadd(Term^.Arg1^.ZahlGRaZ,Term^.Arg2^.Arg1^.ZahlGRaZ);
                      Dispose(Term^.Arg2^.Arg1); Term^.Arg2^.Arg1:=nil;
                      ZwSp:=Term^.Arg2;
                      Term^.Arg2:=Term^.Arg2^.Arg2;
                      Dispose(ZwSp); ZwSp:=nil;
                    end;
                  end; // while
                  If Term^.Arg2^.Opera=001 then
                  begin
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZadd(Term^.Arg1^.ZahlGRaZ,Term^.Arg2^.ZahlGRaZ);
                    Dispose(Term^.Arg1); Term^.Arg1:=nil;
                    Dispose(Term^.Arg2); Term^.Arg2:=nil;
                  end else
                  if (length(Term^.Arg1^.ZahlGRaZ.zaehler)=1)and(Term^.Arg1^.ZahlGRaZ.zaehler[0]=0) then      // Summand ist 0
                  begin
                    ZwSp:=Term;
                    Term:=Term^.Arg2;
                    Dispose(ZwSp^.Arg1); ZwSp^.Arg1:=nil;
                    Dispose(ZwSp); ZwSp:=nil;
                  end;
                end; // Vereinfachung: If Term^.Arg1^.Opera=001

                If Term^.Opera=004 then                                                                       // a+5*a+3*a=9*a
                begin
                  If Term^.Arg1^.Opera<>001 then Fuss:=Term else Fuss:=Term^.Arg2;
                  while Fuss^.Opera=004 do
                  begin                                                                                       // Große Schleife: Term wird Summand für Summand durchlaufen und zusammengefasst
                    Summand:=Fuss^.Arg1;
                    If Summand^.Opera<>005 then                                                               // Basis festlegen. Bein 45*d*sin(x) ist Basis = d*sin(x)
                    begin  // bspw. Summand = a
                      Basis:=Summand;
                      VorFaktorGRaZ:=GRaZeins;
                    end else if Summand^.Arg1^.Opera=001 then
                    begin  // bspw. Summand = 2*(a*b)
                      Basis:=Summand^.Arg2;
                      VorFaktorGRaZ:=Summand^.Arg1^.ZahlGRaZ;
                    end else
                    begin  // bspw. Summand = a*b
                      Basis:=Summand;
                      VorFaktorGRaZ:=GRaZeins;
                    end;

                    AbbruchBed:=false;
                    while (not AbbruchBed)and(Fuss^.Arg2^.Opera=004) do                                       //Hier wird nach Summanden gleicher Basis gesucht. Diese werden zusammengefasst.
                    begin
                      If Fuss^.Arg2^.Arg1^.Opera<>005 then
                      begin  // a
                        If not TTagleichb(Basis,Fuss^.Arg2^.Arg1) then AbbruchBed:=true else
                        begin
                          VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,GRaZeins);                                     //Erhöht den Vorfaktor um 1
                          ZwSp:=Fuss^.Arg2;                                                                   //Umstrukturierung des Terms
                          Fuss^.Arg2:=Fuss^.Arg2^.Arg2;
                          TTTermfreigabe(ZwSp^.Arg1);
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end else if Fuss^.Arg2^.Arg1^.Arg1.Opera=001 then
                      begin  // 2*a*b
                        If not TTagleichb(Basis,Fuss^.Arg2^.Arg1^.Arg2) then AbbruchBed:=true else
                        begin
                          VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,Fuss^.Arg2^.Arg1^.Arg1^.ZahlGRaZ);
                          ZwSp:=Fuss^.Arg2;
                          Fuss^.Arg2:=Fuss^.Arg2^.Arg2;
                          TTTermfreigabe(ZwSp^.Arg1);
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end else
                      begin  // a*b
                        If not TTagleichb(Basis,Fuss^.Arg2^.Arg1) then AbbruchBed:=true else
                        begin
                          VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,GRaZeins);                                     //Erhöht den Vorfaktor um 1
                          ZwSp:=Fuss^.Arg2;                                                                   //Umstrukturierung des Terms
                          Fuss^.Arg2:=Fuss^.Arg2^.Arg2;
                          TTTermfreigabe(ZwSp^.Arg1);
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end; // If Fuss^.Arg2^.Arg1^.Opera<>005
                    end; // WHILE (not AbbruchBed)and(Fuss^.Arg2^.Opera=004)

                    If (not AbbruchBed)and(Fuss^.Arg2^.Opera<>004) then
                    begin
                      If Fuss^.Arg2^.Opera<>005 then
                      begin  // a
                        If TTagleichb(Basis,Fuss^.Arg2) then
                        begin
                          VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,GRaZeins);                                     //Erhöht den Vorfaktor um 1
                          TTTermfreigabe(Fuss^.Arg2);
                          ZwSp:=Fuss^.Arg1;
                          Fuss^:=Fuss^.Arg1^;                                                                 // Hier wird die Position des Summanden verschoben...
                          Summand:=Fuss;                                                                      // ... und der Zeiger entsprechend angepasst.
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end else if Fuss^.Arg2^.Arg1^.Opera=001 then
                      begin  // 5*a*b
                        If TTagleichb(Basis,Fuss^.Arg2^.Arg2) then
                        begin
                          VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,Fuss^.Arg2^.Arg1^.ZahlGRaZ);                   // Rechnet die Vorfaktoren zusammen
                          TTTermfreigabe(Fuss^.Arg2);
                          ZwSp:=Fuss^.Arg1;
                          Fuss^:=Fuss^.Arg1^;                                                                 // Hier wird die Position des Summanden verrückt...
                          Summand:=Fuss;                                                                      // ... und der zugehörige Zeiger entsprechend angepasst.
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end else
                      begin  // a*b
                        If TTagleichb(Basis,Fuss^.Arg2) then
                        begin
                          VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,GRaZeins);                                     //Erhöht den Vorfaktor um 1
                          TTTermfreigabe(Fuss^.Arg2);
                          ZwSp:=Fuss^.Arg1;
                          Fuss^:=Fuss^.Arg1^;                                                                 // Hier wird die Position des Summanden verschoben...
                          Summand:=Fuss;                                                                      // ... und der Zeiger entsprechend angepasst.
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end; // If Fuss^.Arg2^.Opera<>005
                    end; // If... Bearbeitung letztes Element

                    TTVereinfachung(Summand);
                    If (Summand^.Opera<>005) then
                    begin  // a
                      If (length(VorFaktorGRaZ.zaehler)=1)and(VorFaktorGRaZ.zaehler[0]=0) then
                      begin
                        If (Summand^.Opera>100)and(Summand^.Opera<129) then TTTermfreigabe(Summand^.Arg1);
                        If (Summand^.Opera>=004)and(Summand^.Opera<=006) then
                        begin
                          TTTermfreigabe(Summand^.Arg1);
                          TTTermfreigabe(Summand^.Arg2);
                        end;
                        Summand^.Opera:=001;
                        Summand^.ZahlGRaZ:=GRaZnull;
                        NOCHMAL:=true;                                                                        // Es könnte die Vereinfachung a+b-b --> a+0 auftreten, welche nicht weiter vereinfacht werden würde. Daher muss die gesamte Routine NOCHMAL durchlaufen werden.
                      end else if not (GNZagleichb(VorfaktorGRaZ.zaehler,VorFaktorGRaZ.nenner) and(not VorFaktorGRaZ.Negativ)) then
                      begin  // a --> 5*a
                        new(ZwSp);
                        ZwSp^:=Summand^;
                        Summand^.Opera:=005;
                        new(Summand^.Arg1);
                        Summand^.Arg1^.Opera:=001;
                        Summand^.Arg1^.ZahlGRaZ:=GRaZcopy(VorFaktorGRaZ);                                     // Ist hier und in den Folgezeilen GRaZcopy notwendig?
                        Summand^.Arg2:=ZwSp;
                      end;
                    end else if Summand^.Arg1^.Opera=001 then
                    begin  // 5*a*b
                      If (GNZagleichb(VorFaktorGRaZ.zaehler,VorFaktorGRaZ.nenner) and(not VorFaktorGRaZ.Negativ)) then
                      begin  // 1*a*b --> a*b
                        ZwSp:=Summand^.Arg2;
                        Dispose(Summand^.Arg1); Summand^.Arg1:=nil;
                        Summand^:=Summand^.Arg2^;
                        Dispose(ZwSp); ZwSp:=nil;
                      end else if (length(VorFaktorGRaZ.zaehler)=1)and(VorFaktorGRaZ.zaehler[0]=0) then
                      begin  // 0*a*b --> 0
                        Dispose(Summand^.Arg1); Summand^.Arg1:=nil;
                        TTTermfreigabe(Summand^.Arg2);
                        Summand^.Opera:=001;
                        Summand^.ZahlGRaZ:=GRaZnull;
                        NOCHMAL:=true;
                      end else Summand^.Arg1^.ZahlGRaZ:=GRaZcopy(VorFaktorGRaZ);
                    end else
                    begin  // a*b
                      if not (GNZagleichb(VorfaktorGRaZ.zaehler,VorFaktorGRaZ.nenner) and(not VorFaktorGRaZ.Negativ)) then
                      begin
                        new(ZwSp);
                        ZwSp^:=Summand^;
                        Summand^.Opera:=005;
                        new(Summand^.Arg1);
                        Summand^.Arg1^.Opera:=001;
                        Summand^.Arg1^.ZahlGRaZ:=GRaZcopy(VorFaktorGRaZ);
                        Summand^.Arg2:=ZwSp;
                      end;
                    end; // if Summand.Opera<>005

                    If Fuss^.Opera=004 then Fuss:=Fuss^.Arg2;
                  end; // While Fuss
                end; // Vereinfachung: If Term^.Opera=005

                If NOCHMAL=true then TTVereinfachung(Term);
              end; //004

    005:      begin
                // Rekursion, damit alle Terme sortiert werden:
                Kopf:=Term;
                while Kopf^.Arg2^.Opera=005 do
                begin
                  TTVereinfachung(Kopf^.Arg1);
                  Kopf:=Kopf^.Arg2;
                end;
                TTVereinfachung(Kopf^.Arg1);
                TTVereinfachung(Kopf^.Arg2);

                // Term wird auf eine Form gebracht, mit der der Sortierungsalgorithmus umgehen kann:
                Kopf:=Term;
                while (Kopf^.Arg1^.Opera=005)or(Kopf^.Arg2^.Opera=005) do
                begin
                  while Kopf^.Arg1^.Opera=005 do TTAssoz(Kopf,1);
                  If Kopf^.Arg2^.Opera=005 then Kopf:=Kopf^.Arg2;
                end;

                // Nun wird sortiert:
                AbbruchBed:=false;
                while not AbbruchBed do
                begin
                  Kopf:=Term;
                  AbbruchBed:=true;
                  while Kopf^.Arg2^.Opera=005 do
                  begin
                    If TTakleinerb(Kopf^.Arg2^.Arg1,Kopf^.Arg1) then
                    begin                                                                                     // Vertauschen von Kopf^.Arg1 und Kopf^.Arg2^.Arg1
                      ZwSp:=Kopf^.Arg2^.Arg1;
                      Kopf^.Arg2^.Arg1:=Kopf^.Arg1;
                      Kopf^.Arg1:=ZwSp;
                      ZwSp:=nil;
                      AbbruchBed:=false;
                    end;
                    Kopf:=Kopf^.Arg2;
                  end; //while Kopf
                  If TTakleinerb(Kopf^.Arg2,Kopf^.Arg1) then
                  begin
                    TTkommu(Kopf);
                    AbbruchBed:=false;
                  end;
                end; //while not AbbruchBed

                // NUN WIRD VEREINFACHT:


                IF Term^.Opera=005 then
                If Term^.Arg1^.Opera=001 then                                                                 // Vereinfachungen bzgl. Vorfaktoren Opera=001
                begin
                  AbbruchBed:=false;
                  while (not AbbruchBed)and(Term^.Arg2^.Opera=005) do
                  begin
                    AbbruchBed := Term^.Arg2^.Arg1^.Opera<>001;
                    If not AbbruchBed then
                    begin
                      Term^.Arg1^.ZahlGRaZ:=GRaZmul(Term^.Arg1^.ZahlGRaZ,Term^.Arg2^.Arg1^.ZahlGRaZ);
                      Dispose(Term^.Arg2^.Arg1); Term^.Arg2^.Arg1:=nil;
                      ZwSp:=Term^.Arg2;
                      Term^.Arg2:=Term^.Arg2^.Arg2;
                      Dispose(ZwSp); ZwSp:=nil;
                    end;
                  end; // while
                  If Term^.Arg2^.Opera=001 then
                  begin
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZmul(Term^.Arg1^.ZahlGRaZ,Term^.Arg2^.ZahlGRaZ);
                    Dispose(Term^.Arg1); Term^.Arg1:=nil;
                    Dispose(Term^.Arg2); Term^.Arg2:=nil;
                  end else
                  if (length(Term^.Arg1^.ZahlGRaZ.zaehler)=1)and(Term^.Arg1^.ZahlGRaZ.zaehler[0]=0) then      // Vorfaktor ist 0
                  begin
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZnull;
                    Dispose(Term^.Arg1); Term^.Arg1:=nil;
                    TTTermfreigabe(Term^.Arg2);
                  end else
                  if GNZagleichb(Term^.Arg1^.ZahlGRaZ.zaehler,Term^.Arg1^.ZahlGRaZ.nenner) and (not Term^.Arg1^.ZahlGRaZ.Negativ) then
                  begin                                                                                       // Vorfaktor ist 1
                    ZwSp:=Term;
                    Term:=Term^.Arg2;
                    Dispose(ZwSp^.Arg1); ZwSp^.Arg1:=nil;
                    Dispose(ZwSp); ZwSp:=nil;
                  end;
                end; // Vereinfachung: If Term^.Arg1^.Opera=001

                If Term^.Opera=005 then                                                                       // a*a^5*a^3=a^9
                begin
                  If Term^.Arg1^.Opera<>001 then Fuss:=Term else Fuss:=Term^.Arg2;
                  while Fuss^.Opera=005 do
                  begin
                    Faktor:=Fuss^.Arg1;
                    If Faktor^.Opera=006 then                                                             // Basis,Exponent festlegen
                    begin
                      Basis:=Faktor^.Arg1;
                      Exponent:=Faktor^.Arg2;                                                             // Faktor^.Arg2 lebt absofort in Exponent weiter. D.h. TTTermfreigabe(Exponent) sollte auch Faktor^.Arg2 freigeben.
                    end else
                    begin
                      Basis:=Faktor;
                      new(Exponent);
                      Exponent^.Opera:=001;
                      Exponent^.ZahlGRaZ:=GRaZeins;
                    end;

                    AbbruchBed:=false;
                    while (not AbbruchBed)and(Fuss^.Arg2^.Opera=005) do                                       //Hier wird nach Faktoren gleicher Basis gesucht.
                    begin
                      If Fuss^.Arg2^.Arg1^.Opera=006 then
                      begin
                        If not TTagleichb(Basis,Fuss^.Arg2^.Arg1^.Arg1) then AbbruchBed:=true else
                        begin
                          new(ZwSp);
                          ZwSp^.Opera:=004;                                                                   // Addition des Exponenten
                          ZwSp^.Arg1:=Exponent;
                          ZwSp^.Arg2:=Fuss^.Arg2^.Arg1^.Arg2;
                          Exponent:=ZwSp;

                          ZwSp:=Fuss^.Arg2;                                                                   //Umstrukturierung des Terms
                          Fuss^.Arg2:=Fuss^.Arg2^.Arg2;                                                       //ZwSp^.Arg1^.Arg2 darf nicht freigegeben werden, da im Exponent noch verwendet
                          TTTermfreigabe(ZwSp^.Arg1^.Arg1);
                          Dispose(ZwSp^.Arg1); ZwSp^.Arg1:=nil;
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end else
                      begin
                        If not TTagleichb(Basis,Fuss^.Arg2^.Arg1) then AbbruchBed:=true else
                        begin
                          new(ZwSp);                                                                          //Zum Exponenten 1 hinzuaddieren
                          ZwSp^.Opera:=004;
                          ZwSp^.Arg1:=Exponent;
                          new(ZwSp^.Arg2);
                          ZwSp^.Arg2^.Opera:=001;
                          ZwSp^.Arg2^.ZahlGRaZ:=GRaZeins;
                          Exponent:=ZwSp;

                          ZwSp:=Fuss^.Arg2;
                          Fuss^.Arg2:=Fuss^.Arg2^.Arg2;
                          TTTermfreigabe(ZwSp^.Arg1);
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end; // If Fuss^.Arg2^.Arg1^.Opera=006
                    end; // WHILE (not AbbruchBed)and(Fuss^.Arg2^.Opera=005)

                    If (not AbbruchBed)and(Fuss^.Arg2^.Opera<>005) then
                    begin
                      If Fuss^.Arg2^.Opera=006 then
                      begin
                        If TTagleichb(Basis,Fuss^.Arg2^.Arg1) then
                        begin
                          new(ZwSp);
                          ZwSp^.Opera:=004;                                                                   // Addition des Exponenten
                          ZwSp^.Arg1:=Exponent;
                          ZwSp^.Arg2:=Fuss^.Arg2^.Arg2;
                          Exponent:=ZwSp;

                          TTTermfreigabe(Fuss^.Arg2^.Arg1);
                          Dispose(Fuss^.Arg2);
                          ZwSp:=Fuss^.Arg1;
                          Fuss^:=Fuss^.Arg1^;                                                                 // Hier wird die Position des Faktors verschoben...
                          Faktor:=Fuss;                                                                       // ... und der Zeiger entsprechend angepasst.
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end else
                      begin
                        If TTagleichb(Basis,Fuss^.Arg2) then
                        begin
                          new(ZwSp);                                                                          //Zum Exponenten 1 hinzuaddieren
                          ZwSp^.Opera:=004;
                          ZwSp^.Arg1:=Exponent;
                          new(ZwSp^.Arg2);
                          ZwSp^.Arg2^.Opera:=001;
                          ZwSp^.Arg2^.ZahlGRaZ:=GRaZeins;
                          Exponent:=ZwSp;

                          TTTermfreigabe(Fuss^.Arg2);
                          ZwSp:=Fuss^.Arg1;
                          Fuss^:=Fuss^.Arg1^;                                                                 // Hier wird die Position des Faktors verrückt...
                          Faktor:=Fuss;                                                                       // ... und der zugehörige Zeiger entsprechend angepasst.
                          Dispose(ZwSp); ZwSp:=nil;
                        end;
                      end; // If Fuss^.Arg2^.Opera=006
                    end; // If... Bearbeitung letztes Element

                    TTVereinfachung(Exponent); //Showmessage(TermTypToStr(Faktor));
                    If Faktor^.Opera=006 then
                    begin
                      If Exponent^.Opera<>001 then                                                            // Exponent ist keine rationale Zahl
                      begin
                        Faktor^.Arg2:=Exponent;                                                               // Faktor^.Arg2 lebt in Exponent weiter (siehe oben: Exponent:=Faktor^.Arg2) und muss daher nicht vor dieser Zeile freigegeben werden.
                      end else if GNZagleichb(Exponent^.ZahlGRaZ.zaehler,Exponent^.ZahlGRaZ.nenner) and (not Exponent^.ZahlGRaZ.Negativ) then
                      begin                                                                                   // Exponent ist 1
                        TTTermfreigabe(Exponent);                                                             // Die "Reste" von Faktor^.Arg2 dürften somit ebenfalls freigegeben werden.
                        ZwSp:=Faktor^.Arg1;
                        Faktor^:=Faktor^.Arg1^;
                        Dispose(ZwSp); ZwSp:=nil;
                      end else if (length(Exponent^.ZahlGRaZ.zaehler)=1)and(Exponent^.ZahlGRaZ.zaehler[0]=0) then
                      begin                                                                                   // Exponent = 0
                        Dispose(Exponent); Exponent:=nil;
                        TTTermfreigabe(Faktor^.Arg1);
                        Faktor^.Opera:=001;
                        Faktor^.ZahlGRaZ:=GRaZeins;
                        NOCHMAL := true;                                                                      // Sollte die 1 irgendwo im Term gesetzt werden, wird sie ggf. nicht weiter vereinfacht. D.h. die gesamte Routine muss NOCHMAL aufgerufen werden.
                      end else
                      begin                                                                                   // Exponent ist eine rationale Zahl <>1
                        Faktor^.Arg2:=Exponent;                                                               // Faktor^.Arg2 lebt in Exponent weiter und muss daher nicht freigegeben werden.
                      end;
                    end else
                    begin                                                                                     //Ab hier ist Term^.Arg1^.Opera<>006
                      If Exponent^.Opera<>001 then                                                            //Exponent ist keine rationale Zahl
                      begin
                        If Faktor^.Opera<=002 then                                                            //Ist für Opera<=002 der Fall
                        begin
                          new(Faktor^.Arg1);
                          Faktor^.Arg1^:=Faktor^;
                        end else
                        begin
                          new(ZwSp);
                          ZwSp^:=Faktor^.Arg1^;
                          Faktor^.Arg1^:=Faktor^;
                          Faktor^.Arg1^.Arg1:=ZwSp;
                        end;
                        Faktor^.Opera:=006;
                        Faktor^.Arg2:=Exponent;
                      end else if (length(Exponent^.ZahlGRaZ.zaehler)=1)and(Exponent^.ZahlGRaZ.zaehler[0]=0) then
                      begin   // selbsttest fehlt - wird dieser Bereich überhaupt aufgerufen?
                        If ((Faktor^.Opera>3)and(Faktor^.Opera<7))or((Faktor^.Opera>100)and(Faktor^.Opera<129)) then TTTermfreigabe(Faktor^.Arg1);
                        If ((Faktor^.Opera>3)and(Faktor^.Opera<7)) then TTTermfreigabe(Faktor^.Arg2);         // notwendig?
                        Faktor^.Opera:=001;
                        Faktor^.ZahlGRaZ:=GRaZeins;
                        NOCHMAL:=true;
                      end else if not (GNZagleichb(Exponent^.ZahlGRaZ.zaehler,Exponent^.ZahlGRaZ.nenner) and(not Exponent^.ZahlGRaZ.Negativ)) then
                      begin                                                                                   //Exponent ist eine rationale Zahl <>1
                        If Faktor^.Opera<=2 then
                        begin
                          new(Faktor^.Arg1);
                          Faktor^.Arg1^:=Faktor^;
                        end else
                        begin
                          new(ZwSp);
                          ZwSp^:=Faktor^.Arg1^;
                          Faktor^.Arg1^:=Faktor^;
                          Faktor^.Arg1^.Arg1:=ZwSp;
                        end;
                        Faktor^.Opera:=006;
                        Faktor^.Arg2:=Exponent;
                      end else Dispose(Exponent);                                                             // Exponent=1
                    end; // if Faktor^.Opera=006

                    If Fuss^.Opera=005 then Fuss:=Fuss^.Arg2;
                  end; // While Fuss
                end; // Vereinfachung: If Term^.Opera=005

                If NOCHMAL then TTVereinfachung(Term);
              end; //005
    006:      begin
                TTVereinfachung(Term^.Arg1);
                TTVereinfachung(Term^.Arg2);
                If Term^.Arg1^.Opera=006 then
                begin                                                                                         // (a^b)^c = a^(b*c)
                  new(ZwSp);
                  ZwSp^.Opera:=005;
                  ZwSp^.Arg1:=Term^.Arg1^.Arg2;
                  ZwSp^.Arg2:=Term^.Arg2;
                  TTVereinfachung(ZwSp);
                  Term^.Arg2:=ZwSp;
                  ZwSp:=Term^.Arg1;
                  Term^.Arg1:=Term^.Arg1^.Arg1;
                  Dispose(ZwSp);
                end else if Term^.Arg1^.Opera=001 then
                begin
                  If GNZagleichb(Term^.Arg1^.ZahlGRaZ.zaehler,Term^.Arg1^.ZahlGRaZ.nenner) and(not Term^.Arg1^.ZahlGRaZ.Negativ) then
                  begin  // 1^x = 1
                    Dispose(Term^.Arg1); Term^.Arg1:=nil;
                    TTTermfreigabe(Term^.Arg2);
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZeins;
                  end else if (length(Term^.Arg1^.ZahlGRaZ.zaehler)=1)and(Term^.Arg1^.ZahlGRaZ.zaehler[0]=0) then
                  begin // 0^x = 0, falls x>0
                    if (Term^.Arg2^.Opera=001) then if (not Term^.Arg2^.ZahlGRaZ.Negativ) then
                    begin
                      Dispose(Term^.Arg1); Term^.Arg1:=nil;
                      Dispose(Term^.Arg2); Term^.Arg2:=nil;
                      Term^.Opera:=001;
                      Term^.ZahlGRaZ:=GRaZnull;
                    end else Err:=1;                                                                           // Division durch 0
                  end else if Term^.Arg2^.Opera=001 then if (length(Term^.Arg2^.ZahlGRaZ.nenner)=1)and(Term^.Arg2^.ZahlGRaZ.nenner[0]=1) then
                  begin  // 2^3=8;  2^(-3)=1/8
                    If not Term^.Arg2^.ZahlGRaZ.Negativ then
                    begin
                      Term^.Opera:=001;
                      Term^.ZahlGRaZ.zaehler:=GNZPotenz(Term^.Arg1^.ZahlGRaZ.zaehler,Term^.Arg2^.ZahlGRaZ.zaehler);
                      Term^.ZahlGRaZ.nenner:=GNZPotenz(Term^.Arg1^.ZahlGRaZ.nenner,Term^.Arg2^.ZahlGRaZ.zaehler);
                      Term^.ZahlGRaZ.Negativ:=(not (Term^.Arg2^.ZahlGRaZ.zaehler[0]mod 2=0)) and Term^.Arg1^.ZahlGRaZ.Negativ;
                      Dispose(Term^.Arg1); Term^.Arg1:=nil;
                      Dispose(Term^.Arg2); Term^.Arg2:=nil;
                    end else
                    begin
                      Term^.Opera:=001;
                      Term^.ZahlGRaZ.nenner:=GNZPotenz(Term^.Arg1^.ZahlGRaZ.zaehler,Term^.Arg2^.ZahlGRaZ.zaehler);
                      Term^.ZahlGRaZ.zaehler:=GNZPotenz(Term^.Arg1^.ZahlGRaZ.nenner,Term^.Arg2^.ZahlGRaZ.zaehler);
                      Term^.ZahlGRaZ.Negativ:=(not (Term^.Arg2^.ZahlGRaZ.zaehler[0]mod 2=0)) and Term^.Arg1^.ZahlGRaZ.Negativ;
                      Dispose(Term^.Arg1); Term^.Arg1:=nil;
                      Dispose(Term^.Arg2); Term^.Arg2:=nil;
                    end;
                  end else                                                                                     // Der Nenner des Exponenten ist wegen obiger Abfragen > 1 --> Es handelt sich um einer Wurzel.
                  begin // Teilweises Wurzelziehen, neg. Vorzeichen in Exp
                    If Term^.Arg2^.ZahlGRaZ.Negativ then
                    begin // Zaehler und Nenner der potenzierten GRaZ werden vertauscht.
                      Term^.Arg2^.ZahlGRaZ.Negativ:=false;
                      ZwSpGNZ:=Term^.Arg1^.ZahlGRaZ.Zaehler;
                      Term^.Arg1^.ZahlGRaZ.Zaehler:=Term^.Arg1^.ZahlGRaZ.Nenner;
                      Term^.Arg1^.ZahlGRaZ.Nenner:=ZwSpGNZ;
                    end;
                    If not Term^.Arg1^.ZahlGRaZ.Negativ then TTWurzelTeilwZiehen(Term);                        // Teilweises Wurzelziehen - nicht, wenn Wurzel aus neg. Zahl
                    If Term^.Opera=006 then                                                                    // Denn: Durch das Teilweise Wurzelziehen kann es sein, dass keine Potenz, sondern ein Produkt vorliegt. In diesem Fall muss TTVereinfachung erneut aufgerufen werden.
                    begin
                      if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,1) then
                      begin // (1/5)^(1/2) --> 5^(-1/2) bzw. (1/5)^(-1/2) --> 5^(1/2)
                        ZwSpGNZ:=Term^.Arg1^.ZahlGRaZ.Zaehler;
                        Term^.Arg1^.ZahlGRaZ.Zaehler:=Term^.Arg1^.ZahlGRaZ.Nenner;
                        Term^.Arg1^.ZahlGRaZ.Nenner:=ZwSpGNZ;
                        Term^.Arg2^.ZahlGRaZ.Negativ:= not Term^.Arg2^.ZahlGRaZ.Negativ;
                      end;
                    end else TTVereinfachung(Term);                                                            // In diesem Fall wurde die Wurzel teilw. gezogen. Bsp.: (1/24)^(1/3) --> 1/2*(1/3)^(1/3) --> 1/2*3^(-1/3)
                  end;  // if-Bedingungen an Term^.Arg2
                // Nachfolgend: end von if Term^.Opera=001
                end else if (Term^.Arg1^.Opera=002)and(Term^.Arg2^.Opera=005) then if (Term^.Arg1^.Varname='_e') and (Term^.Arg2^.Arg2^.Opera=101) then
                begin  // _e^(n*ln(x))=x^n  --> Term^.Opera bleibt 006.
                  Dispose(Term^.Arg1); Term^.Arg1:=nil;
                  Term^.Arg1:=Term^.Arg2^.Arg2^.Arg1;                                                          // x^; Pointer wird kopiert
                  Dispose(Term^.Arg2^.Arg2); Term^.Arg2^.Arg2:=nil;
                  ZwSp:=Term^.Arg2;                                                                            // Damit beim Überschreiben keine Speicherleiche entsteht.
                  Term^.Arg2:=Term^.Arg2^.Arg1;                                                                // x^n; Pointer wird kopiert
                  Dispose(ZwSp);
                  TTVereinfachung(Term);                                                                       // bsp. _e^(1*ln(x)) --> x^1 --> x
                end;
                If Term^.Opera=006 then if (Term^.Arg1^.Opera=002)and(Term^.Arg2^.Opera=101) then if Term^.Arg1^.Varname='_e' then
                begin // _e^ln(x) = x
                  ZwSp:=Term;
                  Term:=Term^.Arg2^.Arg1;
                  Dispose(ZwSp^.Arg1); ZwSp^.Arg1:=nil;
                  Dispose(ZwSp^.Arg2); ZwSp^.Arg2:=nil;
                  Dispose(ZwSp); ZwSp:=nil;
                end; // Term^.Opera=006 and Term^.Arg1^.Opera=002
                If Term^.Opera=006 then if Term^.Arg2^.Opera=001 then
                begin
                  If GNZagleichb(Term^.Arg2^.ZahlGRaZ.zaehler,Term^.Arg2^.ZahlGRaZ.nenner) and(not Term^.Arg2^.ZahlGRaZ.Negativ) then
                  begin  // a^1=a
                    ZwSp:=Term;                                                                                // Hinweis: Der Pointer Term ändert sich bei dieser Methode des "Aufrückens".
                    Term:=Term^.Arg1;
                    Dispose(ZwSp^.Arg2); ZwSp^.Arg2:=nil;
                    Dispose(ZwSp); ZwSp:=nil;
                  end else if (length(Term^.Arg2^.ZahlGRaZ.zaehler)=1)and(Term^.Arg2^.ZahlGRaZ.zaehler[0]=0) then
                  begin  // a^0=1, wenn a<>0; der Fall 5^0 wird oben schon abgehandelt.
                    Dispose(Term^.Arg2); Term^.Arg2:=nil;
                    TTTermfreigabe(Term^.Arg1);
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZeins;
                  end else if (Term^.Arg1^.Opera=005) and (GNZagleichb(Term^.Arg2^.ZahlGRaZ.Nenner,1)) then
                  begin // (a*b)^2 = a^2*b^2
                    Term^.Opera:=005;
                    Exponent:=Term^.Arg2;
                    new(ZwSp);
                    ZwSp^.Opera:=006;
                    ZwSp^.Arg1:=Term^.Arg1^.Arg2;                                                              // b, 2. Faktor
                    ZwSp^.Arg2:=Exponent;                                                                      // ACHTUNG: Pointer wird direkt übergeben...
                    Term^.Arg2:=ZwSp;                                                                          // ... daher entsteht hier kein Speicher-Leck
                    new(ZwSp);
                    ZwSp^.Opera:=006;
                    ZwSp^.Arg1:=Term^.Arg1^.Arg1;                                                              // a, 1. Faktor
                    ZwSp^.Arg2:=TTKopieVon(Exponent);                                                          // Da oben Pointer bereits weitergegeben wurde.
                    Dispose(Term^.Arg1);                                                                       // Term^.Arg1 und Term^.Arg2 wurden bereits gesichert, daher reicht ein Dispose.
                    Term^.Arg1:=ZwSp;
                    If not (Term^.Arg1^.Opera=002) then TTVereinfachung(Term^.Arg1);
                    If not (Term^.Arg2^.Opera=002) then TTVereinfachung(Term^.Arg2);
                  end;
                end; // if Term^.Arg2^.Opera=001
              end; // 006
    101:      begin  // ln
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.zaehler,Term^.Arg1^.ZahlGRaZ.nenner) then
                begin // ln(1)=0
                    Dispose(Term^.Arg1); Term^.Arg1:=nil;
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZnull;
                end; // Term^.Arg1^.Opera=001
                If Term^.Opera=101 then if Term^.Arg1^.Opera=002 then if Term^.Arg1^.Varname='_e' then
                begin  // ln(_e)=1
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                  Dispose(Term^.Arg1); Term^.Arg1:=nil;
                end; // Term^.Arg1^.Opera=002
                If Term^.Opera=101 then if Term^.Arg1^.Opera=006 then
                begin // ln(x^n)=n*ln(x)
                  Term^.Arg1^.Opera:=101;
                  Term^.Opera:=005;
                  Term^.Arg2:=Term^.Arg1^.Arg2;
                  Term^.Arg1^.Arg2:=nil;
                  TTVereinfachung(Term);
                end; // If Term^.Arg1^.Opera=006
              end; //101
 // 102:  Entfällt, da exp(x) durch _e^x ersetzt wurde
    103:      begin  // sin
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // sin(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=103 then if Term^.Arg1^.Opera=002 then if Term^.Arg1^.VarName='_pi' then
                begin  // sin(Pi)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=103 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg2^.Opera=002)and(Term^.Arg1^.Arg2^.Konstante=true) then if Term^.Arg1^.Arg2^.VarName='_pi' then
                begin // sin(n*pi)=0, sin(n/2*pi)=+-1
                  If GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,1) then
                  begin
                    TTTermFreigabe(Term^.Arg1);
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZnull;
                  end else if GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,2) then
                  begin
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZeins;
                    // Vorzeichen festlegen: 1, wenn Vorfaktor=1/2+2*k; -1 wenn Vorfaktor -1/2+2*k mit k=0, +-1, +-2, ...
                    VorfaktorGRaZ:=WordToGRaZTyp(1,2,false);                                                     // Aus Optimierungsgründen wird VorfaktorGRaZ als Zwischenspeicher ausgenutzt.
                    VorfaktorGRaZ:=GRaZadd(VorfaktorGRaZ,Term^.Arg1^.Arg1^.ZahlGRaZ);
                    If GNZIstGerade(VorfaktorGRaZ.Zaehler) then Term^.ZahlGRaZ.Negativ:=true;                    // VorFaktorGRaz.Nenner=1
                    TTTermFreigabe(Term^.Arg1);                                                                  // Freigabe erst hier, da vorher noch drauf zugegriffen wird.
                  end;
                end; // If Term^.Arg1^.Opera=103 then if then if then
                If Term^.Opera=103 then TTTrigoSymVereinfachung(Term,true);                                       // sin(-5)=-sin(5), sin(-x)=-sin(x)
              end; // 103 sin
    104:      begin // cos
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // cos(0)=1
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                end;
                If Term^.Opera=104 then if Term^.Arg1^.Opera=002 then if Term^.Arg1^.VarName='_pi' then
                begin  // cos(Pi)=-1
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                                       // (-1)
                end;
                If Term^.Opera=104 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg2^.Opera=002)and(Term^.Arg1^.Arg2^.Konstante=true) then if Term^.Arg1^.Arg2^.VarName='_pi' then
                begin // cos(n*pi)=+-1, cos(n/2*pi)=0
                  If GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,1) then
                  begin
                    Term^.Opera:=001;
                    If GNZIstGerade(Term^.Arg1^.Arg1^.ZahlGRaZ.Zaehler) then Term^.ZahlGRaZ:=GRaZeins else Term^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
                    TTTermFreigabe(Term^.Arg1);                                                                  // Freigabe erst hier, da vorher noch drauf zugegriffen wird.
                  end else if GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,2) then
                  begin
                    TTTermFreigabe(Term^.Arg1);
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZnull;
                  end;
                end; // If Term^.Arg1^.Opera=104 then if then if then
                If Term^.Opera=104 then TTTrigoSymVereinfachung(Term,false);  // cos(-5)=cos(5), cos(-x)=cos(x)
              end; // 104 cos
    105:      begin // tan
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // tan(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=105 then if Term^.Arg1^.Opera=002 then if Term^.Arg1^.VarName='_pi' then
                begin  // tan(Pi)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=105 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg2^.Opera=002)and(Term^.Arg1^.Arg2^.Konstante=true) then if Term^.Arg1^.Arg2^.VarName='_pi' then
                begin // tan(n*pi)=0, tan((n+1/4)*pi)=+1, tan((n-1/4)*pi)=-1, tan((n+1/2)*pi) kann nicht weiter vereinfacht werden.
                  If GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,1) then
                  begin
                    TTTermFreigabe(Term^.Arg1);
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZnull;
                  end else if GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,4) then
                  begin
                    // Vorzeichen festlegen: 1, wenn Vorfaktor=1/4+k; -1 wenn Vorfaktor -1/4+k mit k=0, +-1, +-2, ...
                    VorfaktorGRaZ:=WordToGRaZTyp(1,4,false);                                                     // Aus Optimierungsgründen wird VorfaktorGRaZ als Zwischenspeicher ausgenutzt.
                    VorfaktorGRaZ:=GRaZadd(VorfaktorGRaZ,Term^.Arg1^.Arg1^.ZahlGRaZ);
                    If not GNZagleichb(VorfaktorGRaZ.Nenner,4) then
                    begin
                      TTTermFreigabe(Term^.Arg1);
                      Term^.Opera:=001;
                      Term^.ZahlGRaZ:=GRaZeins;
                      If GNZagleichb(VorfaktorGRaZ.Nenner,1) then Term^.ZahlGRaZ.Negativ:=true else if GNZagleichb(VorfaktorGRaZ.Nenner,2) then Term^.ZahlGRaZ.Negativ:=false;
                    end; // sonst wird nichts vereinfacht.
                  end;
                end; // If Term^.Arg1^.Opera=105 then if then if then
                If Term^.Opera=105 then TTTrigoSymVereinfachung(Term,true);                                      // tan(-5)=-tan(5), tan(-x)=-tan(x)
              end; // 106 tan
    106:      begin // cot
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=106 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg2^.Opera=002)and(Term^.Arg1^.Arg2^.Konstante=true) then if Term^.Arg1^.Arg2^.VarName='_pi' then
                begin // cot((n+1/2)*pi)=0, cot((n+1/4)*pi)=+1, cot((n-1/4)*pi)=-1
                  If GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,2) then
                  begin
                    TTTermFreigabe(Term^.Arg1);
                    Term^.Opera:=001;
                    Term^.ZahlGRaZ:=GRaZnull;
                  end else if GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,4) then
                  begin
                    // Vorzeichen festlegen: 1, wenn Vorfaktor=1/4+k; -1 wenn Vorfaktor=-1/4+k mit k=0, +-1, +-2, ...
                    VorfaktorGRaZ:=WordToGRaZTyp(1,4,false);                                                     // Aus Optimierungsgründen wird VorfaktorGRaZ als Zwischenspeicher ausgenutzt.
                    VorfaktorGRaZ:=GRaZadd(VorfaktorGRaZ,Term^.Arg1^.Arg1^.ZahlGRaZ);
                    If not GNZagleichb(VorfaktorGRaZ.Nenner,4) then
                    begin
                      TTTermFreigabe(Term^.Arg1);
                      Term^.Opera:=001;
                      Term^.ZahlGRaZ:=GRaZeins;
                      If GNZagleichb(VorfaktorGRaZ.Nenner,1) then Term^.ZahlGRaZ.Negativ:=true else if GNZagleichb(VorfaktorGRaZ.Nenner,2) then Term^.ZahlGRaZ.Negativ:=false;
                    end; // sonst wird nichts vereinfacht.
                  end;
                end; // If Term^.Arg1^.Opera=106 then if then if then
                If Term^.Opera=106 then TTTrigoSymVereinfachung(Term,true);                                    // cot(-5)=-cot(5), cot(-x)=-cot(x)
              end; // 107 cot
    107:      begin // sec
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // sec(0)=1
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                end;
                If Term^.Opera=107 then if Term^.Arg1^.Opera=002 then if Term^.Arg1^.VarName='_pi' then
                begin  // sec(Pi)=-1
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                                                      // (-1)
                end;
                If Term^.Opera=107 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg2^.Opera=002)and(Term^.Arg1^.Arg2^.Konstante=true) then
                   if Term^.Arg1^.Arg2^.VarName='_pi' then if GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,1) then
                begin // sec(2*n*pi)=1, sec((2*n+1)*pi)=-1
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                  If not GNZIstGerade(Term^.Arg1^.Arg1^.ZahlGRaZ.Zaehler) then Term^.ZahlGRaZ.Negativ:=true;
                  TTTermFreigabe(Term^.Arg1);
                end; // If Term^.Arg1^.Opera=107 then if then if then
                If Term^.Opera=107 then TTTrigoSymVereinfachung(Term,false);  // sec(-5)=sec(5), sec(-x) = sec(x)
              end; // 107 sec
    108:      begin // csc
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=108 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg2^.Opera=002)and(Term^.Arg1^.Arg2^.Konstante=true) then
                   if Term^.Arg1^.Arg2^.VarName='_pi' then if GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner,2) then
                begin  // csc((2*n+1)/2*pi)=+/-1 (vgl Graph von csc)
                  VorFaktorGRaZ:=WordToGRaZTyp(1,2,false);
                  VorFaktorGRaZ:=GRaZadd(VorFaktorGRaZ,Term^.Arg1^.Arg1^.ZahlGRaZ);
                  TTTermFreigabe(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                  If GNZIstGerade(VorFaktorGRaZ.Zaehler) then Term^.ZahlGRaZ.Negativ:=true;
                end; // If Term^.Arg1^.Opera=108 then if then if then
                If Term^.Opera=108 then TTTrigoSymVereinfachung(Term,true);                                   // csc(-5)=-csc(5), csc(-x)=-csc(x)
              end; // 108 csc
    109:      begin // abs
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // abs(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end else
                begin  // abs(-5)=5
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=Term^.Arg1^.ZahlGRaZ;
                  Term^.ZahlGRaZ.Negativ:=false;
                  TTTermFreigabe(Term^.Arg1);
                end;
                If Term^.Opera=109 then if Term^.Arg1^.Opera=005 then if Term^.Arg1^.Arg1^.Opera=001 then
                begin  // abs(5*x)=5*abs(x), abs(-5*x)=5*abs(x)
                  new(ZwSp);
                  ZwSp^.Opera:=005;
                  ZwSp^.Arg1:=Term^.Arg1^.Arg1;
                  ZwSp^.Arg1^.ZahlGRaZ.Negativ:=false;                                                         // (-5) --> 5
                  new(ZwSp^.Arg2);
                  ZwSp^.Arg2^.Opera:=109;
                  ZwSp^.Arg2^.Arg1:=Term^.Arg1^.Arg2;                                                          // Term^.Arg1^.Arg2=x
                  Dispose(Term^.Arg1);                                                                         // Zeiger Term^.Arg1^.Arg1 und ^.Arg2 wurden vorher an ZwSp übergeben und müssen nicht freigegeben werden.
                  Dispose(Term);
                  Term:=ZwSp;
                end;
              end; // 109 abs
    110:      begin // sign
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then
                begin
                  Term^.Opera:=001;
                  If GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then Term^.ZahlGRaZ:=GRaZnull else
                  begin
                    Term^.ZahlGRaZ:=GRaZeins;
                    Term^.ZahlGRaZ.Negativ:=Term^.Arg1^.ZahlGRaZ.Negativ;
                  end;
                  TTTermFreigabe(Term^.Arg1);
                end;
              end; // 110 sign
    111:      begin // sinh
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=111 then if Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // sinh(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=111 then TTTrigoSymVereinfachung(Term,true);                                    // sinh(-5)=-sinh(5), sinh(-x)=-sinh(x)
              end; // 111 sinh
    112:      begin // cosh
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=112 then if Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // cosh(0)=1
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                end;
                If Term^.Opera=112 then TTTrigoSymVereinfachung(Term,false);                                   // cosh(-x)=cosh(x)
              end; // 112 cosh
    113:      begin // tanh
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=113 then if Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // tanh(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=113 then TTTrigoSymVereinfachung(Term,true);                                    // tanh(-5)=-tanh(5), tanh(-x)=-tanh(x)
              end; // 113 tanh
    114:      begin // coth
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=114 then TTTrigoSymVereinfachung(Term,true);                                    // coth(-5)=-coth(5), coth(-x)=-coth(x)
              end; // 114 coth
    115:      begin // sech
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin  // sech(0)=1
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZeins;
                end else Term^.Arg1^.ZahlGRaZ.Negativ:=false;                                                  // Negatives Vorzeichen in Klammer wird immer eliminiert.
                If Term^.Opera=115 then TTTrigoSymVereinfachung(Term,false);                                   // sech(-x)=sech(x)
              end; // 115 sech
    116:      begin // csch
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=116 then TTTrigoSymVereinfachung(Term,true);                                    // csch(-5)=-csch(5), csch(-x)=-csch(x)
              end; // 116 csch
    117:      begin // arcsin
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin // arcsin(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end else if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then
                begin // arcsin(+-1)=+-Pi/2
                  VorfaktorGRaZ:=WordToGRaZTyp(1,2,Term^.Arg1^.ZahlGRaZ.Negativ);                              // VorfaktorGRaZ wird hier als Zahlen-Zwischenspeicher missbraucht.
                  Dispose(Term^.Arg1);
                  Term^.Opera:=005;
                  new(Term^.Arg1);
                  Term^.Arg1^.Opera:=001;
                  Term^.Arg1^.ZahlGRaZ:=VorfaktorGRaZ;
                  new(Term^.Arg2);
                  Term^.Arg2^.Opera:=002;
                  Term^.Arg2^.Varname:='_pi';
                  Term^.Arg2^.Konstante:=true;
                end;
                If Term^.Opera=117 then TTTrigoSymVereinfachung(Term,true);                                    // arcsin(-5)=-arcsin(5), arcsin(-x)=-arcsin(x)
              end; // 117 arcsin
    118:      begin // arccos
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin // arccos(0)=pi/2
                  Dispose(Term^.Arg1);
                  Term^.Opera:=005;
                  new(Term^.Arg1);
                  Term^.Arg1^.Opera:=001;
                  Term^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,2,false);
                  new(Term^.Arg2);
                  Term^.Arg2^.Opera:=002;
                  Term^.Arg2^.Varname:='_pi';
                  Term^.Arg2^.Konstante:=true;
                end else if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then if not Term^.Arg1^.ZahlGRaZ.Negativ then
                begin // arccos(1)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end else
                begin // arccos(-1)=Pi
                  Dispose(Term^.Arg1);
                  Term^.Opera:=002;
                  Term^.Varname:='_pi';
                  Term^.Konstante:=true;
                end;
                If Term^.Opera=118 then if Term^.Arg1^.Opera=001 then if Term^.Arg1^.ZahlGRaZ.Negativ then
                begin  // arccos(-5)=_pi+(-1)*arccos(5)
                  new(ZwSp);
                  ZwSp^.Opera:=004;
                  new(ZwSp^.Arg1);
                  ZwSp^.Arg1^.Opera:=002;
                  ZwSp^.Arg1^.Varname:='_pi';
                  ZwSp^.Arg1^.Konstante:=true;
                  new(ZwSp^.Arg2);
                  ZwSp^.Arg2^.Opera:=005;
                  new(ZwSp^.Arg2^.Arg1);
                  ZwSp^.Arg2^.Arg1^.Opera:=001;
                  ZwSp^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                         // (-1)
                  ZwSp^.Arg2^.Arg2:=Term;
                  ZwSp^.Arg2^.Arg2^.Arg1^.ZahlGRaZ.Negativ:=false;
                  Term:=ZwSp;
                end;
                If Term^.Opera=118 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg1^.ZahlGRaZ.Negativ=true) then
                begin  // arccos(-x)=_pi+(-1)*arccos(x)
                  new(ZwSp);
                  ZwSp^.Opera:=004;
                  new(ZwSp^.Arg1);
                  ZwSp^.Arg1^.Opera:=002;
                  ZwSp^.Arg1^.Varname:='_pi';
                  ZwSp^.Arg1^.Konstante:=true;
                  new(ZwSp^.Arg2);
                  ZwSp^.Arg2^.Opera:=005;
                  new(ZwSp^.Arg2^.Arg1);
                  ZwSp^.Arg2^.Arg1^.Opera:=001;
                  ZwSp^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                         // (-1)
                  ZwSp^.Arg2^.Arg2:=Term;
                  If not GNZagleichb(ZwSp^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Zaehler,ZwSp^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Nenner) then ZwSp^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Negativ:=false else  // then...: sin(-2*x)=-sin(2*x)
                  begin  // Faktor -1 in Klammer fällt weg
                    Faktor:=ZwSp^.Arg2^.Arg2^.Arg1^.Arg2;                                                            // Faktor:=x
                    Dispose(ZwSp^.Arg2^.Arg2^.Arg1^.Arg1);                                                           // Dispose(-1)
                    Dispose(ZwSp^.Arg2^.Arg2^.Arg1);                                                                 // Dispose(*)
                    ZwSp^.Arg2^.Arg2^.Arg1:=Faktor;
                  end;
                  Term:=ZwSp;
                end;
              end; // 118 arccos
    119:      begin // arctan
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin // arctan(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end else if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then
                begin // arctan(+-1)=+-Pi/4
                  VorfaktorGRaZ:=WordToGRaZTyp(1,4,Term^.Arg1^.ZahlGRaZ.Negativ);                              // VorfaktorGRaZ wird hier als Zahlen-Zwischenspeicher missbraucht.
                  Dispose(Term^.Arg1);
                  Term^.Opera:=005;
                  new(Term^.Arg1);
                  Term^.Arg1^.Opera:=001;
                  Term^.Arg1^.ZahlGRaZ:=VorfaktorGRaZ;
                  new(Term^.Arg2);
                  Term^.Arg2^.Opera:=002;
                  Term^.Arg2^.Varname:='_pi';
                  Term^.Arg2^.Konstante:=true;
                end;
                If Term^.Opera=119 then TTTrigoSymVereinfachung(Term,true);                                    // arctan(-5)=-arctan(5), arctan(-x)=-arctan(x)
              end; // 119 arctan
    120:      begin // arccot
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin // arccot(0)=Pi/2
                  Dispose(Term^.Arg1);
                  Term^.Opera:=005;
                  new(Term^.Arg1);
                  Term^.Arg1^.Opera:=001;
                  Term^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,2,false);
                  new(Term^.Arg2);
                  Term^.Arg2^.Opera:=002;
                  Term^.Arg2^.Varname:='_pi';
                  Term^.Arg2^.Konstante:=true;
                end else if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then
                begin // arccot(+1)=Pi/4; arccot(-1)=-1/4*Pi
                  If not Term^.Arg1^.ZahlGRaZ.Negativ then VorfaktorGRaZ:=WordToGRaZTyp(1,4,false) else VorfaktorGRaZ:=WordToGRaZTyp(1,4,true);
                  Dispose(Term^.Arg1);
                  Term^.Opera:=005;
                  new(Term^.Arg1);
                  Term^.Arg1^.Opera:=001;
                  Term^.Arg1^.ZahlGRaZ:=VorfaktorGRaZ;
                  new(Term^.Arg2);
                  Term^.Arg2^.Opera:=002;
                  Term^.Arg2^.Varname:='_pi';
                  Term^.Arg2^.Konstante:=true;
                end;
                If Term^.Opera=120 then TTTrigoSymVereinfachung(Term,true);                                    // arccot(-5)=-arccot(5), arccot(-x)=-arccot(x)
              end; // 120 arccot
    121:      begin // arcsec
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then if not Term^.Arg1^.ZahlGRaZ.Negativ then
                begin // arcsec(1)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end else
                begin // arcsec(-1)=Pi
                  Dispose(Term^.Arg1);
                  Term^.Opera:=002;
                  Term^.Varname:='_pi';
                  Term^.Konstante:=true;
                end;
                If Term^.Opera=121 then if Term^.Arg1^.Opera=001 then if Term^.Arg1^.ZahlGRaZ.Negativ then
                begin  // arcsec(-5)=_pi+(-1)*arcsec(5)
                  new(ZwSp);
                  ZwSp^.Opera:=004;
                  new(ZwSp^.Arg1);
                  ZwSp^.Arg1^.Opera:=002;
                  ZwSp^.Arg1^.Varname:='_pi';
                  ZwSp^.Arg1^.Konstante:=true;
                  new(ZwSp^.Arg2);
                  ZwSp^.Arg2^.Opera:=005;
                  new(ZwSp^.Arg2^.Arg1);
                  ZwSp^.Arg2^.Arg1^.Opera:=001;
                  ZwSp^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                         // (-1)
                  ZwSp^.Arg2^.Arg2:=Term;
                  ZwSp^.Arg2^.Arg2^.Arg1^.ZahlGRaZ.Negativ:=false;
                  Term:=ZwSp;
                end;
                If Term^.Opera=121 then if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg1^.ZahlGRaZ.Negativ=true) then
                begin  // arcsec(-x)=_pi+(-1)*arcsec(x)
                  new(ZwSp);
                  ZwSp^.Opera:=004;
                  new(ZwSp^.Arg1);
                  ZwSp^.Arg1^.Opera:=002;
                  ZwSp^.Arg1^.Varname:='_pi';
                  ZwSp^.Arg1^.Konstante:=true;
                  new(ZwSp^.Arg2);
                  ZwSp^.Arg2^.Opera:=005;
                  new(ZwSp^.Arg2^.Arg1);
                  ZwSp^.Arg2^.Arg1^.Opera:=001;
                  ZwSp^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                         // (-1)
                  ZwSp^.Arg2^.Arg2:=Term;
                  If not GNZagleichb(ZwSp^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Zaehler,ZwSp^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Nenner) then ZwSp^.Arg2^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Negativ:=false else  // then...: sin(-2*x)=-sin(2*x)
                  begin  // Faktor -1 im Argument fällt weg.
                    Faktor:=ZwSp^.Arg2^.Arg2^.Arg1^.Arg2;                                                            // Faktor:=x
                    Dispose(ZwSp^.Arg2^.Arg2^.Arg1^.Arg1);                                                           // Dispose(-1)
                    Dispose(ZwSp^.Arg2^.Arg2^.Arg1);                                                                 // Dispose(*)
                    ZwSp^.Arg2^.Arg2^.Arg1:=Faktor;
                  end;
                  Term:=ZwSp;
                end;
              end; // 121 arcsec
    122:      begin // arccsc
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then
                begin // arccsc(+-1)=+-Pi/2
                  VorfaktorGRaZ:=WordToGRaZTyp(1,2,Term^.Arg1^.ZahlGRaZ.Negativ);                              // VorfaktorGRaZ wird hier als Zahlen-Zwischenspeicher missbraucht.
                  Dispose(Term^.Arg1);
                  Term^.Opera:=005;
                  new(Term^.Arg1);
                  Term^.Arg1^.Opera:=001;
                  Term^.Arg1^.ZahlGRaZ:=VorfaktorGRaZ;
                  new(Term^.Arg2);
                  Term^.Arg2^.Opera:=002;
                  Term^.Arg2^.Varname:='_pi';
                  Term^.Arg2^.Konstante:=true;
                end;
                If Term^.Opera=122 then TTTrigoSymVereinfachung(Term,true);                                    // arccsc(-5)=-arccsc(5), arccsc(-x)=-arccsc(x)
              end; // 122 arccsc
    123:      begin // arsinh
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin // arsinh(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=123 then TTTrigoSymVereinfachung(Term,true);                                    // arsinh(-5)=-arsinh(5), arsinh(-x)=-arsinh(x)
              end; // 123 arsinh
    124:      begin // arcosh
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.ZahlGRaZ.Nenner) then if not Term^.Arg1^.ZahlGRaZ.Negativ then
                begin // arcosh(1)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
              end; // 124 arcosh
    125:      begin // artanh
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=001 then if GNZagleichb(Term^.Arg1^.ZahlGRaZ.Zaehler,0) then
                begin // artanh(0)=0
                  Dispose(Term^.Arg1);
                  Term^.Opera:=001;
                  Term^.ZahlGRaZ:=GRaZnull;
                end;
                If Term^.Opera=125 then TTTrigoSymVereinfachung(Term,true);                                    // artanh(-5)=-artanh(5), artanh(-x)=-artanh(x)
              end; // 125 artanh
    126:      begin  // arcoth
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=005 then TTTrigoSymVereinfachung(Term,false);                             // arcoth(-5)=arcoth(5), arcoth(-5*x)=arcoth(5*x)
              end;  // 126 arcoth
    127:      begin  // arsech
                TTVereinfachung(Term^.Arg1);
                If Term^.Arg1^.Opera=005 then TTTrigoSymVereinfachung(Term,false);                             // arsech(-5)=arsech(5), arsech(-5*x)=arsech(5*x)
              end;  // 127 arsech
    128:      begin  // arcsch
                TTVereinfachung(Term^.Arg1);
                If Term^.Opera=128 then TTTrigoSymVereinfachung(Term,true);                                    // arcsch(-5)=-arcsch(5), arcsch(-x)=-arcsch(x)
              end;  // 128 arcsch
  end; //case
end; // TTVereinfachung


procedure tAnalyse.TTTrigoSymVereinfachung(var Term:PTermTyp; punktsymmetrisch:boolean);
var ZwSp, Faktor:PTermTyp;
begin
  If punktsymmetrisch then
  begin
    If Term^.Arg1^.Opera=001 then
    begin
      if Term^.Arg1^.ZahlGRaZ.Negativ then
      begin  // sin(-5)=-sin(5)
        new(ZwSp);
        ZwSp^.Opera:=005;
        new(ZwSp^.Arg1);
        ZwSp^.Arg1^.Opera:=001;
        ZwSp^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                               // (-1)
        ZwSp^.Arg2:=Term;
        ZwSp^.Arg2^.Arg1^.ZahlGRaZ.Negativ:=false;
        Term:=ZwSp;
      end;
    end else if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg1^.ZahlGRaZ.Negativ=true) then
    begin  // sin(-x)=-sin(x)
      new(ZwSp);
      ZwSp^.Opera:=005;
      new(ZwSp^.Arg1);
      ZwSp^.Arg1^.Opera:=001;
      ZwSp^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                               // (-1)
      ZwSp^.Arg2:=Term;
      If not GNZagleichb(ZwSp^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Zaehler,ZwSp^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Nenner) then ZwSp^.Arg2^.Arg1^.Arg1^.ZahlGRaZ.Negativ:=false else  // then...: sin(-2*x)=-sin(2*x)
      begin  // sin(-1*x)=-sin(x), d.h. Faktor 1 fällt weg.
        Faktor:=ZwSp^.Arg2^.Arg1^.Arg2;                                                            // Faktor:=x
        Dispose(ZwSp^.Arg2^.Arg1^.Arg1);                                                           // Dispose(-1)
        Dispose(ZwSp^.Arg2^.Arg1);                                                                 // Dispose(*)
        ZwSp^.Arg2^.Arg1:=Faktor;
      end;
      Term:=ZwSp;
    end;
  end else
  begin
    If Term^.Arg1^.Opera=001 then Term^.Arg1^.ZahlGRaZ.Negativ:=false else if Term^.Arg1^.Opera=005 then if (Term^.Arg1^.Arg1^.Opera=001)and(Term^.Arg1^.Arg1^.ZahlGRaZ.Negativ=true) then
    begin
      If not GNZagleichb(Term^.Arg1^.Arg1^.ZahlGRaZ.Zaehler,Term^.Arg1^.Arg1^.ZahlGRaZ.Nenner) then Term^.Arg1^.Arg1^.ZahlGRaZ.Negativ:=false else  // then...: cos(-2*x)=cos(2*x)
      begin  // cos(-1*x)=cos(x), d.h. Faktor 1 fällt weg.
        Faktor:=Term^.Arg1^.Arg2;                                                            // Faktor:=x
        Dispose(Term^.Arg1^.Arg1);                                                           // Dispose(-1)
        Dispose(Term^.Arg1);                                                                 // Dispose(*)
        Term^.Arg1:=Faktor;
      end;
    end;
  end; // If symmetrisch then else
end;  // TTTrigoSymVereinfachung


procedure tAnalyse.TTWurzelTeilwZiehen(var Term:PTermTyp);    // Es wird davon ausgegangen, dass Term^.Opera=006, Term^.Arg1^.Opera=001 und Term^.Arg2^.Opera=001 sind.
var ZwSpGNZ: GNZTyp;
    Vorfaktor, Radikant, Exponent: GRaZTyp;
    PrimFaktZaehler, PrimFaktNenner, Laeufer, Faktor: PTermTyp;
begin
  Vorfaktor:=GRaZeins;
  Radikant:=GRaZeins;
  Exponent:=Term^.Arg2^.ZahlGRaZ;
  If GNZakleinerb(1,Term^.Arg1^.ZahlGRaZ.Zaehler) then
  begin  // Teilweises Wurzelziehen Zaehler:
    PrimFaktZaehler:=GNZPrimFaktZerl(Term^.Arg1^.ZahlGRaZ.Zaehler);
    Laeufer:=PrimFaktZaehler;
    repeat
      If Laeufer^.Opera=005 then
      begin
        Faktor:=Laeufer^.Arg1;                                                                                   // Faktor^.Opera=006 oder 001
        Laeufer:=Laeufer^.Arg2;
      end else Faktor:=Laeufer;
      If Faktor^.Opera=001 then Radikant.Zaehler:=GNZmul(Radikant.Zaehler,Faktor^.ZahlGRaZ.Zaehler) else
      begin
        ZwSpGNZ:=GNZdiv(Faktor^.Arg2^.ZahlGRaZ.Zaehler,Exponent.Nenner);
        If not GNZagleichb(ZwSpGNZ,0) then
        begin
          Vorfaktor.Zaehler:= GNZmul(Vorfaktor.Zaehler,GNZPotenz(Faktor^.Arg1^.ZahlGRaZ.Zaehler,GNZmul(ZwSpGNZ,Exponent.Zaehler)));
          ZwSpGNZ:=GNZmod(Faktor^.Arg2^.ZahlGRaZ.Zaehler,Exponent.Nenner);
          If GNZakleinerb(0,ZwSpGNZ) then Radikant.Zaehler := GNZmul(Radikant.Zaehler,GNZPotenz(Faktor^.Arg1^.ZahlGRaZ.Zaehler,ZwSpGNZ));
        end else Radikant.Zaehler:=GNZmul(Radikant.Zaehler,GNZPotenz(Faktor^.Arg1^.ZahlGRaZ.Zaehler,Faktor^.Arg2^.ZahlGRaZ.Zaehler));
      end; // If Faktor^.Opera=001 else
    until Faktor=Laeufer;
    TTTermFreigabe(PrimFaktZaehler);
  end else Radikant.Zaehler:=Term^.Arg1^.ZahlGRaZ.Zaehler;  // if GNZakleinerb(1,Term^.Arg1^.ZahlGRaZ.Zaehler) else

  If GNZakleinerb(1,Term^.Arg1^.ZahlGRaZ.Nenner) then
  begin  // Teilweises Wurzelziehen Nenner:
    PrimFaktNenner :=GNZPrimFaktZerl(Term^.Arg1^.ZahlGRaZ.Nenner);
    Laeufer:=PrimFaktNenner;
    repeat
      If Laeufer^.Opera=005 then
      begin
        Faktor:=Laeufer^.Arg1;                                                                                   // Faktor^.Opera=006 oder 001
        Laeufer:=Laeufer^.Arg2;
      end else Faktor:=Laeufer;
      If Faktor^.Opera=001 then Radikant.Nenner:=GNZmul(Radikant.Nenner,Faktor^.ZahlGRaZ.Zaehler) else           // Hinweis: Bei den Faktoren ist nur Zaehler besetzt, da es sich um eine PrimFaktZerl des Radikantennenners handelt. Kann verwirren.
      begin
        ZwSpGNZ:=GNZdiv(Faktor^.Arg2^.ZahlGRaZ.Zaehler,Exponent.Nenner);
        If not GNZagleichb(ZwSpGNZ,0) then
        begin
          Vorfaktor.Nenner:= GNZmul(Vorfaktor.Nenner,GNZPotenz(Faktor^.Arg1^.ZahlGRaZ.Zaehler,GNZmul(ZwSpGNZ,Exponent.Zaehler)));
          ZwSpGNZ:=GNZmod(Faktor^.Arg2^.ZahlGRaZ.Zaehler,Exponent.Nenner);
          If GNZakleinerb(0,ZwSpGNZ) then Radikant.Nenner:= GNZmul(Radikant.Nenner,GNZPotenz(Faktor^.Arg1^.ZahlGRaZ.Zaehler,ZwSpGNZ));
        end else Radikant.Nenner:=GNZmul(Radikant.Nenner,GNZPotenz(Faktor^.Arg1^.ZahlGRaZ.Zaehler,Faktor^.Arg2^.ZahlGRaZ.Zaehler));
      end; // If Faktor^.Opera=001 else
    until Faktor=Laeufer;
    TTTermFreigabe(PrimFaktNenner);
  end else Radikant.Nenner:=Term^.Arg1^.ZahlGRaZ.Nenner;  // if GNZakleinerb(1,Term^.Arg1^.ZahlGRaZ.Nenner) else
  // Aufbau des Terms:
  If (GNZagleichb(Radikant.Zaehler,1))and(GNZagleichb(Radikant.Nenner,1)) then
  begin // Radikant ist 1 - Wurzel fällt weg
    Dispose(Term^.Arg1);
    Dispose(Term^.Arg2);
    Term^.Opera:=001;
    Term^.ZahlGRaZ:=Vorfaktor;
  end else if not GraZagleichb(Vorfaktor,GraZeins) then
  begin
    Term^.Arg1^.ZahlGRaZ:=Radikant;
    new(Laeufer);                                                                                                // Laeufer wird hier als ZwSp missbraucht.
    Laeufer^.Opera:=005;
    new(Laeufer^.Arg1);
    Laeufer^.Arg1^.Opera:=001;
    Laeufer^.Arg1^.ZahlGRaZ:=Vorfaktor;
    Laeufer^.Arg2:=Term;
    Term:=Laeufer;
  end; // If Radikant=1 else
end; // TTWurzelTeilwZiehen


function tAnalyse.TTakleinerb(a,b:PTermTyp):boolean;  // TTakleinerb kann nur innerhalb TTVereinfachung oder bei einem bereits sortierten Term verwendet werden --> Setzt entsprechende Anordnung der Argumente aus TTVereinfachung voraus
var laenge,n: dword;
    ZwSp: PTermTyp;
begin
                                                                                                               // Im Folgenden: Ordnungsebenen (1., 2., 3., u.s.w.)
  If a^.opera<>b^.opera then                                                                                   // 1. Sortierung nach Operationsnummer
  begin
    If (a^.opera=006)and(b^.Opera<>006) then if b^.Opera=001 then RESULT:=false else                           // Denn es ist a<a^2<b
    begin
      If TTagleichb(a^.Arg1,b) then
      begin // a^.Arg1=b   Bsp.: Es ist x^(-2)<x<x^3
        new(ZwSp);
        ZwSp.Opera:=001;                                                                                       // 001=Zahl
        ZwSp^.ZahlGRaZ.zaehler:=GNZeins;
        ZwSp^.ZahlGRaZ.nenner:= GNZeins;
        ZwSp^.ZahlGRaZ.Negativ:=false;
        RESULT:=TTakleinerb(a^.Arg2,ZwSp);
        Dispose(ZwSp);
      end else
      begin // a^.Arg1<>b  Bsp.: (a=x^2 und b=2*x^3) oder (a=x^2 und b=w) oder (a=x^2 und b=a*x^3)
        If b^.Opera<>005 then RESULT:=TTakleinerb(a^.Arg1,b) else if b^.Arg1^.Opera=001 then RESULT:=TTakleinerb(a,b^.Arg2)
         else RESULT:=TTakleinerb(a^.Arg1,b);
      end;
    end else if (a^.opera<>006)and(b^.Opera=006) then if a^.Opera=001 then RESULT:=true else
    begin // Spiegelsymmetrisch zu "if (a^.opera=006)and(b^.Opera<>006)" oben.
      If TTagleichb(a,b^.Arg1) then
      begin // a=b^.Arg1
        new(ZwSp);
        ZwSp.Opera:=001;                                                                                       // 001=Zahl
        ZwSp^.ZahlGRaZ.zaehler:=GNZeins;
        ZwSp^.ZahlGRaZ.nenner:= GNZeins;
        ZwSp^.ZahlGRaZ.Negativ:=false;
        RESULT:=TTakleinerb(ZwSp,b^.Arg2);
        Dispose(ZwSp);
      end else
      begin // a<>b^.Arg1
        If a^.Opera<>005 then RESULT:=TTakleinerb(a,b^.Arg1) else if a^.Arg1^.Opera=001 then RESULT:=TTakleinerb(a^.Arg2,b)
         else RESULT:=TTakleinerb(a,b^.Arg1);
      end;
    end else if (a^.Opera=005)and(b^.Opera<>005) then
    begin                                                                                                      // Denn es ist b<2*b<c
      If (TTagleichb(a^.Arg2,b))and(a^.Arg1^.Opera=001) then RESULT:=GNZakleinerb(a^.Arg1^.ZahlGRaZ.zaehler,a^.Arg1^.ZahlGRaZ.nenner)  // Bsp.: Es ist 1/3*x<x<2*x
       else if not (a^.Arg1^.Opera=001) then RESULT:= a^.Opera<b^.Opera                                        // Ist RESULT hier nicht immer FALSE?
       else RESULT:=TTakleinerb(a^.Arg2,b);
    end else if (a^.Opera<>005)and(b^.Opera=005) then
    begin // analog zu "If (TTagleichb(a^.Arg2,b))and(a^.Arg1^.Opera=001)" oben
      If (TTagleichb(a,b^.Arg2))and(b^.Arg1^.Opera=001) then RESULT:=GNZakleinerb(b^.Arg1^.ZahlGRaZ.NENNER,b^.Arg1^.ZahlGRaZ.ZAEHLER) or GNZagleichb(b^.Arg1^.ZahlGRaZ.zaehler,b^.Arg1^.ZahlGRaZ.nenner)
       else if not (b^.Arg1^.Opera=001) then RESULT:= a^.Opera<b^.Opera
       else RESULT:=TTakleinerb(a,b^.Arg2);
    end else RESULT:= a^.Opera<b^.Opera;
  end else
  CASE a^.Opera OF                                                                                            // Falls Opera gleich groß ist.
    001:      begin
                RESULT:=GRaZakleinerb(a^.ZahlGRaZ,b^.ZahlGRaZ);                                               // 2. Sortierung nach Größe der Zahl
              end; //001
    002:      begin  // Alphabetische Sortierung von Variablennamen
                laenge:=length(a^.Varname);                                                                   // 2. Sortierung nach Variablennamen
                if laenge<length(b^.Varname) then laenge:=length(b^.Varname);
                n:=0;
                repeat
                  inc(n);
                until (n=laenge)or(ord(a^.Varname[n])<>ord(b^.Varname[n]));
                RESULT:=ord(a^.Varname[n])<ord(b^.Varname[n]);
              end; //002
    004:      begin  // Wird z.B. bei (a+d)*(a+b) --> (a+b)*(a+d) gebraucht und setzt voraus, dass die Summanden bereits sortiert sind.
                if TTakleinerb(a^.Arg1,b^.Arg1) then RESULT:= true                                          // 3. Sortierung nach dem 1. Argument
                else if TTakleinerb(b^.Arg1,a^.Arg1) then RESULT:= false
                else RESULT:= TTakleinerb(a^.Arg2,b^.Arg2);                                               // 4. Sortierung nach dem 2. Argument
              end; //004
    005:      begin
                If (a^.Arg1^.Opera=001)and(b^.Arg1^.Opera=001) then
                begin
                  if TTakleinerb(a^.Arg2,b^.Arg2) then RESULT:= true
                  else if TTakleinerb(b^.Arg2,a^.Arg2) then RESULT:= false
                  else RESULT:= TTakleinerb(a^.Arg1,b^.Arg1);
                end else
                if (a^.Arg1^.Opera=001)and(b^.Arg1^.Opera<>001) then
                begin
                  if TTakleinerb(a^.Arg2,b) then RESULT:= true
                  else if TTakleinerb(b,a^.Arg2) then RESULT:= false
                  else RESULT:=GNZakleinerb(a^.Arg1^.ZahlGRaZ.zaehler,a^.Arg1^.ZahlGRaZ.nenner)or(a^.Arg1^.ZahlGRaZ.Negativ);   // Bsp.: -2*x<1/2*x<x<3*x
                end else
                if (a^.Arg1^.Opera<>001)and(b^.Arg1^.Opera=001) then
                begin
                  if TTakleinerb(a,b^.Arg2) then RESULT:= true
                  else if TTakleinerb(b^.Arg2,a) then RESULT:= false
                  else RESULT:= (GNZakleinerb(b^.Arg1^.ZahlGRaZ.nenner,b^.Arg1^.ZahlGRaZ.zaehler))and(not a^.Arg1^.ZahlGRaZ.Negativ);
                end else
                begin // wie bei CASE Opera OF 004
                  if TTakleinerb(a^.Arg1,b^.Arg1) then RESULT:= true
                  else if TTakleinerb(b^.Arg1,a^.Arg1) then RESULT:= false
                  else RESULT:= TTakleinerb(a^.Arg2,b^.Arg2);                                                 // 4. Sortierung nach dem 2. Argument
                end;
              end; //005
    006:      begin
                If TTakleinerb(a^.Arg1,b^.Arg1) then RESULT:=true                                             // 2. Sortierung nach Basis
                else if TTakleinerb(b^.Arg1,a^.Arg1) then RESULT:=false
                else RESULT:= TTakleinerb(a^.Arg2,b^.Arg2);                                                   // 3. Sortierung nach Exponent
              end;
    101..128: begin
                RESULT:= TTakleinerb(a^.Arg1,b^.Arg1);
              end; // 101..128
  ENd; //case
end; // TTakleinerb


function TAnalyse.TTagleichb(a,b:PTermTyp):boolean;
begin
  Result:= a^.Opera=b^.Opera;
  If (Result=true)and(a^.Opera=001) then Result:=GRaZagleichb(a^.ZahlGRaZ,b^.ZahlGRaZ);
  If (Result=true)and(a^.Opera=002) then Result:= a^.Varname=b^.Varname;
  If (Result=true)and((a^.Opera>=004)and(a^.Opera<=006)) then Result:=(TTagleichb(a^.Arg1,b^.Arg1))and(TTagleichb(a^.Arg2,b^.Arg2));
  If (Result=true)and((a^.Opera>=101)and(a^.Opera<=128)) then Result:=TTagleichb(a^.Arg1,b^.Arg1);
end;  // TTagleichb


procedure tAnalyse.TTEntwicklung(var Term:PTermTyp);
var ZwSpPTT, Laeufer: PTermTyp;
    N,K: dword;
    PotenzNegativ:boolean;
begin
  CASE Term^.Opera OF
    004:      begin
                TTEntwicklung(Term^.Arg1);
                TTEntwicklung(Term^.Arg2);
              end; //004
    005:      begin
                // Ausmultiplizieren nach den Distributivgesetzen:
                TTEntwicklung(Term^.Arg1);
                TTEntwicklung(Term^.Arg2);
                If Term^.Arg1^.Opera=004 then
                begin
                  TTdistri(Term,1);
                  TTEntwicklung(Term^.Arg1);                                                                  // Beschleunigung möglich: Obige 004-Abfrage mit while iterativ gestalten. Diese Rekursion wäre dann nicht mehr nötig.
                  TTEntwicklung(Term^.Arg2);
                end else
                if Term^.Arg2^.Opera=004 then
                begin
                  TTdistri(Term,2);
                  TTEntwicklung(Term^.Arg1);                                                                  // Beschleunigung möglich: Obige 004-Abfrage mit while iterativ gestalten. Diese Rekursion wäre dann nicht mehr nötig.
                  TTEntwicklung(Term^.Arg2);
                end;
              end; // 005
    006:      begin
                If (Term^.Arg1^.Opera=004)and((Term^.Arg2^.Opera=001)and((length(Term^.Arg2^.ZahlGRaZ.nenner)=1)and(Term^.Arg2^.ZahlGRaZ.nenner[0]=1))) then
                begin
                  If Term^.Arg2^.ZahlGRaZ.Negativ then
                  begin  // (a+b)^(-2) wird zunächst wie (a+b)^2 ausmultipliziert. Weiter unten dann wird ^(-1) gesetzt: (a^2+b^2+2*a*b)^(-1)
                    PotenzNegativ:=true;
                    Term^.Arg2^.ZahlGRaZ.Negativ:=false;
                  end else PotenzNegativ:=false;
                  If length(Term^.Arg2^.ZahlGRaZ.Zaehler)>1 then
                  begin                                                                                     // (a+b)^5 = (a+b)*(a+b)^4 für sehr große Potenzen; Nicht im Konsolen-Selbsttest enthalten.
                    Term^.Arg2^.ZahlGRaZ.zaehler:=GNZSub(Term^.Arg2^.ZahlGRaZ.zaehler,GNZeins);
                    new(ZwSpPTT);
                    ZwSpPTT^.Opera:=005;                                                                    // 005=Multiplikation
                    ZwSpPTT^.Arg1:=TTKopieVon(Term^.Arg1^.Arg1);
                    ZwSpPTT^.Arg2:=Term;
                    Term:=ZwSpPTT;
                    TTEntwicklung(Term);
                  end else
                  begin // Binomialentwicklung: (a+b)^N = Summe(K=0 bis N) (N über K) * a^(N-K) * b^K
                    TTEntwicklung(Term^.Arg1);                                                              // Damit in Term^.Arg1 alles ausmultipliziert ist.
                    N := Term^.Arg2^.ZahlGRaZ.Zaehler[0];                                                   // Wegen Zaehler[0] ist obige length-Unterscheidung notwendig.
                    new(ZwSpPTT);                                                                           // In ZwSpPTT wird die Summe zwischengespeichert.
                    ZwSpPTT^.Opera:=004;
                    new(ZwSpPTT^.Arg1);                                                                     // 1. Summand: K=0 --> a^N
                    ZwSpPTT^.Arg1^.Opera:=006;
                    ZwSpPTT^.Arg1^.Arg1:=TTKopieVon(Term^.Arg1^.Arg1);
                    new(ZwSpPTT^.Arg1^.Arg2);
                    ZwSpPTT^.Arg1^.Arg2^.Opera:=001;
                    ZwSpPTT^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(N,1,false);
                    If ZwSpPTT^.Arg1^.Arg1^.Opera=004 then TTEntwicklung(ZwSpPTT^.Arg1);                    // Rekursion, s.u.
                    Laeufer:=ZwSpPTT;
                    for K:=1 to N-1 do
                    begin
                      new(Laeufer^.Arg2);
                      Laeufer:=Laeufer^.Arg2;
                      Laeufer^.Opera:=004;

                      new(Laeufer^.Arg1);                                                                   // Laeufer^.Arg1 := (N über K) * a^(N-K) * b^K
                      Laeufer^.Arg1^.Opera:=005;
                      new(Laeufer^.Arg1^.Arg1);
                      Laeufer^.Arg1^.Arg1^.Opera:=001;
                      Laeufer^.Arg1^.Arg1^.ZahlGRaZ.Zaehler:= GNZNueberK(N,K);                              // (N über K)
                      Laeufer^.Arg1^.Arg1^.ZahlGRaZ.Nenner := GNZeins;
                      Laeufer^.Arg1^.Arg1^.ZahlGRaZ.Negativ:= false;
                      new(Laeufer^.Arg1^.Arg2);
                      Laeufer^.Arg1^.Arg2^.Opera:=005;
                      new(Laeufer^.Arg1^.Arg2^.Arg1);
                      Laeufer^.Arg1^.Arg2^.Arg1^.Opera:=006;                                                // a^(N-K)
                      Laeufer^.Arg1^.Arg2^.Arg1^.Arg1:= TTKopieVon(Term^.Arg1^.Arg1);                       // a
                      new(Laeufer^.Arg1^.Arg2^.Arg1^.Arg2);
                      Laeufer^.Arg1^.Arg2^.Arg1^.Arg2^.Opera:=001;
                      Laeufer^.Arg1^.Arg2^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(N-K,1,false);                // +(N-K)/1
                      new(Laeufer^.Arg1^.Arg2^.Arg2);
                      Laeufer^.Arg1^.Arg2^.Arg2^.Opera:=006;                                                // b^K
                      Laeufer^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Term^.Arg1^.Arg2);
                      new(Laeufer^.Arg1^.Arg2^.Arg2^.Arg2);
                      Laeufer^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
                      Laeufer^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(K,1,false);                  // K

                      If Laeufer^.Arg1^.Arg2^.Arg1^.Arg1^.Opera=004 then TTEntwicklung(Laeufer^.Arg1);      // Rekursion
                      If Laeufer^.Arg1^.Arg2^.Arg2^.Arg1^.Opera=004 then TTEntwicklung(Laeufer^.Arg1);      // Rekursion (bsp.: (a+(b+c))^n)
                    end; // for
                    new(Laeufer^.Arg2);
                    Laeufer^.Arg2^.Opera:=006;                                                              // N. Summand: K=N --> b^N
                    Laeufer^.Arg2^.Arg1:=TTKopieVon(Term^.Arg1^.Arg2);
                    new(Laeufer^.Arg2^.Arg2);
                    Laeufer^.Arg2^.Arg2^.Opera:=001;
                    Laeufer^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(N,1,false);
                    If Laeufer^.Arg2^.Arg1^.Opera=004 then TTEntwicklung(Laeufer^.Arg2);
                    TTTermFreigabe(Term);
                    Term:=ZwSpPTT;
                  end; // If Term^.Arg2.ZahlGRaZ.Zaehler=1 else if else
                  If PotenzNegativ then
                  begin  // vgl. oben: Wenn Potenz ursprünglich negativ war, wird hier a^2+b^2+2*a*b zu (a^2+b^2+2*a*b)^(-1)
                    new(ZwSpPTT);
                    ZwSpPTT^:=Term^;
                    Term^.Opera:=006;
                    Term^.Arg1:=ZwSpPTT;
                    new(Term^.Arg2);
                    Term^.Arg2^.Opera:=001;
                    Term^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                          // (-1)
                  end;
                end else
                if Term^.Arg1^.Opera=005 then
                begin // Umwandlung: (a*(b*c))^(1/3) = a^(1/3)*(b*c)^(1/3)                                  // TTVereinfachung unterstützt nur den Fall ganzzahliger Exponenten, d.h. (a*(b*c))^3 = a^(1/3)*(b*c)^3
                  new(ZwSpPTT);
                  ZwSpPTT^.Opera:=005;                                                                      // 005 = Multiplikation

                  new(ZwSpPTT^.Arg1);
                  ZwSpPTT^.Arg1^.Opera:=006;                                                                // 006 = Hoch
                  ZwSpPTT^.Arg1^.Arg2:=Term^.Arg2;
                  ZwSpPTT^.Arg1^.Arg1:=Term^.Arg1^.Arg1;

                  new(ZwSpPTT^.Arg2);
                  ZwSpPTT^.Arg2^.Opera:=006;                                                                // 006 = Hoch
                  ZwSpPTT^.Arg2^.Arg2:=TTKopieVon(Term^.Arg2);                                              // Da ZwSpPTT^.Arg1^.Arg2 bereits auf Term^.Arg2 zeigt
                  ZwSpPTT^.Arg2^.Arg1:=Term^.Arg1^.Arg2;

                  Dispose(Term^.Arg1);                                                                      // Freigabe nicht mehr benötigten Speichers
                  Dispose(Term);
                  Term:=ZwSpPTT;
                  TTEntwicklung(Term);
                end else
                begin
                  TTEntwicklung(Term^.Arg1);
                  TTEntwicklung(Term^.Arg2);
                end; // sonst
              end; // 006
    101..128: begin
                TTEntwicklung(Term^.Arg1);
              end; //101..128
  END; //case
end; // TTEntwicklung


procedure tAnalyse.TTEinzelklammernAufloesen(var Term:PTermTyp);
begin
  CASE Term^.Opera OF
    004:      begin
                TTEinzelklammernAufloesen(Term^.Arg1);
                TTEinzelklammernAufloesen(Term^.Arg2);
              end; //004
    005:      begin
                // Ausmultiplizieren nach den Distributivgesetzen:
                TTEinzelklammernAufloesen(Term^.Arg1);
                TTEinzelklammernAufloesen(Term^.Arg2);
                If Term^.Arg1^.Opera=004 then
                begin
                  TTdistri(Term,1);
                  TTEinzelklammernAufloesen(Term^.Arg1);                                                                  // Beschleunigung möglich: Obige 004-Abfrage mit while iterativ gestalten. Diese Rekursion wäre dann nicht mehr nötig.
                  TTEinzelklammernAufloesen(Term^.Arg2);
                end else
                if Term^.Arg2^.Opera=004 then
                begin
                  TTdistri(Term,2);
                  TTEinzelklammernAufloesen(Term^.Arg1);                                                                  // Beschleunigung möglich: Obige 004-Abfrage mit while iterativ gestalten. Diese Rekursion wäre dann nicht mehr nötig.
                  TTEinzelklammernAufloesen(Term^.Arg2);
                end;
              end; // 005
    006:      begin
                TTEinzelklammernAufloesen(Term^.Arg1);
                TTEinzelklammernAufloesen(Term^.Arg2);
              end; // 006
    101..128: begin
                TTEinzelklammernAufloesen(Term^.Arg1);
              end; //101..128
  END; //case
end; // TTEinzelklammernAufloesen

function tAnalyse.TTLoeseGleichung(LinkeSeite, RechteSeite, Unbekannte:PTermTyp):PTermTypArray;
var NormalForm, ZwSpPTT:PTermTyp;
    SummandForm, LoesungsKandidaten:PTermTypArray;
    n, LoesAnz: dword;
    RechteSeiteIstNull:boolean;
begin
  // NORMALFORM: Zunaechst muss die Gleichung auf Normalform gebracht werden. D.h. keine Variable im Nenner und rechte Seite = 0
  // Schritt 1: Die rechte Seite von der Gleichung abziehen --> rechte Seite wird 0, neue Linke Seite wird in NormalForm gespeichert.
  //            NormalForm := LinkeSeite + (-1*(RechteSeite))
  LoesAnz:=0;
  RechteSeiteIstNull:=false;
  If RechteSeite^.Opera=001 then if GNZagleichb(RechteSeite^.ZahlGRaZ.Zaehler,0) then RechteSeiteIstNull:=true;
  If RechteSeiteIstNull then
  begin
    NormalForm:=TTKopieVon(LinkeSeite);
  end else
  begin
    new(NormalForm);
    NormalForm^.Opera:=004;
    NormalForm^.Arg1:=TTKopieVon(LinkeSeite);
    new(NormalForm^.Arg2);
    NormalForm^.Arg2^.Opera:=005;
    new(NormalForm^.Arg2^.Arg1);
    NormalForm^.Arg2^.Arg1^.Opera:=001;
    NormalForm^.Arg2^.Arg1^.ZahlGRaZ:=GRaZeins;
    NormalForm^.Arg2^.Arg1^.ZahlGRaZ.Negativ:=true;
    NormalForm^.Arg2^.Arg2:=TTKopieVon(RechteSeite);
  end; // If RechteSeiteIstNull

  // Schritt 2: Prüfen, ob der Term bereits in faktorisierter Forum vorliegt  <<-- Später. Hinweis: Mit Vereinfachung kann ein Term vereinfacht werden, ohne dass ausmultipliziert wird.
  If NormalForm^.Opera=005 then
  begin
  end;

  // Schritt 3: Umwandlung in SummandForm - d.h. die Summanden der NormalForm werden in ein Array abgespalten. Dieses Array erleichtert den Umgang mit dem Term erheblich.
  SummandForm:=TTTermToSummandForm(NormalForm);

  // Schritt 4: Für Bruchgleichungen: Unbekannte aus Nenner rausmultiplizieren.
  TTBruchEntferner(SummandForm, Unbekannte);

  // Schritt 5: Potenzlöser zum lösen von allen Gleichungen, die auf Plynomgleichungen zurückgeführt werden können.

  LoesungsKandidaten:=TTPotenzLoeser(SummandForm, Unbekannte);
  for n:=0 to length(SummandForm)-1 do TTTermfreigabe(SummandForm[n]);

  // LÖSUNG DURCH EINSETZEN PRÜFEN
  If length(Loesungskandidaten)>0 then
  begin
    for n:=0 to length(LoesungsKandidaten) -1 do
    begin
      TTEntwicklung(LoesungsKandidaten[n]);
      TTVereinfachung(LoesungsKandidaten[n]);
      If LoesungsKandidaten[n]^.Opera=001 then
      begin // Die Zahl in NormalForm eingesetzt muss 0 ergeben - nur dann löst die Lösung die Gleichung.
        ZwSpPTT:=UnbekannteErsetzen(NormalForm,Unbekannte,LoesungsKandidaten[n]);
        TTVereinfachung(ZwSpPTT);
        If (Err<>0)or(ZwSpPTT^.Opera<>001) then
        begin
          TTTermFreigabe(LoesungsKandidaten[n]);
          Err:=0;
        end else if not GNZagleichb(ZwSpPTT^.ZahlGRaZ.Zaehler,0) then TTTermFreigabe(LoesungsKandidaten[n]) else
        begin
          inc(LoesAnz);
          setlength(RESULT,LoesAnz);
          RESULT[LoesAnz-1]:=LoesungsKandidaten[n];
        end;
        TTTermFreigabe(ZwSpPTT);
      end else if TTKeineVariableEnthalten(LoesungsKandidaten[n]) then
      begin  // Bsp: sqrt(x)-x=-4 hat 9/2+1/2*sqrt(17) als Lösung, nicht jedoch 9/2-1/2*sqrt(17). Durch Einsetzen werden falsche Lösungen rausgefiltert.
        ZwSpPTT:=UnbekannteErsetzen(NormalForm,Unbekannte,LoesungsKandidaten[n]);
        Dezimalisierung(ZwSpPTT);                                                                 // Da KeineVariableEnthalten müsste ZwSpPTT jetzt eine Zahl sein.
        If Err<>0 then
        begin                                                                                     // z.B.: WURZEL AUS NEGATIVER ZAHL wird hier rausgefiltert.
          TTTermFreigabe(LoesungsKandidaten[n]);
          Err:=0;
        end else if abs(ZwSpPTT^.GlKoZa)<0.00000000001 then                                       // Streng genommen ein bisschen unsauber. Bessere Lösung durch genauere Analyse der Wurzelgleichungen mit hohem Programmieraufwand möglich.
        begin
          inc(LoesAnz);
          setlength(RESULT,LoesAnz);
          RESULT[LoesAnz-1]:=LoesungsKandidaten[n];
        end else TTTermFreigabe(LoesungsKandidaten[n]);
        TTTermFreigabe(ZwSpPTT);
      end else
      begin
        inc(LoesAnz);
        setlength(RESULT,LoesAnz);
        RESULT[LoesAnz-1]:=LoesungsKandidaten[n];
      end; // If LoesungsKandidaten[n]^.Opera=1 else if TTKeineVariableEnthalten else
    end; // for
  end else RESULT:=nil;

  TTTermfreigabe(NormalForm);
end;  // TTLoeseGleichung


function tAnalyse.TTTermToSummandForm(var Term:PTermTyp):PTermTypArray;
var Kopf: PTermTyp;
    SummandAnz: dword;
begin
  TTEntwicklung(Term);                                                                                      // Denn der Term könnte störende Produkte enthalten
  TTVereinfachung(Term);

  SummandAnz:=0;
  Kopf:=Term;
  while Kopf^.Opera=004 do
  begin
    inc(SummandAnz);
    setlength(RESULT,SummandAnz);
    RESULT[SummandAnz-1]:=TTKopieVon(Kopf^.Arg1);
    Kopf:=Kopf^.Arg2;
  end;
  inc(SummandAnz);
  setlength(RESULT,SummandAnz);
  RESULT[SummandAnz-1]:=TTKopieVon(Kopf);
end; // TTTermToSummandForm


procedure tAnalyse.TTBruchEntferner(var SummandForm:PTermTypArray; Unbekannte:PTermTyp);
var Kopf, ZwSpPTT, NennerBasis, NennerExponent: PTermTyp;
    n, n2, SummandAnz: dword;
    NennerWarVorhanden:boolean;
begin
  NennerWarVorhanden:=false;
  SummandAnz:=length(SummandForm);
  for n:=0 to SummandAnz-1 do
  begin
    Kopf:=SummandForm[n];
    while Kopf^.Opera=005 do
    begin
      If Kopf^.Arg1^.Opera=006 then if Kopf^.Arg1^.Arg2^.Opera=001 then if Kopf^.Arg1^.Arg2^.ZahlGRaZ.Negativ=true then if TTUnbekannteEnthalten(Kopf^.Arg1^.Arg1, Unbekannte) then
      begin
        NennerBasis:=Kopf^.Arg1^.Arg1;                                                                   // Hier kein TTKopieVon, da der NennerBasis folgend aus dem Term entfernt wird...
        NennerExponent:=Kopf^.Arg1^.Arg2;                                                                // bla*x^(-3) --> NennerExponent=-3; hier: NennerBasis = x^3
        NennerExponent^.ZahlGRaZ.Negativ:=false;                                                         // --> NennerExponent = 3; bereitet Multiplikation der übrigen Summanden mit diesem NennerBasis vor.
        Dispose(Kopf^.Arg1);                                                                             // Nun wird der Faktor mit neg. Exp aus dem Summanden Eliminiert.
        ZwSpPTT:=Kopf^.Arg2;
        Kopf^:=Kopf^.Arg2^;
        Dispose(ZwSpPTT);
        for n2:=0 to SummandAnz-1 do if n2 <> n then                                                     // Nun wird jeder andere Summand mit der NennerBasis & zugehörigem positiven Exponenten multipliziert.
        begin
          new(ZwSpPTT);
          ZwSpPTT^.Opera:=005;
          new(ZwSpPTT^.Arg1);
          ZwSpPTT^.Arg1^.Opera:=006;
          ZwSpPTT^.Arg1^.Arg1:=TTKopieVon(NennerBasis);
          ZwSpPTT^.Arg1^.Arg2:=TTKopieVon(NennerExponent);
          ZwSpPTT^.Arg2:=SummandForm[n2];
          SummandForm[n2]:=ZwSpPTT;
          ZwSpPTT:=nil;
        end; // for n2
        TTTermFreigabe(NennerBasis);
        TTTermFreigabe(NennerExponent);
        NennerWarVorhanden:=true;                                                                        // Für Rekursion, siehe unten.
      end;
      If Kopf^.Opera=005 then Kopf:=Kopf^.Arg2;
    end; // while
    If Kopf^.Opera=006 then if Kopf^.Arg2^.Opera=001 then if Kopf^.Arg2^.ZahlGRaZ.Negativ=true then if TTUnbekannteEnthalten(Kopf^.Arg1, Unbekannte) then
    begin
      NennerBasis:=Kopf^.Arg1;
      NennerExponent:=Kopf^.Arg2;
      NennerExponent^.ZahlGRaZ.Negativ:=false;
      Kopf^.Opera:=001;                                                                                  // In diesem Fall kann der Faktor nicht einfach gelöscht werden, sondern muss durch 1 ersetzt werden, da Kopf ja auf einen der Summanden zeigt.
      Kopf^.Arg1:=nil; Kopf^.Arg2:=nil;
      Kopf^.ZahlGRaZ:=GRaZeins;
      for n2:=0 to SummandAnz-1 do if n2 <> n then                                                       // Nun wird jeder andere Summand mit dem NennerBasis & zugehörigem positiven Exponenten multipliziert.
      begin
        new(ZwSpPTT);
        ZwSpPTT^.Opera:=005;
        new(ZwSpPTT^.Arg1);
        ZwSpPTT^.Arg1^.Opera:=006;
        ZwSpPTT^.Arg1^.Arg1:=TTKopieVon(NennerBasis);
        ZwSpPTT^.Arg1^.Arg2:=TTKopieVon(NennerExponent);
        ZwSpPTT^.Arg2:=SummandForm[n2];
        SummandForm[n2]:=ZwSpPTT;
        ZwSpPTT:=nil;
      end; // for n2
      TTTermFreigabe(NennerBasis);
      TTTermFreigabe(NennerExponent);
      NennerWarVorhanden:=true;                                                                          // Für Rekursion, siehe unten
    end;
  end; // for n

  If NennerWarVorhanden then
  begin
    n:=0;
    while n<SummandAnz do
    begin
      TTEntwicklung(SummandForm[n]);
      while SummandForm[n]^.Opera=004 do
      begin
        inc(SummandAnz);
        setlength(SummandForm,SummandAnz);
        SummandForm[SummandAnz-1]:=SummandForm[n]^.Arg1;                                                 // SummandForm[n]^.Arg1^.Opera kann auch 004 sein, daher wird die äußere Schleife mit SummandAnz auf das Array samt neuer Elemente erweitert.
        ZwSpPTT:=SummandForm[n];
        SummandForm[n]:=SummandForm[n]^.Arg2;
        Dispose(ZwSpPTT);
      end; // while SummandAnz
      TTVereinfachung(SummandForm[n]);
      inc(n);
    end; // while n

    TTBruchEntferner(SummandForm,Unbekannte);                                                            // Rekursion für z.B. den Fall 1/(1+1/x)) --> TTBruchEntferner muss 2-mal angewendet werden.
  end;
end; // TTBruchEntferner


function  tAnalyse.TTUnbekannteEnthalten(Term,Unbekannte:PTermTyp):boolean;
begin
  RESULT:= TTagleichb(Term,Unbekannte);
  If RESULT=false then
  begin
    If (Term^.Opera>=4)and(Term^.Opera<=6) then
    begin
      RESULT:=TTUnbekannteEnthalten(Term^.Arg1, Unbekannte);
      If RESULT=false then RESULT:=TTUnbekannteEnthalten(Term^.Arg2, Unbekannte);
    end else if (Term^.Opera>=101)and(Term^.Opera<=128) then RESULT:=TTUnbekannteEnthalten(Term^.Arg1, Unbekannte);
  end;
end; // TTUnbekannteEnthalten


function tAnalyse.TTKeineVariableEnthalten(Term:PTermTyp):boolean;
begin
  RESULT:= not (Term^.Opera=002);
  If RESULT=true then
  begin
    If (Term^.Opera>=4)and(Term^.Opera<=6) then
    begin
      RESULT:=TTKeineVariableEnthalten(Term^.Arg1);
      If RESULT=true then RESULT:=TTKeineVariableEnthalten(Term^.Arg2);
    end else if (Term^.Opera>=101)and(Term^.Opera<=128) then RESULT:=TTKeineVariableEnthalten(Term^.Arg1);
  end;
end;  // TTKeineVariableEnthalten


function tAnalyse.TTPotenzLoeser(var SummandForm:PTermTypArray; Unbekannte:PTermTyp):PTermTypArray;          // Gibt true zurück, wenn Wurzeln erfolgreich entfernt werden konnten.

    function PLFaktorVonExponent(VorFaktoren:PTermTypArray; Exponenten: array of GRaZTyp; Exponent:dword):PTermTyp; // WICHTIG: Ist nur kompatibel bis Exponent=GNZ_GlobZahlenbasis-1; Gibt den Vorfaktor eines Summanden mit dem gewünschten Exponenten zurück.
    var ArrayLaenge, n:dword;
    begin
      ArrayLaenge:=length(Exponenten);
      n:=ArrayLaenge;
      repeat
        dec(n);
      until (n=0)or(Exponenten[n].zaehler[0]=Exponent);
      If (n=0)and(Exponenten[0].zaehler[0]<>Exponent) then
      begin // für diesen Fall ist der VorFaktor=0
        new(RESULT);
        RESULT^.Opera:=001;
        RESULT^.ZahlGRaZ:=GRaZnull;
      end else RESULT:=TTKopieVon(VorFaktoren[n]);
    end; // PLFaktorVonExponent

var n, n2, ArrayLaenge, AnzWurzeln, AnzQrdWurzeln, LoesAnz: dword;
    Radikanten, Vorfaktoren: PTermTypArray;
    RechteSeite, LinkeSeite, Laeufer, FaktorPTT, ZwSpA, ZwSpB, RadikantenVergleich: PTermTyp;
    Exponenten: GRaZListeTyp;     // = array of GRaZTyp
    ZwSpGRaZ: GRaZTyp;
    NennerVergleich: GNZTyp;
    GleichungLoesbar, RestVorhanden, UnbekannteInRest, RadikantenGleich, NennerGleich, ExponentNegativ:boolean;
begin
  RESULT:=nil; LoesAnz:=0;
  AnzWurzeln:=0; AnzQrdWurzeln:=0;
  // PARSEN: Im VorFaktoren gehören die Vorfaktoren zu dem Exponenten. Bsp.: a*x^(1/2)+2 --> VorFaktoren[0]=a; Exponenten[0]=1/2; VorFaktoren[1]=2; Exponenten[1]=0
  ArrayLaenge:=length(SummandForm);
  setlength(Radikanten, ArrayLaenge);                                                                    // Im Fall von Wurzeln sind die Radikanten die Radikanten.
  setlength(VorFaktoren, ArrayLaenge);
  setlength(Exponenten, ArrayLaenge);
  GleichungLoesbar:=true;
  ExponentNegativ:=false;                                                                                // true --> BruchEntferner muss aufgerufen werden.
  for n:=0 to ArrayLaenge-1 do
  begin
    VorFaktoren[n]:=nil;
    Radikanten[n]:=nil;
    Exponenten[n]:=GRaZnull;
    If TTagleichb(SummandForm[n],Unbekannte) then
    begin
      Radikanten[n]:=TTKopieVon(Unbekannte);                                                             // Nur im Fall von Wurzeln sind die Radikanten die Radikanten
      new(VorFaktoren[n]);
      VorFaktoren[n]^.Opera:=001;
      VorFaktoren[n]^.ZahlGRaZ:=GRaZeins;                                                                // Vorfaktor = 1
      Exponenten[n]:=GRaZeins;                                                                           // Exponent = 1
    end else
    begin
      CASE SummandForm[n]^.Opera of
        001..002,                                                                                        // 003 hat keine Bedeutung
        101..128: begin
                    VorFaktoren[n] := TTKopieVon(SummandForm[n]);                                        // Exponenten[n]:=GRaZnull ist nicht notwendig, da der Exponent bei der Initialisierung oben schon auf 0 gesetzt wird.
                    If TTUnbekannteEnthalten(VorFaktoren[n],Unbekannte) then GleichungLoesbar:=false;    // Dann handelt es sich um keine Polynomgleichung mehr, sondern um eine trigonometrische.
                  end; // 001..002,101..128
        005:      begin
                    Laeufer:=SummandForm[n];
                    Repeat
                      If Laeufer^.Opera=005 then
                      begin
                        FaktorPTT:=Laeufer^.Arg1;
                        Laeufer:=Laeufer^.Arg2;
                      end else FaktorPTT:=Laeufer;
                      If TTagleichb(FaktorPTT,Unbekannte) then
                      begin
                        if VorFaktoren[n]=nil then                                                       // Ansonsten wird ein vorher gescannter Faktor ev. überschrieben.
                        begin
                          new(VorFaktoren[n]);
                          VorFaktoren[n]^.Opera:=001;
                          VorFaktoren[n]^.ZahlGRaZ:=GRaZeins;                                            // Vorfaktor = 1
                        end;
                        Radikanten[n]:=TTKopieVon(Unbekannte);
                        Exponenten[n]:=GRaZeins;                                                         // Wenn TTVereinfachung richtig arbeitet, ist dies die einzige Unbekannte im Summand. (x*a*x^2 TTVereinfachung: a*x^3)
                      end else if FaktorPTT^.Opera=006 then                                              // eine andere Fallunterscheidung ist wegen der Sortierung des Terms (durch TTVereinfachung in TTLoeseGleichung) nicht notwendig.
                      begin
                        if TTUnbekannteEnthalten(FaktorPTT^.Arg1,Unbekannte) then
                        begin
                          If FaktorPTT^.Arg2^.Opera=001 then
                          begin
                            if VorFaktoren[n]=nil then                                                   // Ansonsten wird ein vorher gescannter Faktor ev. überschrieben.
                            begin
                              new(VorFaktoren[n]);
                              VorFaktoren[n]^.Opera:=001;
                              VorFaktoren[n]^.ZahlGRaZ:=GRaZeins;                                        // Vorfaktor = 1, da reine Potenz.
                            end;
                            Radikanten[n]:=TTKopieVon(FaktorPTT^.Arg1);
                            If GNZagleichb(Exponenten[n].zaehler,0) then Exponenten[n]:=GRaZcopy(FaktorPTT^.Arg2^.ZahlGRaZ) else GleichungLoesbar:=false; // Wenn Exponenten[n]<>nil: Mind. zwei versch. Wurzeln in einem Faktor. SPÄTER: Kann gelöst werden, indem der isolierte Faktor mit kgV-Nenner potenziert wird.
                            If FaktorPTT^.Arg2^.ZahlGRaZ.Negativ=true then ExponentNegativ:=true;        // --> BruchEntferner
                          end else GleichungLoesbar:=false; // if FaktorPTT^.Arg2^.Opera=001 else        // Die Gleichung ist nur dann mit dem PotenzLoeser lösbar, wenn der Exponent rational ist.
                        end else
                        begin
                          If TTUnbekannteEnthalten(FaktorPTT^.Arg2, Unbekannte) then GleichungLoesbar:=false;  // Dann handelt es sich um keine Polynomgleichung mehr, sondern um eine Exponentialgleichung.
                          If VorFaktoren[n]=nil then
                          begin
                            VorFaktoren[n]   := TTKopieVon(FaktorPTT);
                          end else
                          begin
                            ZwSpA:=VorFaktoren[n];
                            new(VorFaktoren[n]);
                            VorFaktoren[n]^.Opera:=005;
                            VorFaktoren[n]^.Arg1:=ZwSpA;
                            VorFaktoren[n]^.Arg2:=TTKopieVon(FaktorPTT);
                          end;
                        end; // 006
                      end else
                      begin                                                                              // Nun kann es sich nur noch um einen normalen Faktor handeln.
                        If VorFaktoren[n]=nil then
                        begin
                          VorFaktoren[n]   := TTKopieVon(FaktorPTT);
                        end else
                        begin
                          ZwSpA:=VorFaktoren[n];
                          new(VorFaktoren[n]);
                          VorFaktoren[n]^.Opera:=005;
                          VorFaktoren[n]^.Arg1:=ZwSpA;
                          VorFaktoren[n]^.Arg2:=TTKopieVon(FaktorPTT)
                        end;
                        If TTUnbekannteEnthalten(FaktorPTT,Unbekannte) then GleichungLoesbar:=false;
                      end;
                    until FaktorPTT=Laeufer;
                  end; // 005
        006:      If TTUnbekannteEnthalten(SummandForm[n]^.Arg1,Unbekannte) then
                  begin
                    If SummandForm[n]^.Arg2^.Opera=001 then
                    begin
                      Radikanten[n]:=TTKopieVon(SummandForm[n]^.Arg1);
                      new(VorFaktoren[n]);
                      VorFaktoren[n]^.Opera:=001;
                      VorFaktoren[n]^.ZahlGRaZ:=GRaZeins;                                                // Vorfaktor = 1, da reine Potenz.
                      Exponenten[n]:=GRaZcopy(SummandForm[n]^.Arg2^.ZahlGRaZ);
                      If SummandForm[n]^.Arg2^.ZahlGRaZ.Negativ=true then ExponentNegativ:=true;         // --> BruchEntferner
                    end else GleichungLoesbar:=false;                                                    // Denn es handelt sich nicht mehr um eine Polynomgleichung, sondern um eine Exponentialgleichung.
                  end else
                  begin
                    VorFaktoren[n]:= TTKopieVon(SummandForm[n]);
                    If TTUnbekannteEnthalten(SummandForm[n]^.Arg2,Unbekannte) then GleichungLoesbar:=false;
                  end; // 006
      end; // CASE
    end;
  end; // for n

  If ExponentNegativ then
  begin  // Wird z.B. bei Rekursion von sqrt(1/x+1)=2 aufgerufen.
    TTBruchEntferner(SummandForm,Unbekannte);
    RESULT:=TTPotenzLoeser(SummandForm, Unbekannte);
    for n:=0 to ArrayLaenge-1 do
    begin
      if VorFaktoren[n]<>nil then TTTermFreigabe(VorFaktoren[n]);
      if Radikanten[n]<>nil then TTTermFreigabe(Radikanten[n]);
    end;
  end else if GleichungLoesbar then
  begin
    // INITIALISIERUNG:
    RestVorhanden:=false;                                                                                // Rest = Faktoren ohne Wurzel
    UnbekannteInRest:=false;                                                                             // true, wenn die Unbekannte im Rest enthalten ist.
    RadikantenGleich:=true;                                                                              // true, wenn alle vorkommenden Radikanten gleich sind.
    RadikantenVergleich:=nil;
    NennerGleich:=true;                                                                                  // true, wenn alle Wurzelexponenten den gleichen Nenner haben.
    NennerVergleich:=nil;
    AnzWurzeln:=0;
    AnzQrdWurzeln:=0;
    for n:=0 to ArrayLaenge-1 do if Radikanten[n]=nil then                                               // Um Zugriffsfehler im nun folgenden Algorithmus vorzubeugen müssen Radikanten stets besetzt sein.
    begin
      new(Radikanten[n]);
      Radikanten[n]^.Opera:=001;
      Radikanten[n]^.ZahlGRaZ:=GRaZeins;
    end; // for
    // SORTIERUNG: Die Arrays werden aufsteigend nach Exponenten sortiert. Zudem werden gleiche Exponenten (bzw. zugehörige Faktoren) zusammengefasst.
    n:=0;
    while (n<ArrayLaenge) do
    begin
      n2:= n+1;
      while (n2<ArrayLaenge) do
      begin
        if GRaZakleinerbBetrag(Exponenten[n2],Exponenten[n]) then                                        // Betrag deshalb, weil der Exponent nach der BruchEntfernung positiv seien müsste.
        begin // Einträge müssen getauscht werden.
          ZwSpA:=Vorfaktoren[n2];
          ZwSpB:=Radikanten[n2];
          ZwSpGRaZ:=Exponenten[n2];
          Vorfaktoren[n2]:=Vorfaktoren[n];
          Radikanten[n2] :=Radikanten[n];
          Exponenten[n2] :=Exponenten[n];
          Vorfaktoren[n]:=ZwSpA;
          Radikanten[n] :=ZwSpB;
          Exponenten[n] :=ZwSpGRaZ;
          ZwSpA:=nil;
        end else if GRaZagleichb(Exponenten[n2],Exponenten[n]) then if TTagleichb(Radikanten[n],Radikanten[n2]) then
        begin                                                                                            // Terme mit gleichem Radikanten und gleichem Exponenten werden zusammengefasst.
          new(ZwSpA);
          ZwSpA^.Opera:=004;                                                                             // 004 = Addition
          ZwSpA^.Arg1:=Vorfaktoren[n];
          ZwSpA^.Arg2:=Vorfaktoren[n2];
          Vorfaktoren[n]:=ZwSpA;
          Vorfaktoren[n2]:=Vorfaktoren[ArrayLaenge-1];                                                   // die aufkommende Lücke wird durch den letzten Array-Eintrag gestopft, welcher daraufhin auf nil gesetzt wird.
          Vorfaktoren[ArrayLaenge-1]:=nil;
          TTTermFreigabe(Radikanten[n2]);
          Radikanten[n2]:=Radikanten[ArrayLaenge-1];
          Radikanten[ArrayLaenge-1]:=nil;
          Exponenten[n2]:=Exponenten[ArrayLaenge-1];
          dec(ArrayLaenge); dec(n2);
          setlength(Vorfaktoren,ArrayLaenge);
          setlength(Radikanten,ArrayLaenge);
          setlength(Exponenten,ArrayLaenge);
          ZwSpA:=nil;
        end;
        inc(n2);
      end; // while n2
      // Nun werden Variablen gesetzt, die weiter unten die Wahl der Lösungsstrategien beeinflussen.
      If GNZakleinerb(1,Exponenten[n].nenner) then                                                       // Ist nur der Fall, wenn Radikanten[n] die Unbekannte enthält.
      begin
        inc(AnzWurzeln);                                                                                 // Wenn der Nenner > 1 ist, handelt es sich um eine Wurzel --> AnzWurzel um 1 erhöhen.
        If RadikantenVergleich=nil then RadikantenVergleich:=Radikanten[n] else if not (TTagleichb(RadikantenVergleich, Radikanten[n])) then RadikantenGleich:=false;
        If NennerVergleich=nil then NennerVergleich:=Exponenten[n].nenner else if not (GNZagleichb(NennerVergleich,Exponenten[n].nenner)) then NennerGleich:=false;
      end;
      If GNZagleichb(Exponenten[n].nenner,2) then inc(AnzQrdWurzeln);
      If (GNZagleichb(Exponenten[n].nenner,1))or(GNZagleichb(Exponenten[n].zaehler,0)) then
      begin
        RestVorhanden:=true;                                                                             // Rest = Faktoren ohne Wurzel
        If TTUnbekannteEnthalten(Radikanten[n],Unbekannte) then UnbekannteInRest:=true;                  // Der Rest enthält die Unbekannte.
      end;
      inc(n);
    end; // while n

    If (AnzWurzeln=0)and(RadikantenGleich) then                                                          // 1. ================================================================================
    begin  //---> POLYLOESER <---
      // LOESUNG: Die Arrays werden nach Mustern gescannt, für die Lösungsalgorithmen existieren.
      LoesAnz:=0;
      // Schritt 1: Prüfen, ob x abgespalten werden kann. Wenn ja, ist 0 automatisch eine der Lösungen.
      If GNZakleinerb(0,Exponenten[0].zaehler) then
      begin
        for n:=ArrayLaenge-1 downto 0 do Exponenten[n].zaehler:=GNZsub(Exponenten[n].zaehler,Exponenten[0].zaehler);
        inc(LoesAnz);
        setlength(RESULT,LoesAnz);
        new(RESULT[LoesAnz-1]);
        RESULT[LoesAnz-1]^.Opera:=001;
        RESULT[LoesAnz-1]^.ZahlGRaZ:=GRaZnull;
      end;
      // Schritt 2: Anwenden der Lösungsformeln für Polynomgrad <= 4
      If length(Exponenten[ArrayLaenge-1].zaehler)=1 then
      CASE Exponenten[ArrayLaenge-1].zaehler[0] of                                                       // Fragt den höchsten Exponenten des Polynoms ab.
        0: begin // In diesem Fall handelt es sich bei der Gleichung um eine immer wahre Aussage (z.B. x=x), um eine immer falsche Aussage (z.B. 2=3) oder um eine oben abgefangene Aussage wie 2x=3x
             if Vorfaktoren[ArrayLaenge-1].Opera=001 then if GNZagleichb(Vorfaktoren[ArrayLaenge-1].ZahlGRaZ.Zaehler,GNZnull) then if LoesAnz=0 then
             begin  // Z.B. bei Gleichung 3=3 wird Vorfaktor 0, da 3-3=0
               inc(LoesAnz);
               setlength(RESULT,LoesAnz);
               new(RESULT[LoesAnz-1]);
               RESULT[LoesAnz-1]^.Opera:=002;
               RESULT[LoesAnz-1]^.Varname:='_alle';
               RESULT[LoesAnz-1]^.Konstante:=true;
             end;
           end;  // 0
        1: begin // lineare Gleichung  b+a*x=0 ==> x = (-1)*b*a^(-1); VorFaktoren[0]=b; VorFaktoren[1]=a; Bemerkung: Fall a*x=0 wird durch Schritt 1 schon bereinigt, kommt hier also nicht mehr vor.
             inc(LoesAnz);
             setlength(RESULT,LoesAnz);
             new(RESULT[LoesAnz-1]);
             RESULT[LoesAnz-1]^.Opera:=005;
             new(RESULT[LoesAnz-1]^.Arg1);
             RESULT[LoesAnz-1]^.Arg1^.Opera:=001;
             RESULT[LoesAnz-1]^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
             new(RESULT[LoesAnz-1]^.Arg2);
             RESULT[LoesAnz-1]^.Arg2^.Opera:=005;
             RESULT[LoesAnz-1]^.Arg2^.Arg1:=PLFaktorVonExponent(VorFaktoren, Exponenten, 0);             // = b, denn b*x^0
             new(RESULT[LoesAnz-1]^.Arg2^.Arg2);
             RESULT[LoesAnz-1]^.Arg2^.Arg2^.Opera:=006;
             RESULT[LoesAnz-1]^.Arg2^.Arg2^.Arg1:=PLFaktorVonExponent(VorFaktoren, Exponenten, 1);       // = a, denn a*x^1
             new(RESULT[LoesAnz-1]^.Arg2^.Arg2^.Arg2);
             RESULT[LoesAnz-1]^.Arg2^.Arg2^.Arg2^.Opera:=001;
             RESULT[LoesAnz-1]^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
           end;  // 1
        2: begin // quadratische Gleichung c+b*x+a*x^2=0 ==> x_1 = (-1)*b*(2*a)^(-1)+sqrt((b*(2*a)^(-1))^2+(-1)*c*a^(-1))
             // ZwSpA := b*((2*a))^(-1);
             new(ZwSpA);
             ZwSpA^.Opera:=005;
             ZwSpA^.Arg1:=PLFaktorVonExponent(VorFaktoren, Exponenten, 1);                               // = b, denn b*x^1
             new(ZwSpA^.Arg2);
             ZwSpA^.Arg2^.Opera:=006;
             new(ZwSpA^.Arg2^.Arg1);
             ZwSpA^.Arg2^.Arg1^.Opera:=005;
             new(ZwSpA^.Arg2^.Arg1^.Arg1);
             ZwSpA^.Arg2^.Arg1^.Arg1^.Opera:=001;
             ZwSpA^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);
             ZwSpA^.Arg2^.Arg1^.Arg2:=PLFaktorVonExponent(VorFaktoren, Exponenten, 2);                 // = a, denn a*x^2
             new(ZwSpA^.Arg2^.Arg2);
             ZwSpA^.Arg2^.Arg2^.Opera:=001;
             ZwSpA^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
             // ZwSpB := (-1)*(c*(a^(-1)))
             new(ZwSpB);
             ZwSpB^.Opera:=005;
             new(ZwSpB^.Arg1);
             ZwSpB^.Arg1^.Opera:=001;
             ZwSpB^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
             new(ZwSpB^.Arg2);
             ZwSpB^.Arg2^.Opera:=005;
             ZwSpB^.Arg2^.Arg1:=PLFaktorVonExponent(VorFaktoren, Exponenten, 0);                         // = c, denn c*x^0
             new(ZwSpB^.Arg2^.Arg2);
             ZwSpB^.Arg2^.Arg2^.Opera:=006;
             ZwSpB^.Arg2^.Arg2^.Arg1:=PLFaktorVonExponent(VorFaktoren, Exponenten, 2);                   // = a, denn a*x^2
             new(ZwSpB^.Arg2^.Arg2^.Arg2);
             ZwSpB^.Arg2^.Arg2^.Arg2^.Opera:=001;
             ZwSpB^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);

             // 1. Lösung: x_1 = (-1)*(ZwSpA) + ((ZwSpA)^(2)+ZwSpB)^(1/2)
             inc(LoesAnz);
             setlength(RESULT,LoesAnz);
             new(RESULT[LoesAnz-1]);
             RESULT[LoesAnz-1]^.Opera:=004;
             new(RESULT[LoesAnz-1]^.Arg1);
             RESULT[LoesAnz-1]^.Arg1^.Opera:=005;
             new(RESULT[LoesAnz-1]^.Arg1^.Arg1);
             RESULT[LoesAnz-1]^.Arg1^.Arg1^.Opera:=001;
             RESULT[LoesAnz-1]^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
             RESULT[LoesAnz-1]^.Arg1^.Arg2:=TTKopieVon(ZwSpA);
             new(RESULT[LoesAnz-1]^.Arg2);
             RESULT[LoesAnz-1]^.Arg2^.Opera:=006;
             new(RESULT[LoesAnz-1]^.Arg2^.Arg1);
             RESULT[LoesAnz-1]^.Arg2^.Arg1^.Opera:=004;
             new(RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg1);
             RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg1^.Opera:=006;
             RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg1^.Arg1:=TTKopieVon(ZwSpA);
             new(RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg1^.Arg2);
             RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg1^.Arg2^.Opera:=001;
             RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                     // ^(2)
             RESULT[LoesAnz-1]^.Arg2^.Arg1^.Arg2:=ZwSpB;                                                        // "TTKopieVon" wurde weggelassen, damit Pointer später nicht freigegeben werden muss.
             new(RESULT[LoesAnz-1]^.Arg2^.Arg2);
             RESULT[LoesAnz-1]^.Arg2^.Arg2^.Opera:=001;
             RESULT[LoesAnz-1]^.Arg2^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(1,2,false);                                 // ^(1/2)

             // ZwSpB := (ZwSpA^2+ZwSpB)^(1/2) = RESULT[LoesAnz-1].Arg2;
             ZwSpB:=TTKopieVon(RESULT[LoesAnz-1].Arg2);

             // 2. Lösung existiert nur, wenn ZwSpB<>0
             TTVereinfachung(ZwSpB);
             If ZwSpB^.Opera=001 then ZwSpGRaZ:=ZwSpB^.ZahlGRaZ else ZwSpGRaZ:=GRaZeins;
             If not GNZagleichb(ZwSpGRaZ.Zaehler,0) then
             begin
               // 2. Lösung: x_1 = (-1)*(ZwSpA) + (-1)*ZwSpB
               inc(LoesAnz);
               setlength(RESULT,LoesAnz);
               new(RESULT[LoesAnz-1]);
               RESULT[LoesAnz-1]^.Opera:=004;
               new(RESULT[LoesAnz-1]^.Arg1);
               RESULT[LoesAnz-1]^.Arg1^.Opera:=005;
               new(RESULT[LoesAnz-1]^.Arg1^.Arg1);
               RESULT[LoesAnz-1]^.Arg1^.Arg1^.Opera:=001;
               RESULT[LoesAnz-1]^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
               RESULT[LoesAnz-1]^.Arg1^.Arg2:=ZwSpA;                                                            // "TTKopieVon" wurde weggelassen, damit Pointer später nicht freigegeben werden muss.
               new(RESULT[LoesAnz-1]^.Arg2);
               RESULT[LoesAnz-1]^.Arg2^.Opera:=005;                                                             // *(-1)
               new(RESULT[LoesAnz-1]^.Arg2^.Arg1);
               RESULT[LoesAnz-1]^.Arg2^.Arg1^.Opera:=001;
               RESULT[LoesAnz-1]^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
               RESULT[LoesAnz-1]^.Arg2^.Arg2:=ZwSpB;                                                            // "TTKopieVon" aus den selben Gründen wie oben weggelassen.
             end else
             begin // sonst: ZwSpA, ZwSpB freigeben.
               TTTermFreigabe(ZwSpA);
               TTTermFreigabe(ZwSpB);
             end;
             If ZwSpGRaZ.Negativ then
             begin                                                                                              // NEG. WURZEL --> NUR REELLE LÖSUNGEN WERDEN ZUGELASSEN; Siehe zudem Hinweis zu neg. Wurzeln in LoeseGleichung
               LoesAnz:=LoesAnz-2;
               TTTermFreigabe(RESULT[LoesAnz-1]);
               TTTermFreigabe(RESULT[LoesAnz-2]);
             end;
           end;  // 2
        {3: begin // kubische Gleichung
             // muss noch implementiert werden.
           end;  // 3
        4: begin // Polynomgleichung vierten Grades
             // muss noch implementiert werden.
           end;  // 4      }
      else //CASE OF
        inc(LoesAnz);
        setlength(RESULT,LoesAnz);
        new(RESULT[LoesAnz-1]);
        RESULT[LoesAnz-1]^.Opera:=002;
        RESULT[LoesAnz-1]^.Konstante:=true;
        RESULT[LoesAnz-1]^.Varname:='_weitere_Lösungen_möglich';                                          // Aufgrund fehlender Implementierung von Lösungsalgorithmen
      end; // CASE ELSE
      // Zu tun:
      // --> Schritt 3: Lösung einfacher Potenzgleichungen durch Ziehen der n-ten Wurzel (Dürfte recht einfach möglich sein, da die Arrays nur 2 Elemente enthalten...)
      // --> Schritt 4: Anwenden der Regel für den absoluten Koeffizienten für Polynomgrad > 4; Alle Koeffizienten müssen ganzzahlig sein (oder ganzzahlig gemacht werden können).
    end else if (AnzWurzeln=1) and (Restvorhanden) then                                                  // 2. ================================================================================
    begin  // Nur eine Wurzel vorhanden.
      ZwSpA:=nil; ZwSpB:=nil;                                                                            // ZwSpA = Alles, was von der Linken Seite abgezogen werden muss.
      LinkeSeite:=nil; RechteSeite:=nil;                                                                 // Auf LinkeSeite soll die Wurzel samt Vorfaktor stehen - allerdings bereits potenziert.
      n2:=0;                                                                                             // n2 gibt das Element des Arrays an, welches die Wurzel enthält.
      for n:=0 to ArrayLaenge-1 do
      begin
        If GNZagleichb(Exponenten[n].nenner,1) then
        begin
          if ZwSpA=nil then
          begin
            new(ZwSpA);
            ZwSpA^.Opera:=005;
            ZwSpA^.Arg1:=TTKopieVon(Vorfaktoren[n]);
            new(ZwSpA^.Arg2);
            ZwSpA^.Arg2^.Opera:=006;
            ZwSpA^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
            new(ZwSpA^.Arg2^.Arg2);
            ZwSpA^.Arg2^.Arg2^.Opera:=001;
            ZwSpA^.Arg2^.Arg2^.ZahlGRaZ:=GRaZcopy(Exponenten[n]);
          end else
          begin
            ZwSpB:=ZwSpA;
            new(ZwSpA);
            ZwSpA^.Opera:=004;
            ZwSpA^.Arg2:=ZwSpB;                                                                            // Kleine Optimierung: Durch Zuweisung des bisherigen Terms zu Arg2 wird der Sortieraufwandt später verkleinert.
            new(ZwSpA^.Arg1);
            ZwSpA^.Arg1^.Opera:=005;
            ZwSpA^.Arg1^.Arg1:=TTKopieVon(Vorfaktoren[n]);
            new(ZwSpA^.Arg1^.Arg2);
            ZwSpA^.Arg1^.Arg2^.Opera:=006;
            ZwSpA^.Arg1^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
            new(ZwSpA^.Arg1^.Arg2^.Arg2);
            ZwSpA^.Arg1^.Arg2^.Arg2^.Opera:=001;
            ZwSpA^.Arg1^.Arg2^.Arg2^.ZahlGRaZ:=GRaZcopy(Exponenten[n]);
          end;  // if ZwSpA=nil else
        end else  n2:=n; // If GNZagleichb(Exponenten[n].nenner,1) else --> D.h. bei n2 handelt es sich um die Wurzel.
      end;  // for
      If (not UnbekannteInRest) and TTagleichb(Radikanten[n2],Unbekannte) then
      begin
        LoesAnz:=1;
        setlength(RESULT,LoesAnz);
        LinkeSeite:=TTKopieVon(Radikanten[n2]);
        // RechteSeite:=VorFaktoren[n2]^(-(Zaehler:Exponenten[n2].nenner; Nenner: Exponenten[n2].zaehler)) * ((-1)*ZwSpA)^(Zaehler:Exponenten[n2].nenner; Nenner: Exponenten[n2].zaehler)
        new(RechteSeite);
        RechteSeite^.Opera:=005;
        new(RechteSeite^.Arg1);
        RechteSeite^.Arg1^.Opera:=006;
        RechteSeite^.Arg1^.Arg1:=TTKopieVon(VorFaktoren[n2]);
        new(RechteSeite^.Arg1^.Arg2);
        RechteSeite^.Arg1^.Arg2^.Opera:=001;
        RechteSeite^.Arg1^.Arg2^.ZahlGRaZ.negativ:=true;
        RechteSeite^.Arg1^.Arg2^.ZahlGRaZ.zaehler:=copy(Exponenten[n2].nenner);
        RechteSeite^.Arg1^.Arg2^.ZahlGRaZ.nenner :=copy(Exponenten[n2].zaehler);
        new(RechteSeite^.Arg2);
        RechteSeite^.Arg2^.Opera:=006;
        new(RechteSeite^.Arg2^.Arg1);
        RechteSeite^.Arg2^.Arg1^.Opera:=005;
        new(RechteSeite^.Arg2^.Arg1^.Arg1);
        RechteSeite^.Arg2^.Arg1^.Arg1^.Opera:=001;
        RechteSeite^.Arg2^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                    // (-1)
        RechteSeite^.Arg2^.Arg1^.Arg2:=ZwSpA;
        new(RechteSeite^.Arg2^.Arg2);
        RechteSeite^.Arg2^.Arg2^.Opera:=001;
        RechteSeite^.Arg2^.Arg2^.ZahlGRaZ.Negativ:=false;
        RechteSeite^.Arg2^.Arg2^.ZahlGRaZ.zaehler:=copy(Exponenten[n2].nenner);
        RechteSeite^.Arg2^.Arg2^.ZahlGRaZ.nenner :=copy(Exponenten[n2].zaehler);

        RESULT[0]:=RechteSeite;
        TTTermFreigabe(LinkeSeite);
      end else
      begin // für diesen Fall ist die Unbekannte im Radikanten mit Vorfaktor enthalten. Zudem kann die Unbekannte im Rest enthalten sein.
        new(LinkeSeite);                                                                                     // Die Linke Seite wird hier so potenziert, dass die Wurzel wegfällt.
        LinkeSeite^.Opera:=005;
        new(LinkeSeite^.Arg1);
        LinkeSeite^.Arg1^.Opera:=006;
        LinkeSeite^.Arg1^.Arg1:=TTKopieVon(Vorfaktoren[n2]);
        new(LinkeSeite^.Arg1^.Arg2);
        LinkeSeite^.Arg1^.Arg2^.Opera:=001;
        LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ.zaehler:=copy(Exponenten[n2].nenner);                               // Wird mit Nenner potenziert.
        LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ.nenner :=GNZeins;
        LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ.Negativ:=false;
        new(LinkeSeite^.Arg2);
        LinkeSeite^.Arg2^.Opera:=006;
        LinkeSeite^.Arg2^.Arg1:=TTKopieVon(Radikanten[n2]);
        new(LinkeSeite^.Arg2^.Arg2);
        LinkeSeite^.Arg2^.Arg2^.Opera:=001;
        LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ.zaehler:=copy(Exponenten[n2].zaehler);
        LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ.nenner :=GNZeins;                                                   // Der Nenner wurde wegpotenziert.
        LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ.Negativ:=false;

        new(RechteSeite);                                                                                    // Die RechteSeite muss ebenfalls mit dem Nenner potenziert werden.
        RechteSeite^.Opera:=006;
        new(RechteSeite^.Arg1);
        RechteSeite^.Arg1^.Opera:=005;
        new(RechteSeite^.Arg1^.Arg1);
        RechteSeite^.Arg1^.Arg1^.Opera:=001;
        RechteSeite^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);
        RechteSeite^.Arg1^.Arg2:=ZwSpA;                                                                      // ZwSpA = Alles, was von der linken Seite abgezogen werden muss. Daher die Multiplikation mit (-1)
        new(RechteSeite^.Arg2);
        RechteSeite^.Arg2^.Opera:=001;
        RechteSeite^.Arg2^.ZahlGRaZ.zaehler:=copy(Exponenten[n2].nenner);                                    // Dies ist der Exponentennenner
        RechteSeite^.Arg2^.ZahlGRaZ.nenner :=GNZeins;
        RechteSeite^.Arg2^.ZahlGRaZ.Negativ:=false;

        //Nun wird der Term in Normalform gebracht: LinkeSeite:=LinkeSeite + (-1)*RechteSeite
        ZwSpB:=LinkeSeite;
        new(LinkeSeite);
        LinkeSeite^.Opera:=004;
        LinkeSeite^.Arg1:=ZwSpB;
        new(LinkeSeite^.Arg2);
        LinkeSeite^.Arg2^.Opera:=005;
        new(LinkeSeite^.Arg2^.Arg1);
        LinkeSeite^.Arg2^.Arg1^.Opera:=001;
        LinkeSeite^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                           // (-1)
        LinkeSeite^.Arg2^.Arg2:=RechteSeite;

        for n:=0 to length(SummandForm)-1 do TTTermFreigabe(SummandForm[n]);
        SummandForm:= TTTermToSummandForm(LinkeSeite);
        RESULT:=TTPotenzLoeser(SummandForm,Unbekannte);                                                     // Löst die durch das Potenzieren entstehende Polynom- bzw. Potenzgleichung
        TTTermFreigabe(LinkeSeite);
      end;
    end else if (AnzWurzeln=2) and (not Restvorhanden) then                                                 // 3. ================================================================================
    begin  // Gleichung besteht aus genau 2 Wurzeln, welche beide die Unbekannte enthalten.                 // Kann noch nicht vollständig in Selbsttest aufgenommen werden, da nur Polynomgleichungen 2. Grades unterstützt werden.
      ZwSpGRaZ:=GRaZeins;
      ZwSpGRaZ.zaehler:=GNZkgV(Exponenten[0].nenner,Exponenten[1].nenner);                                  // Lösung der Gleichung, indem sie mit dem kgV der beiden Exponentennenner potenziert und anschließend als Polygongleichung gelöst wird.

      new(LinkeSeite);
      LinkeSeite^.Opera:=005;
      new(LinkeSeite^.Arg1);
      LinkeSeite^.Arg1^.Opera:=006;
      LinkeSeite^.Arg1^.Arg1:=TTKopieVon(Vorfaktoren[0]);
      new(LinkeSeite^.Arg1^.Arg2);
      LinkeSeite^.Arg1^.Arg2^.Opera:=001;
      LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ:=GRaZcopy(ZwSpGRaZ);
      new(LinkeSeite^.Arg2);
      LinkeSeite^.Arg2^.Opera:=006;
      LinkeSeite^.Arg2^.Arg1:=TTKopieVon(Radikanten[0]);
      new(LinkeSeite^.Arg2^.Arg2);
      LinkeSeite^.Arg2^.Arg2^.Opera:=001;
      LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ:=GRaZmul(Exponenten[0],ZwSpGRaZ);

      new(RechteSeite);
      RechteSeite^.Opera:=005;
      new(RechteSeite^.Arg1);
      RechteSeite^.Arg1^.Opera:=006;
      new(RechteSeite^.Arg1^.Arg1);
      RechteSeite^.Arg1^.Arg1^.Opera:=005;
      new(RechteSeite^.Arg1^.Arg1^.Arg1);
      RechteSeite^.Arg1^.Arg1^.Arg1^.Opera:=001;
      RechteSeite^.Arg1^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                    // (-1)
      RechteSeite^.Arg1^.Arg1^.Arg2:=TTKopieVon(Vorfaktoren[1]);
      new(RechteSeite^.Arg1^.Arg2);
      RechteSeite^.Arg1^.Arg2^.Opera:=001;
      RechteSeite^.Arg1^.Arg2^.ZahlGRaZ:=GRaZcopy(ZwSpGRaZ);
      new(RechteSeite^.Arg2);
      RechteSeite^.Arg2^.Opera:=006;
      RechteSeite^.Arg2^.Arg1:=TTKopieVon(Radikanten[1]);
      new(RechteSeite^.Arg2^.Arg2);
      RechteSeite^.Arg2^.Arg2^.Opera:=001;
      RechteSeite^.Arg2^.Arg2^.ZahlGRaZ:=GRaZmul(Exponenten[1],ZwSpGRaZ);

      ZwSpB:=LinkeSeite;                                                                                   // LinkeSeite:=LinkeSeite + (-1)*RechteSeite
      new(LinkeSeite);
      LinkeSeite^.Opera:=004;
      LinkeSeite^.Arg1:=ZwSpB;
      new(LinkeSeite^.Arg2);
      LinkeSeite^.Arg2^.Opera:=005;
      new(LinkeSeite^.Arg2^.Arg1);
      LinkeSeite^.Arg2^.Arg1^.Opera:=001;
      LinkeSeite^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                           // (-1)
      LinkeSeite^.Arg2^.Arg2:=RechteSeite;

      for n:=0 to length(SummandForm)-1 do TTTermFreigabe(SummandForm[n]);
      SummandForm:= TTTermToSummandForm(LinkeSeite);
      RESULT:= TTPotenzLoeser(SummandForm,Unbekannte);                                                     // Löst die durch das Potenzieren entstehende Polynom- bzw. Potenzgleichung
      TTTermFreigabe(LinkeSeite);
    end else if (AnzWurzeln=2) and (AnzQrdWurzeln>=1) then                                                  // 4. ================================================================================
    begin  // Rest ist vorhanden und Gleichung besteht aus 2 Wurzeln, von denen eine eine Quadratwurzel ist.
           // KANN ERST GETESTET WERDEN, WENN POLYNOMGLEICHUNGEN VOM GRAD > 2 GELÖST WERDEN KÖNNEN
      RechteSeite:=nil;
      If AnzQrdWurzeln=1 then
      begin
        for n:=0 to ArrayLaenge-1 do
        begin
          If GNZakleinerb(2,Exponenten[n].nenner) then n2:=n else if RechteSeite=nil then                    // n2 kommt auf LinkeSeite, alles Andere auf RechteSeite.
          begin
            // RechteSeite:=(-1)*Vorfaktoren[n]*Radikanten[n]^Exponenten[n];
            new(RechteSeite);
            RechteSeite^.Opera:=005;
            new(RechteSeite^.Arg1);
            RechteSeite^.Arg1^.Opera:=001;
            RechteSeite^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                            // (-1)
            new(RechteSeite^.Arg2);
            RechteSeite^.Arg2^.Opera:=005;
            RechteSeite^.Arg2^.Arg1:=TTKopieVon(Vorfaktoren[n]);
            new(RechteSeite^.Arg2^.Arg2);
            RechteSeite^.Arg2^.Arg2^.Opera:=006;
            RechteSeite^.Arg2^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
            new(RechteSeite^.Arg2^.Arg2^.Arg2);
            RechteSeite^.Arg2^.Arg2^.Arg2^.Opera:=001;
            RechteSeite^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
          end else
          begin
            // RechteSeite:=(-1)*Vorfaktoren[n]*Radikanten[n]^Exponenten[n] + RechteSeite
            ZwSpB:=RechteSeite;
            new(RechteSeite);
            RechteSeite^.Opera:=004;
            new(RechteSeite^.Arg1);
            RechteSeite^.Arg1^.Opera:=005;
            new(RechteSeite^.Arg1^.Arg1);
            RechteSeite^.Arg1^.Arg1^.Opera:=001;
            RechteSeite^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                      // (-1)
            new(RechteSeite^.Arg1^.Arg2);
            RechteSeite^.Arg1^.Arg2^.Opera:=005;
            RechteSeite^.Arg1^.Arg2^.Arg1:=TTKopieVon(Vorfaktoren[n]);
            new(RechteSeite^.Arg1^.Arg2^.Arg2);
            RechteSeite^.Arg1^.Arg2^.Arg2^.Opera:=006;
            RechteSeite^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
            new(RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2);
            RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
            RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
            RechteSeite^.Arg2:=ZwSpB;                                                                        // + (alte) RechteSeite
          end; // if RechteSeite=nil else
        end;  // for n
      end else
      begin // In diesem Fall sind beide Wurzeln Quadratwurzeln. For-Schleife ist nur in der if-Abfrage zu oben geändert.
        n2:=ArrayLaenge;                                                                                     // Marker dafür, ob If-Bedingung unten bereits erfüllt war.
        for n:=0 to ArrayLaenge-1 do
        begin
          If (n2=ArrayLaenge)and(not GNZagleichb(Exponenten[n].Nenner,1)) then n2:=n else if RechteSeite=nil then   // n2 kommt auf LinkeSeite, alles Andere auf RechteSeite.
          begin
            // RechteSeite:=(-1)*Vorfaktoren[n]*Radikanten[n]^Exponenten[n];
            new(RechteSeite);
            RechteSeite^.Opera:=005;
            new(RechteSeite^.Arg1);
            RechteSeite^.Arg1^.Opera:=001;
            RechteSeite^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                            // (-1)
            new(RechteSeite^.Arg2);
            RechteSeite^.Arg2^.Opera:=005;
            RechteSeite^.Arg2^.Arg1:=TTKopieVon(Vorfaktoren[n]);
            new(RechteSeite^.Arg2^.Arg2);
            RechteSeite^.Arg2^.Arg2^.Opera:=006;
            RechteSeite^.Arg2^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
            new(RechteSeite^.Arg2^.Arg2^.Arg2);
            RechteSeite^.Arg2^.Arg2^.Arg2^.Opera:=001;
            RechteSeite^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
          end else
          begin
            // RechteSeite:=(-1)*Vorfaktoren[n]*Radikanten[n]^Exponenten[n] + RechteSeite
            ZwSpB:=RechteSeite;
            new(RechteSeite);
            RechteSeite^.Opera:=004;
            new(RechteSeite^.Arg1);
            RechteSeite^.Arg1^.Opera:=005;
            new(RechteSeite^.Arg1^.Arg1);
            RechteSeite^.Arg1^.Arg1^.Opera:=001;
            RechteSeite^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                      // (-1)
            new(RechteSeite^.Arg1^.Arg2);
            RechteSeite^.Arg1^.Arg2^.Opera:=005;
            RechteSeite^.Arg1^.Arg2^.Arg1:=TTKopieVon(Vorfaktoren[n]);
            new(RechteSeite^.Arg1^.Arg2^.Arg2);
            RechteSeite^.Arg1^.Arg2^.Arg2^.Opera:=006;
            RechteSeite^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
            new(RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2);
            RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
            RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
            RechteSeite^.Arg2:=ZwSpB;                                                                        // + (alte) RechteSeite
          end; // if RechteSeite=nil else
        end;  // for n
      end; // If AnzQdrWurzeln=1 else

      // LinkeSeite := (Vorfaktoren[n2])^Exponenten[n2].nenner*Radikanten^Exponenten[n2].zaehler
      new(LinkeSeite);
      LinkeSeite^.Opera:=005;
      new(LinkeSeite^.Arg1);
      LinkeSeite^.Arg1^.Opera:=006;
      LinkeSeite^.Arg1^.Arg1:=TTKopieVon(Vorfaktoren[n2]);
      new(LinkeSeite^.Arg1^.Arg2);
      LinkeSeite^.Arg1^.Arg2^.Opera:=001;
      LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ.Zaehler:=copy(Exponenten[n2].Nenner);
      LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ.Nenner :=GNZeins;
      LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ.Negativ:=false;
      new(LinkeSeite^.Arg2);
      LinkeSeite^.Arg2^.Opera:=006;
      LinkeSeite^.Arg2^.Arg1:=TTKopieVon(Radikanten[n2]);
      new(LinkeSeite^.Arg2^.Arg2);
      LinkeSeite^.Arg2^.Arg2^.Opera:=001;
      LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ.Zaehler:=copy(Exponenten[n2].Zaehler);
      LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ.Nenner :=GNZeins;
      LinkeSeite^.Arg2^.Arg2^.ZahlGRaZ.Negativ:=false;

      // RechteSeite:=(RechteSeite)^Exponenten[n2].nenner;
      ZwSpA:=RechteSeite;
      new(RechteSeite);
      RechteSeite^.Opera:=006;
      RechteSeite^.Arg1:=ZwSpA;
      new(RechteSeite^.Arg2);
      RechteSeite^.Arg2^.Opera:=001;
      RechteSeite^.Arg2^.ZahlGRaZ.Zaehler:=copy(Exponenten[n2].Nenner);
      RechteSeite^.Arg2^.ZahlGRaZ.Nenner :=GNZeins;
      RechteSeite^.Arg2^.ZahlGRaZ.Negativ:=false;

      //Nun wird der Term in Normalform gebracht: LinkeSeite:=LinkeSeite + (-1)*RechteSeite
      ZwSpB:=LinkeSeite;
      new(LinkeSeite);
      LinkeSeite^.Opera:=004;
      LinkeSeite^.Arg1:=ZwSpB;
      new(LinkeSeite^.Arg2);
      LinkeSeite^.Arg2^.Opera:=005;
      new(LinkeSeite^.Arg2^.Arg1);
      LinkeSeite^.Arg2^.Arg1^.Opera:=001;
      LinkeSeite^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                           // (-1)
      LinkeSeite^.Arg2^.Arg2:=RechteSeite;

      for n:=0 to length(SummandForm)-1 do TTTermFreigabe(SummandForm[n]);
      SummandForm:= TTTermToSummandForm(LinkeSeite);
      RESULT:=TTPotenzLoeser(SummandForm,Unbekannte);                                                      // Löst die durch das Potenzieren entstehende Polynom- bzw. Potenzgleichung
      TTTermFreigabe(LinkeSeite);
    end else if (AnzWurzeln<>0) and RadikantenGleich and NennerGleich then                                 // 5. ================================================================================
    begin  // Alle Wurzeln haben den selben Radikanten und den selben Nenner.
           // KANN ERST VOLLSTÄNDIG GETESTET WERDEN, WENN POLYNOMGLEICHUNGEN VOM GRAD > 2 GELÖST WERDEN KÖNNEN
      If AnzQrdWurzeln<>0 then
      begin // Ausschließlich Quadratwurzeln und deren Potenzen vorhanden --> Lösung durch Quadrierung.
        RechteSeite:=nil;
        LinkeSeite:= nil;
        FaktorPTT:=nil;                                                                                    // Wurzeln werden alle ausgeklammert - FaktorPTT beinhaltet als Gesamtvorfaktor "die Klammer".
        for n:=0 to ArrayLaenge-1 do
        begin
          If GNZagleichb(Exponenten[n].nenner,1) then
          begin  // Rest: alles auf die rechte Seite abgezogen.
            if RechteSeite=nil then
            begin
              // RechteSeite:=(-1)*Vorfaktoren[n]*Radikanten[n]^Exponenten[n];
              new(RechteSeite);
              RechteSeite^.Opera:=005;
              new(RechteSeite^.Arg1);
              RechteSeite^.Arg1^.Opera:=001;
              RechteSeite^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                        // (-1)
              new(RechteSeite^.Arg2);
              RechteSeite^.Arg2^.Opera:=005;
              RechteSeite^.Arg2^.Arg1:=TTKopieVon(Vorfaktoren[n]);
              new(RechteSeite^.Arg2^.Arg2);
              RechteSeite^.Arg2^.Arg2^.Opera:=006;
              RechteSeite^.Arg2^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
              new(RechteSeite^.Arg2^.Arg2^.Arg2);
              RechteSeite^.Arg2^.Arg2^.Arg2^.Opera:=001;
              RechteSeite^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
            end else
            begin
              // RechteSeite:=(-1)*Vorfaktoren[n]*Radikanten[n]^Exponenten[n] + RechteSeite
              ZwSpB:=RechteSeite;
              new(RechteSeite);
              RechteSeite^.Opera:=004;
              new(RechteSeite^.Arg1);
              RechteSeite^.Arg1^.Opera:=005;
              new(RechteSeite^.Arg1^.Arg1);
              RechteSeite^.Arg1^.Arg1^.Opera:=001;
              RechteSeite^.Arg1^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                  // (-1)
              new(RechteSeite^.Arg1^.Arg2);
              RechteSeite^.Arg1^.Arg2^.Opera:=005;
              RechteSeite^.Arg1^.Arg2^.Arg1:=TTKopieVon(Vorfaktoren[n]);
              new(RechteSeite^.Arg1^.Arg2^.Arg2);
              RechteSeite^.Arg1^.Arg2^.Arg2^.Opera:=006;
              RechteSeite^.Arg1^.Arg2^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
              new(RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2);
              RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2^.Opera:=001;
              RechteSeite^.Arg1^.Arg2^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
              RechteSeite^.Arg2:=ZwSpB;                                                                    // + (alte) RechteSeite
            end; // if RechteSeite=nil else
          end else
          begin  // Wurzel:
            If LinkeSeite=nil then LinkeSeite:=TTKopieVon(Radikanten[n]);
            If GNZagleichb(Exponenten[n].zaehler,1) then
            begin
              If FaktorPTT=nil then FaktorPTT:= TTKopieVon(Vorfaktoren[n]) else
              begin
                ZwSpB:=FaktorPTT;
                new(FaktorPTT);
                FaktorPTT^.Opera:=004;
                FaktorPTT^.Arg1:=TTKopieVon(Vorfaktoren[n]);
                FaktorPTT^.Arg2:=ZwSpB;
              end; // if FaktorPTT=nil else
              TTTermFreigabe(Radikanten[n]);                                                               // Dies ist wichtig, da diese Radikanten zusammengestrichen (ausgeklammert) werden.
            end else
            begin  //Ganzzahlige Exponenten des Radikanten werden in den Vorfaktor geschoben: Es bleibt nur der Exponent (1/2); a*x^(3/2) --> (a*x)*x^(1/2)
              // ZwSpA:=Vorfaktoren[n]*Radikanten[n]^(Exponenten[n].zaehler div Exponenten[n].nenner)
              new(ZwSpA);
              ZwSpA^.Opera:=005;
              ZwSpA^.Arg1:=TTKopieVon(Vorfaktoren[n]);
              new(ZwSpA^.Arg2);
              ZwSpA^.Arg2^.Opera:=006;
              ZwSpA^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);                                                          // Hier finden die Radikanten im Vorfaktor selbst Verwendung.
              new(ZwSpA^.Arg2^.Arg2);
              ZwSpA^.Arg2^.Arg2^.Opera:=001;
              ZwSpA^.Arg2^.Arg2^.ZahlGRaZ.zaehler:=GNZdiv(Exponenten[n].zaehler,Exponenten[n].nenner);
              ZwSpA^.Arg2^.Arg2^.ZahlGRaZ.nenner:=GNZeins;
              ZwSpA^.Arg2^.Arg2^.ZahlGRaZ.negativ:=false;
              If FaktorPTT=nil then FaktorPTT:= ZwSpA else
              begin
                ZwSpB:=FaktorPTT;
                new(FaktorPTT);
                FaktorPTT^.Opera:=004;
                FaktorPTT^.Arg1:=ZwSpA;
                FaktorPTT^.Arg2:=ZwSpB;
              end; // if FaktorPTT=nil else
            end; // if Exponenten[n].zaehler=1 else
          end; // If Exponenten[n].nenner=1 else
        end; // for n
        // RechteSeite:=(RechteSeite)^(2)
        ZwSpB:=RechteSeite;
        new(RechteSeite);
        RechteSeite^.Opera:=006;
        RechteSeite^.Arg1:=ZwSpB;
        new(RechteSeite^.Arg2);
        RechteSeite^.Arg2^.Opera:=001;
        RechteSeite^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);

        // LinkeSeite:=FaktorPTT^2*LinkeSeite
        ZwSpB:=LinkeSeite;
        new(LinkeSeite);
        LinkeSeite^.Opera:=005;
        new(LinkeSeite^.Arg1);
        LinkeSeite^.Arg1^.Opera:=006;
        LinkeSeite^.Arg1^.Arg1:=FaktorPTT;
        new(LinkeSeite^.Arg1^.Arg2);
        LinkeSeite^.Arg1^.Arg2^.Opera:=001;
        LinkeSeite^.Arg1^.Arg2^.ZahlGRaZ:=WordToGRaZTyp(2,1,false);                                          // (2)
        LinkeSeite^.Arg2:=ZwSpB;

        // LinkeSeite:=LinkeSeite + (-1)*RechteSeite
        ZwSpB:=LinkeSeite;
        new(LinkeSeite);
        LinkeSeite^.Opera:=004;
        LinkeSeite^.Arg1:=ZwSpB;
        new(LinkeSeite^.Arg2);
        LinkeSeite^.Arg2^.Opera:=005;
        new(LinkeSeite^.Arg2^.Arg1);
        LinkeSeite^.Arg2^.Arg1^.Opera:=001;
        LinkeSeite^.Arg2^.Arg1^.ZahlGRaZ:=WordToGRaZTyp(1,1,true);                                           // (-1)
        LinkeSeite^.Arg2^.Arg2:=RechteSeite;

        for n:=0 to length(SummandForm)-1 do TTTermFreigabe(SummandForm[n]);
        SummandForm:= TTTermToSummandForm(LinkeSeite);
        RESULT:= TTPotenzLoeser(SummandForm,Unbekannte);                                                     // Löst die durch das Potenzieren entstehende Polynom- bzw. Potenzgleichung
        TTTermFreigabe(LinkeSeite);
      end else
      begin // Lösung durch Substitution.
        for n:=0 to length(SummandForm)-1 do TTTermFreigabe(SummandForm[n]);                                 // In diesem Fall wird die Summandform direkt neu festgelegt, ohne über TTTermToSummandForm gehen zu müssen.
        setlength(SummandForm, ArrayLaenge);
        // In jedem Summanden wird Unbekannte^(zaehler,nenner) durch (Unbekannte^(1,nenner))^(zaehler,1) bzw. Unbekannte^(zaehler,1) durch (Unbekannte^(1,nenner))^(zaehler*nenner,1) ersetzt --> Substitution: NeueUnbekannte:=Unbekannte^(1,nenner)
        // Nenner befindet sich als GNZTyp in Variable NennerVergleich.
        for n:=0 to ArrayLaenge-1 do
        begin
          If GNZagleichb(Exponenten[n].nenner,1) then
          begin
            If TTagleichb(Radikanten[n], Unbekannte) then
            begin
              // Radikanten:=Radikanten^(1/NennerVergleich)
              ZwSpA:=TTKopieVon(Radikanten[n]);
              new(Radikanten[n]);
              Radikanten[n]^.Opera:=006;
              Radikanten[n]^.Arg1:=ZwSpA;
              new(Radikanten[n]^.Arg2);
              Radikanten[n]^.Arg2^.Opera:=001;
              Radikanten[n]^.Arg2^.ZahlGRaZ.Zaehler:=GNZeins;
              Radikanten[n]^.Arg2^.ZahlGRaZ.Nenner :=copy(NennerVergleich);
              Radikanten[n]^.Arg2^.ZahlGRaZ.Negativ:=false;
              // Exponenten.Zaehler:=Exponenten.Zaehler*NennerVergleich  -  Nenner des Exponenten ist wegen obiger Abfrage 1
              Exponenten[n].Zaehler:=GNZmul(Exponenten[n].zaehler,NennerVergleich);
            end;
          end else
          begin
            // Im Fall Exponenten[n].nenner>1 ist unter Garantie TTagleichb(Radikanten[n], Unbekannte)
            // Radikanten:=Radikanten^(1/NennerVergleich)
            ZwSpA:=TTKopieVon(Radikanten[n]);
            new(Radikanten[n]);
            Radikanten[n]^.Opera:=006;
            Radikanten[n]^.Arg1:=ZwSpA;
            new(Radikanten[n]^.Arg2);
            Radikanten[n]^.Arg2^.Opera:=001;
            Radikanten[n]^.Arg2^.ZahlGRaZ.Zaehler:=GNZeins;
            Radikanten[n]^.Arg2^.ZahlGRaZ.Nenner :=copy(NennerVergleich);
            Radikanten[n]^.Arg2^.ZahlGRaZ.Negativ:=false;
            // Exponenten.Zaehler:=Exponenten.Zaehler, Exponenten.Nenner:=1;
            Exponenten[n].Nenner:=GNZeins;
          end; // If Exponenten[n].nenner=1 else
          // SummandForm[n]:=Vorfaktoren[n]*Radikanten[n]^Exponenten[n];
          new(SummandForm[n]);                                                                               // Neuaufbau der SummandForm.
          SummandForm[n]^.Opera:=005;
          SummandForm[n]^.Arg1:=TTKopieVon(Vorfaktoren[n]);
          new(SummandForm[n]^.Arg2);
          SummandForm[n]^.Arg2^.Opera:=006;
          SummandForm[n]^.Arg2^.Arg1:=TTKopieVon(Radikanten[n]);
          new(SummandForm[n]^.Arg2^.Arg2);
          SummandForm[n]^.Arg2^.Arg2^.Opera:=001;
          SummandForm[n]^.Arg2^.Arg2^.ZahlGRaZ:=GRaZCopy(Exponenten[n]);
        end; // for n
        // JETZT: Potenzlöser SummandForm lösen lassen. Dann die Ergebnisse mit 3 potenzieren.
        new(ZwSpA);                                                                                        // Substitution: ZwSpA:=Unbekannte^(1/NennerVergleich)
        ZwSpA^.Opera:=006;
        ZwSpA^.Arg1:=TTKopieVon(Unbekannte);
        new(ZwSpA^.Arg2);
        ZwSpA^.Arg2^.Opera:=001;
        ZwSpA^.Arg2^.ZahlGRaZ.Zaehler:=GNZeins;
        ZwSpA^.Arg2^.ZahlGRaZ.Nenner := copy(NennerVergleich);
        ZwSpA^.Arg2^.ZahlGRaZ.Negativ:=false;

        RESULT:=TTPotenzLoeser(SummandForm,ZwSpA);
        TTTermFreigabe(ZwSpA);
        for n:=0 to length(RESULT)-1 do
        begin
          //RESULT:=RESULT^NennerVergleich
          ZwSpA:=RESULT[n];
          new(RESULT[n]);
          RESULT[n]^.Opera:=006;
          RESULT[n]^.Arg1:=ZwSpA;
          new(RESULT[n]^.Arg2);
          RESULT[n]^.Arg2^.Opera:=001;
          RESULT[n]^.Arg2^.ZahlGRaZ.Zaehler:=copy(NennerVergleich);
          RESULT[n]^.Arg2^.ZahlGRaZ.Nenner :=GNZeins;
          RESULT[n]^.Arg2^.ZahlGRaZ.Negativ:=false;
          showmessage(TermTypToStr(RESULT[n],0));
          TTEntwicklung(RESULT[n]);                                                                        // HINWEIS: Sollte in LoeseGleichung TTEntwicklung einmal aufgerufen werden, kann diese Zeile aus Geschwindigkeitsgründen entfernt werden.
        end; // for n
      end; // If AnzQrdWurzeln<>0 else
    end else // if (AnzWurzeln<>0) and RadikantenGleich and NennerGleich
    begin
        inc(LoesAnz);
        setlength(RESULT,LoesAnz);
        new(RESULT[LoesAnz-1]);
        RESULT[LoesAnz-1]^.Opera:=002;
        RESULT[LoesAnz-1]^.Konstante:=true;
        RESULT[LoesAnz-1]^.Varname:='_weitere_Lösungen_möglich';                                          // Aufgrund fehlender Implementierung von Lösungsalgorithmen
    end;
  end else  // if GleichungLoesbar
  begin
    // D.h. die Gleichung kann nicht mit PotenzLoeser gelöst werden. So lange keine anderen Lösungsalgorithmen implementiert sind, folgende 6 Zeilen:
    inc(LoesAnz);
    setlength(RESULT,LoesAnz);
    new(RESULT[LoesAnz-1]);
    RESULT[LoesAnz-1]^.Opera:=002;
    RESULT[LoesAnz-1]^.Konstante:=true;
    RESULT[LoesAnz-1]^.Varname:='_weitere_Lösungen_möglich';                                              // Aufgrund fehlender Implementierung von Lösungsalgorithmen
  end; // if GleichungLoesbar else

  // Speicher Freigeben:
  for n:=0 to ArrayLaenge-1 do
  begin
    If VorFaktoren[n]<>nil then TTTermFreigabe(VorFaktoren[n]);
    If Radikanten[n]<>nil then TTTermFreigabe(Radikanten[n]);
  end;
end; // TTPotenzLoeser
