{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


procedure tAnalyse.FEing(funktion:string);  //Eingabe-Funktion für FunkWert: f_Wert
var n:integer;
    s:string;
begin
  {Initialisierung:
  Überprüfung des Strings, bzw. der Funktion und Fehlerauswertung
  sowie Variablenbesetzung:}
  n:=0;
  Err:=0;
  If funktion<>'' then
  begin
    repeat
      inc(n);
      s:=funktion[n];
      if ((s='P') or (s='p')) and ((funktion[n+1]='h')or(funktion[n+1]='H'))   //Fuer Polarkoordinaten
       and ((funktion[n+2]='i')or(funktion[n+2]='I')) then                     //Muss ggf. spaeter in eigene FEing-Prozedur gelagert werden.
      begin                                                                    //waere zumindest "sauberer".
        delete(funktion,n,3);
        insert('x',funktion,n);
      end;
    until n>=length(funktion);
    funktion:=TermKorrPruef(funktion);
  end else Err:=6;
  If Err=0 then ZeichenPruef_FWert(funktion);
  If Err=0 then
  begin
    If f_PTermTy<>nil then TTTermFreigabe(f_PTermTy);  //Speicher des alten Terms muss zunaechst freigegeben werden.
    f_PTermTy:=StrToTermtyp(funktion);
  end;
end; //FEing


procedure tAnalyse.FWert_polar(phi:double; var r,x,y:double);
var ZwSp:double;
begin
  Err:=0;
  ZwSp:=FunkWert_NM(f_PTermTy,phi);
  If Err=0 then
  begin
    r:=ZwSp;
    x:=r*cos(phi);
    y:=r*sin(phi);
  end else r:=0;
end; //FWert


function tAnalyse.FWert(Xwert:double):double;
begin
  If f_PTermTy<>nil then
  begin
    Err:=0;
    FWert:=FunkWert_NM(f_PTermTy,XWert);
  end;
  If Err<>0 then FWert:=0;
end; //FWert

function tAnalyse.Error:integer;
begin
  Error:=err;
end;

procedure tAnalyse.ResetError;
begin
  Err:=0;
end; // ResetError


//==================================================================================================
//***  Schnittstelle für die Konsole ***

function tAnalyse.SAbleitung(FunktionStr:string; VariableStr:string):string;
var Funktion,Variable,Ableitung: PTermTyp;
begin
  FunktionStr:=TermKorrPruef(FunktionStr);
  If Err=0 then VariableStr:=TermKorrPruef(VariableStr);
  If Err=0 then
  begin
    Funktion:= StrToTermTyp(FunktionStr);
    Variable:= StrToTermTyp(VariableStr);
    Ableitung:=TTAbleitung(Funktion,Variable);
    TTEinzelklammernAufloesen(Ableitung);                                                           // Die Ableitung soll vereinfacht und mit ausmultiplizierten Einzelklammern dargestellt werden.
    TTVereinfachung(Ableitung);
    SAbleitung:=TermTypToStr(Ableitung,0);

    TTTermfreigabe(Funktion);
    TTTermfreigabe(Variable);
    TTTermfreigabe(Ableitung);
  end else SAbleitung:='';
end; // SAbleitung - OVERLOADED

function tAnalyse.SAbleitung(FunktionStr:string; VariableStr:string; VielfachheitStr:string):string;
var Funktion,Variable,Ableitung,ZwSp: PTermTyp;
    n,Vielfachheit:dword;
begin
  Ableitung:=nil;
  FunktionStr:=TermKorrPruef(FunktionStr);
  If Err=0 then VariableStr:=TermKorrPruef(VariableStr);
  If (IstNatuerlicheZahl(VielfachheitStr)=false)or(length(VielfachheitStr)>5) then Err:=7;
  If Err=0 then
  begin
    Funktion:= StrToTermTyp(FunktionStr);
    Variable:= StrToTermTyp(VariableStr);
    Ableitung:=TTAbleitung(Funktion,Variable);
    Vielfachheit:=StrToInt(VielfachheitStr);
    If Vielfachheit>1 then for n:=2 to Vielfachheit do
    begin
      TTVereinfachung(Ableitung);
      ZwSp:=Ableitung;
      Ableitung:=TTAbleitung(Ableitung,Variable);
      TTTermfreigabe(ZwSp);
    end; // if for
    If not (Ableitung = nil) then
    begin
      TTEinzelklammernAufloesen(Ableitung);                                                           // Die Ableitung soll vereinfacht und mit ausmultiplizierten Einzelklammern dargestellt werden.
      TTVereinfachung(Ableitung);
    end;
    If VielFachheit=0 then RESULT:=FunktionStr else RESULT:=TermTypToStr(Ableitung,0);

    TTTermfreigabe(Funktion);
    TTTermfreigabe(Variable);
    TTTermfreigabe(Ableitung);
  end else SAbleitung:='';
end; // SAbleitung  Vielfachheit-fache Ableitung - OVERLOADED

function tAnalyse.SBasiswechsel(QBasisStr,ZBasisStr,ZahlStr:string):string;
var QBasisWrd, ZBasisWrd, ZahlLaenge, ZwSp, n, n2: dword;
    Erg, Zahl:GNZTyp;
begin
  RESULT:='';
  If (IstNatuerlicheZahl(QBasisStr))and(length(QBasisStr)<10)and(IstNatuerlicheZahl(ZBasisStr))and(length(ZBasisStr)<10) then
  begin
    QBasisWrd:=StrToInt(QBasisStr);
    ZBasisWrd:=StrToInt(ZBasisStr);
    If (QBasisWrd<2)or(QBasisWrd>=GNZ_GlobZahlenbasis)or(ZBasisWrd<2)or(ZBasisWrd>=GNZ_GlobZahlenbasis) then Err:=12;
    // PARSEN des ZahlStr:
    If Err=0 then
    begin
      If QBasisWrd<=10 then
      begin                                                                    // <--- QBasis <= 10
        ZahlLaenge:=length(ZahlStr);
        setlength(Zahl, ZahlLaenge);
        for n:=1 to ZahlLaenge do
        begin
          Zahl[ZahlLaenge-n] := ord(ZahlStr[n])-48;
          If Zahl[ZahlLaenge-n]>=QBasisWrd then Err:=9;                        // Sichert z.B. den Eigabefehler 11011030110011101001 bzgl. Dualsystem ab.
        end; // for
      end else if QBasisWrd<=16 then
      begin                                                                    // <--- QBasis <= 16
        LowerCase(ZahlStr);
        ZahlLaenge:=length(ZahlStr);
        setlength(Zahl, ZahlLaenge);
        for n:=1 to ZahlLaenge do
        begin
          ZwSp:=ord(ZahlStr[n]);
          If (ZwSp>=48)and(ZwSp<=57) then Zahl[ZahlLaenge-n] := ZwSp-48
           else if (ZwSp>=97)and(ZwSp<=97-(QBasisWrd-11)) then
           Zahl[ZahlLaenge-n] := ZwSp-87
           else Err:=9;
        end; // for
      end else
      begin                                                                    // <--- QBasis > 16
        n:=length(ZahlStr); n2:=0; ZahlLaenge:=0;
        repeat
          dec(n);
          If (ZahlStr[n]='|')and(n2<>0) then
          begin
            if n2<=9 then
            begin
              inc(ZahlLaenge);
              setlength(Zahl,ZahlLaenge);
              Zahl[ZahlLaenge-1]:=StrToInt(MidStr(ZahlStr,n+1,n2));
            end else Err:=12;
            n2:=0;
          end else if (ord(ZahlStr[n])>=48)and(ord(ZahlStr[n])<=57) then inc(n2) else if ZahlStr[n]<>'|' then Err:=9;
        until (n=1)or(Err<>0);
        If ZahlLaenge=0 then Err:=15;
      end; // if QBasisWrd<=10,16 else
    end; // if Err=0

    // GENERIEREN des Strings:
    If Err=0 then
    begin
      Erg:=GNZZBasiswechsel(QBasisWrd,ZBasisWrd,Zahl);
      If ZBasisWrd<=10 then
      begin                                                                    // <--- ZBasis <= 10
        for n:=0 to length(Erg)-1 do RESULT := chr(Erg[n]+48) + RESULT;
      end else if ZBasisWrd<=16 then
      begin                                                                    // <--- ZBasis <=16
        for n:=0 to length(Erg)-1 do
         if Erg[n]<10 then RESULT := chr(Erg[n]+48) + RESULT else RESULT := chr(Erg[n]+87) + RESULT;
      end else
      begin                                                                    // <--- ZBasis > 16
        for n:=0 to length(Erg)-1 do RESULT := IntToStr(Erg[n]) + '|' + RESULT;
        RESULT:='|' + RESULT;
      end;
    end; // if Err=0

  end else Err:=7;
end;  // SBasiswechsel

function tAnalyse.SDiv(DividentStr,DivisorStr:string):string;
begin
  If (not IstNatuerlicheZahl(DividentStr))or(not IstNatuerlicheZahl(DivisorStr)) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZdiv(StrToGNZTyp(DividentStr),StrToGNZTyp(DivisorStr))) else RESULT:='';
end; // SDiv

function tAnalyse.SEntwicklung(TermStr:string):string;
var Term: PTermTyp;
begin
  TermStr:=TermKorrPruef(TermStr);
  If Err=0 then
  begin
    Term:=StrToTermtyp(TermStr);
    TTVereinfachung(Term);                                                          // Damit z.B. (x+y)^(2*3) zu (x+y)^6 wird und entwickelt werden kann.
    TTEntwicklung(Term);
    TTVereinfachung(Term);
    SEntwicklung:=TermTypToStr(Term,0);
    TTTermfreigabe(Term);
  end else SEntwicklung:='';
end; // SEntwicklung;

function tAnalyse.SFakultaet(ZahlStr:string):string;
begin
  If not IstNatuerlicheZahl(ZahlStr) then Err:=7;
  If length(ZahlStr)>9 then Err:=12;                                                          // Schutz wegen StrToInt unten.
  If Err=0 then RESULT:=GNZTypToStr(GNZFakultaet(StrToInt(ZahlStr))) else RESULT:='';
end; // SFakultaet

function tAnalyse.SNueberK(NStr,KStr:string):string;
begin
  If (not IstNatuerlicheZahl(NStr))or(not IstNatuerlicheZahl(KStr)) then Err:=7;
  If (length(NStr)>9)or(length(KStr)>9) then Err:=12;
  If Err=0 then RESULT:=GNZTypToStr(GNZNueberK(StrToInt(NStr),StrToInt(KStr))) else RESULT:='';
end; // SNueberK

function tAnalyse.Sggt(aStr,bStr:string):string;
begin
  If (not IstNatuerlicheZahl(aStr))or(not IstNatuerlicheZahl(bStr)) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZggt(StrToGNZTyp(aStr),StrToGNZTyp(bStr))) else RESULT:='';
end; // Sggt

function tAnalyse.SIstPrim(ZahlStr:string):string;
begin
  If not IstNatuerlicheZahl(ZahlStr) then Err:=7;
  If Err=0 then begin if GNZIstPrim(StrToGNZTyp(ZahlStr)) then RESULT:='wahr' else RESULT:='falsch' end else RESULT:='';
end; // SIstPrim

function tAnalyse.SMillerRabinPrim(zahlStr,zeugeStr:string):string;
begin
  If (not IstNatuerlicheZahl(zahlStr))or(not IstNatuerlicheZahl(zeugeStr)) then Err:=7;
  If Err=0 then begin if GNZmillerrabinPrim(StrToGNZTyp(zahlStr),StrToGNZTyp(zeugeStr)) then RESULT:='wahr' else RESULT:='falsch' end else RESULT:='';
end;  // SMillerRabinPrim

function tAnalyse.SMillerRabinItera(zahlStr,iteraStr:string):string;
begin
  If (not IstNatuerlicheZahl(zahlStr))or(not IstNatuerlicheZahl(iteraStr)) then Err:=7;
  If length(iteraStr)>9 then Err:=7;
  If Err=0 then begin if GNZmillerrabinitera(StrToGNZTyp(zahlStr),StrToInt(iteraStr)) then RESULT:='wahr' else RESULT:='falsch' end else RESULT:='';
end;  // SMillerRabinItera

function tAnalyse.SMod(DividentStr,DivisorStr:string):string;
begin
  If (not IstNatuerlicheZahl(DividentStr))or(not IstNatuerlicheZahl(DivisorStr)) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZmod(StrToGNZTyp(DividentStr),StrToGNZTyp(DivisorStr))) else RESULT:='';
end; // SGNZMod

function tAnalyse.Skgv(aStr,bStr:string):string;
begin
  If (not IstNatuerlicheZahl(aStr))or(not IstNatuerlicheZahl(bStr)) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZkgv(StrToGNZTyp(aStr),StrToGNZTyp(bStr))) else RESULT:='';
end; // Skgv

function tAnalyse.SLoeseGleichung(GleichungStr,UnbekannteStr:string):string;
var RechteSeiteStr, LinkeSeiteStr:string;
    RechteSeite, LinkeSeite, Unbekannte: PTermTyp;
    Ergebnis: PTermTypArray;
    n: dword;
begin
  n:=pos('=',GleichungStr);
  If (n<=1)or(n=length(GleichungStr)) then Err:=19;
  If Err=0 then
  begin
    LinkeSeiteStr:=TermKorrPruef(LeftStr(GleichungStr,n-1));
    RechteSeiteStr:=TermKorrPruef(RightStr(GleichungStr,length(GleichungStr)-n));
    UnbekannteStr:=TermKorrPruef(UnbekannteStr);
    If (LinkeSeiteStr='')or(RechteSeiteStr='') then Err:=19;
    If UnbekannteStr='' then Err:=9;
  end;
  If Err = 0 then
  begin
    LinkeSeite := StrToTermTyp(LinkeSeiteStr);
    RechteSeite:= StrToTermTyp(RechteSeiteStr);
    Unbekannte := StrToTermTyp(UnbekannteStr);
    Ergebnis := TTLoeseGleichung(LinkeSeite,RechteSeite,Unbekannte);
    If (Ergebnis <> nil)and(Err=0) then
    begin
      RESULT:='L={';
      for n := 0 to length(Ergebnis)-1 do RESULT:=RESULT + TermTypToStr(Ergebnis[n],0) + ';';      // "0": Zahlen werden nicht durch Dezimalbruchdarstellung ersetzt.
      delete(RESULT,length(RESULT),1);                                                             // löscht das letzte ';'.
      RESULT:=RESULT + '}';
      for n := 0 to length(Ergebnis)-1 do TTTermfreigabe(Ergebnis[n]);                             // Von Ergebnispointern belegter Speicher wird freigegeben.
    end else RESULT:='L={}';                                                                         // ... RESULT darf daher von der Konsole nicht vereinfacht werden --> würde zu einem Error führen.
    TTTermfreigabe(LinkeSeite);
    TTTermfreigabe(RechteSeite);
    TTTermfreigabe(Unbekannte);
  end else RESULT:=''; // Err = 0
end; // SLoeseGleichung

function tAnalyse.SPrimDanach(ZahlStr:string):string;
begin
  If not IstNatuerlicheZahl(ZahlStr) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZPrimDanach(StrToGNZTyp(ZahlStr))) else RESULT:='';
end; // SPrimDanach

function tAnalyse.SPrimDavor(ZahlStr:string):string;
begin
  If not IstNatuerlicheZahl(ZahlStr) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZPrimDavor(StrToGNZTyp(ZahlStr))) else RESULT:='';
end; // SPrimDavor

function tAnalyse.SPrimFaktZerl(ZahlStr:string):string;
var Term: PTermTyp;
begin
  If not IstNatuerlicheZahl(ZahlStr) then Err:=7;
  If Err=0 then
  begin
    Term:=GNZPrimFaktZerl(StrToGNZTyp(ZahlStr));
    RESULT:=TermTypToStr(Term,0);
    TTTermFreigabe(Term);
  end else RESULT:='';
end; // SPrimFaktZerl

function tAnalyse.SPrimzahlListe(VonStr,BisStr:string):string;
var n: dword;
    ErgebnisListe: GNZListeTyp;
begin
  If (not IstNatuerlicheZahl(VonStr))or(not IstNatuerlicheZahl(BisStr)) then Err:=7;
  If Err=0 then
  begin
    ErgebnisListe:= GNZPrimzahlListe(StrToGNZTyp(VonStr),StrToGNZTyp(BisStr));
    If ErgebnisListe=nil then RESULT:='[ ]' else
    begin
      RESULT:='[ ';
      for n:=0 to length(ErgebnisListe)-1 do RESULT:=RESULT + GNZTypToStr(ErgebnisListe[n]) + ' ';
      RESULT:=RESULT + ']';
    end; // If ErgebnisListe=nil else
  end else RESULT:=''; // If Err=0 else
end;

function tAnalyse.SPotenzModulo(basisStr,exponentStr,moduloStr:string):string;
begin
  If (not IstNatuerlicheZahl(basisStr))or(not IstNatuerlicheZahl(exponentStr))or(not IstNatuerlicheZahl(moduloStr)) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZPotenzModulo(StrToGNZTyp(basisStr),StrToGNZTyp(exponentStr),StrToGNZTyp(moduloStr))) else RESULT:='';
end; // Skgv

function tAnalyse.STaylorEntwicklung(TermStr, VariableStr, EntwPunktStr, PotenzStr:string):string;
var Term, Variable, EntwPunkt, Erg:PTermTyp;
begin
  TermStr:=TermKorrPruef(TermStr);
  VariableStr:=TermKorrPruef(VariableStr);
  EntwPunktStr:=TermKorrPruef(EntwPunktStr);
  If (not IstNatuerlicheZahl(PotenzStr))or(length(Potenzstr)>9) then Err:=7;
  If Err=0 then
  begin
    Term:=StrToTermTyp(TermStr);
    Variable:=StrToTermTyp(VariableStr);
    EntwPunkt:=StrToTermTyp(EntwPunktStr);
    Erg:=TTTaylorEntwicklung(Term,Variable,EntwPunkt,StrToInt(PotenzStr));
    TTVereinfachung(Erg);
    RESULT:=TermTypToStr(Erg,0);
    TTTermFreigabe(Erg);
    TTTermFreigabe(Term);
    TTTermFreigabe(Variable);
    TTTermFreigabe(EntwPunkt);
  end else RESULT:=''; // If Err=0 then else
end; // STaylorEntwicklung

function tAnalyse.SVereinfachung(TermStr:string; DezimalbruchZiffernAnz:word):string;
var Term: PTermTyp;
begin
  TermStr:=TermKorrPruef(TermStr);
  If Err=0 then
  begin
    Term:=StrToTermtyp(TermStr);
    TTVereinfachung(Term);
    SVereinfachung:=TermTypToStr(Term, DezimalbruchZiffernAnz);
    TTTermfreigabe(Term);
  end else SVereinfachung:='';
end; // SVereinfachung

function tAnalyse.SGNZRandom(zahlStr:string):string;
begin
  If not IstNatuerlicheZahl(zahlStr) then Err:=7;
  If Err=0 then RESULT:=GNZTypToStr(GNZRandom(StrToGNZTyp(zahlStr))) else RESULT:='';
end; // SGNZRandom
