{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


unit uFuncEdit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Grids, StdCtrls, Buttons, ExtCtrls, Spin, Menus, uFuncListDB, uDrawClass,
  u_prm_Settings, lclproc, ComCtrls,uPointEdit;

type

  { TFFuncEdit }

  TFFuncEdit = class(TForm)
    CB_Active: TCheckBox;
    CB_Gradient: TComboBox;
    CDiaFunc: TColorDialog;
    E_Unsharp: TEdit;
    E_Xmin: TEdit;
    E_Xmax: TEdit;
    FSE_CurvWidth: TFloatSpinEdit;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Img_Preview: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    LB_AA_Mode_Fedit: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LE_FuncName: TLabeledEdit;
    LE_FuncText: TLabeledEdit;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MM_ignore_perf: TMenuItem;
    MM_ignore_curvWidth: TMenuItem;
    MM_ignore_unsharp: TMenuItem;
    MM_newList: TMenuItem;
    MenuItem15: TMenuItem;
    MM_DrawList: TMenuItem;
    MM_showFile: TMenuItem;
    MM_OpenList: TMenuItem;
    MM_Save: TMenuItem;
    MM_SaveAs: TMenuItem;
    MM_IntegrateList: TMenuItem;
    MenuItem6: TMenuItem;
    MM_Preview: TMenuItem;
    MM_ignore_Intervals: TMenuItem;
    MM_Ignore_Cols: TMenuItem;
    OpenDialog1: TOpenDialog;
    PC_funcEdit: TPageControl;
    SaveDialog1: TSaveDialog;
    SG_Func: TStringGrid;
    SB_RandomCol: TSpeedButton;
    SB_PEdit: TSpeedButton;
    S_Col_1: TShape;
    S_Col_2: TShape;
    SB_del: TSpeedButton;
    SB_OK: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SE_AA_hor: TSpinEdit;
    SE_AA_ver: TSpinEdit;
    TB_TCount: TTrackBar;
    TB_AA_Mode_Fedit: TTrackBar;
    TS_FEdit_Basic: TTabSheet;
    TS_FEdit_Advanced: TTabSheet;
    procedure MyOnExit(Sender: TObject);
    procedure E_UnsharpExit(Sender: TObject);
    procedure E_XmaxExit(Sender: TObject);
    procedure E_XminExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FSE_CurvWidthExit(Sender: TObject);
    procedure LE_FuncNameExit(Sender: TObject);
    procedure LE_FuncTextExit(Sender: TObject);
    procedure LE_FuncTextKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuItem2Click(Sender: TObject);
    procedure MM_Ignore_ColsClick(Sender: TObject);
    procedure MM_ignore_curvWidthClick(Sender: TObject);
    procedure MM_ignore_IntervalsClick(Sender: TObject);
    procedure MM_ignore_perfClick(Sender: TObject);
    procedure MM_ignore_unsharpClick(Sender: TObject);
    procedure MM_newListClick(Sender: TObject);
    procedure MM_DrawListClick(Sender: TObject);
    procedure MM_PreviewClick(Sender: TObject);
    procedure MM_showFileClick(Sender: TObject);
    procedure MM_OpenListClick(Sender: TObject);
    procedure MM_SaveClick(Sender: TObject);
    procedure MM_SaveAsClick(Sender: TObject);
    procedure MM_IntegrateListClick(Sender: TObject);
    procedure SB_PEditClick(Sender: TObject);
    procedure SB_RandomColClick(Sender: TObject);
    procedure SE_AA_horExit(Sender: TObject);
    procedure SE_AA_verExit(Sender: TObject);
    procedure SG_FuncDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure SG_FuncMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SG_FuncMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SG_FuncSelection(Sender: TObject; aCol, aRow: Integer);
    procedure SB_delClick(Sender: TObject);
    procedure SB_OKClick(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure S_Col_1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure S_Col_2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TB_AA_Mode_FeditChange(Sender: TObject);
    procedure TB_AA_Mode_FeditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TB_TCountMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    PreView:tDrawClass;
    LocalSet:TGlobalSet;
    SelIndex:LongInt;
    WorkFuncList:tFuncList;
    procedure OptionsToGui;
    procedure GuiToOptions;
    function CurrentGuiToFunc (var Func:tFuncSet):boolean; //true, falls keine Fehler, sonst false
    Procedure CurrentFuncToGui (Func:tFuncSet);
    procedure ShowResults (loc_List:tFuncList);
    procedure TogglePreView (Prv_active:boolean);
  public
    { public declarations }
  end; 

var
  FFuncEdit: TFFuncEdit;

implementation
uses UMain;

{ TFFuncEdit }

procedure TFFuncEdit.FormCreate(Sender: TObject);
 var
   FMainRatio:Double;
begin
  Decimalseparator:=',';
  preview:=nil;
  setlength(WorkfuncList,0);
  SelIndex:=-1;
  FunclistDB.ListResults(WorkfuncList);
  randomize;
  LocalSet:=Cur_Settings;
end;

procedure TFFuncEdit.FormShow(Sender: TObject);
var
 funcSetbuf:tFuncSet;
begin
  {$ifdef linux}
    If Screen.PixelsPerInch>84 then FFUncEdit.SG_Func.Font.Height:=8;
    FFuncEdit.Font.Size:=9;
    FFuncEdit.Color:=rgbToColor(240,240,240);
    FFuncEdit.PC_funcEdit.Color:=clWhite;
  {$endif}
  FFuncEdit.OptionsToGui;
  FuncListDB.getdefaults(FuncSetBuf);
  FuncSetBuf.FuncString:='x^2';
  CurrentFuncToGui(FuncSetBuf);
  TogglePreview(FFuncEdit.MM_Preview.Checked);
  showresults(WorkfuncList);
end;

procedure TFFuncEdit.FSE_CurvWidthExit(Sender: TObject);
var actFunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.LE_FuncNameExit(Sender: TObject);
var
  actfunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.LE_FuncTextExit(Sender: TObject);
var
  actfunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.LE_FuncTextKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var
    actfunc:tFuncSet;
begin
  If (key = 13) and (LE_FuncText.text<>'') then begin
    key:= 0; //beep abschalten
    If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
  end;
end;

procedure TFFuncEdit.MenuItem2Click(Sender: TObject);
 var
   Str_buf:String;
begin
  Str_buf:=Konsole.BIOS(FFuncEdit.LE_FuncText.Text);
  If Str_buf<>'' then FFuncEdit.LE_FuncText.Text:=str_buf else begin
    FFuncEdit.LE_FuncText.Text:='';
    MessageDlg('*Eingabefehler*',Konsole.ErrorMsg, mtError, [mbOk] , 0);
  end;

end;

procedure TFFuncEdit.MM_Ignore_ColsClick(Sender: TObject);
begin
  If FFuncEdit.MM_Ignore_Cols.Checked=false then FFuncEdit.MM_ignore_Cols.Checked:=true else FFuncEdit.MM_ignore_Cols.Checked:=false;
  FFuncEdit.GuiToOptions;
end;

procedure TFFuncEdit.MM_ignore_curvWidthClick(Sender: TObject);
begin
  If FFuncEdit.MM_Ignore_CurvWidth.Checked=false then FFuncEdit.MM_ignore_CurvWidth.Checked:=true else FFuncEdit.MM_ignore_CurvWidth.Checked:=false;
  FFuncEdit.GuiToOptions;
end;

procedure TFFuncEdit.MM_ignore_IntervalsClick(Sender: TObject);
begin
  If FFuncEdit.MM_ignore_Intervals.Checked=false then FFuncEdit.MM_ignore_Intervals.Checked:=true else FFuncEdit.MM_ignore_Intervals.Checked:=false;
  FFuncEdit.GuiToOptions;
end;

procedure TFFuncEdit.MM_ignore_perfClick(Sender: TObject);
begin
  If FFuncEdit.MM_Ignore_perf.Checked=false then FFuncEdit.MM_ignore_perf.Checked:=true else FFuncEdit.MM_ignore_Perf.Checked:=false;
  GuiToOptions;
end;

procedure TFFuncEdit.MM_ignore_unsharpClick(Sender: TObject);
begin
  If MM_Ignore_unsharp.Checked=false then MM_ignore_unsharp.Checked:=true else MM_ignore_unsharp.Checked:=false;
  GuiToOptions;
end;

  function TFFuncEdit.CurrentGuiToFunc (var Func:tFuncSet):boolean;
   var
     str_buf:String;
    begin
      result:=true;
      Func.AA_Level_hor:=SE_AA_hor.Value;
      Func.AA_Level_ver:=SE_AA_ver.Value;
      Func.ThreadCount:=TB_TCount.Position;
      Func.CurvWidth:=FSE_CurvWidth.Value;
      Func.AA_Mode:=TB_AA_Mode_Fedit.Position;
      Func.CurvCol:=S_Col_1.Brush.Color;
      Func.CurvCol2:=S_Col_2.Brush.Color;
      If CB_Gradient.Text='kein' then Func.CurvGrad:=-1;
      If CB_Gradient.Text='vertikal' then Func.CurvGrad:=0;
      If CB_Gradient.Text='horizontal' then Func.CurvGrad:=1;
      try
        Func.IntMin:=StrToFloat(E_Xmin.Text);
      except
        MessageDlg('*Eingabefehler*','Für den Intervall-Beginn darf nur eine reele Zahl eingetragen werden', mtError, [mbOk] , 0);
        result:=false;
      end;
      try
        Func.IntMax:=StrToFloat(E_Xmax.Text);
      except
        MessageDlg('*Eingabefehler*','Für das Intervall-Ende darf nur eine reele Zahl eingetragen werden', mtError, [mbOk] , 0);
        result:=false;
      end;
      If (Result=true) and (Func.IntMin>Func.IntMax)then begin
        Func.IntMin:=0; Func.IntMax:=0;
        MessageDlg('!Warnung!','Das Intervall-Minimum muss kleiner oder gleich(=>ohne Beschränkung) Intervall-Maximum sein. Es folgt eine Zurücksetzung', mtError, [mbOk] , 0);
      end;
      try
        If StrToFloat(E_Unsharp.Text)>0 then Func.unsharpnes:=StrToFloat(E_Unsharp.Text)
        else begin
          MessageDlg('*Eingabefehler*','Nur Zahlen >0 bitte!', mtError, [mbOk] , 0);
          result:=false;
        end;
      except
        MessageDlg('*Eingabefehler*','Für die Unschärfe darf nur eine positive reele Zahl eingetragen werden', mtError, [mbOk] , 0);
        result:=false;
      end;
      Func.Active:=CB_Active.Checked;
      Str_buf:=FMain.Prefilter(FFuncEdit.LE_FuncText.Text);
      If Str_Buf='' then begin
        result:=false;
        Func.FuncString:='';
        MessageDlg('*Eingabefehler*',Konsole.ErrorMsg, mtError, [mbOk] , 0);
      end else  Func.FuncString:=FFuncEdit.LE_FuncText.Text;
      func.FuncName:=LE_FuncName.Text;
    end;

  Procedure TFFuncEdit.CurrentFuncToGui (Func:tFuncSet);
    begin
      SE_AA_hor.Value:=Func.AA_Level_hor;
      SE_AA_ver.Value:=Func.AA_Level_ver;
      TB_TCount.Position:=Func.ThreadCount;
      Label12.Caption:=IntToStr(Func.ThreadCount)+' Threads';
      FSE_CurvWidth.Value:=Func.CurvWidth;
      S_Col_1.Brush.Color:=Func.CurvCol;
      S_Col_2.Brush.Color:=Func.CurvCol2;
      Case Func.CurvGrad of
       -1: CB_Gradient.Text:='kein';
        0:  CB_Gradient.Text:='vertikal';
        1:  CB_Gradient.Text:='horizontal';
      end;
      Case func.AA_Mode of
        1: LB_AA_Mode_Fedit.Caption:='ungepuffertes Tetragon';
        2: LB_AA_Mode_Fedit.Caption:='gepuffertes Hexagon';
        3: LB_AA_Mode_Fedit.Caption:='gepufferter Kreis';
        4: LB_AA_Mode_Fedit.Caption:='gepuffertes Rundeck';
      end;
      TB_AA_Mode_FEdit.Position:=func.AA_Mode;
      E_Xmin.Text:=FloatToStr(Func.IntMin);
      E_Xmax.Text:=FloatToStr(Func.IntMax);
      E_Unsharp.Text:=FloatToStr(Func.unsharpnes);
      CB_Active.Checked:=Func.Active;
      LE_Functext.Text:=func.FuncString;
      LE_FuncName.Text:=func.FuncName;
      If Preview<>nil then begin
        FFuncEdit.Img_Preview.Visible:=true;
        LocalSet:=Umain.ListSourceSettings;
        localSet.MainSizing.DrawResX:=FFuncEdit.Img_Preview.Width;
        LocalSet.MainSizing.DrawResY:=FFuncEdit.Img_Preview.Height;
        LocalSet.ColorSet.CurvCol:=Func.CurvCol;
        LocalSet.ColorSet.CurvCol2:=Func.CurvCol2;
        LocalSet.ColorSet.CurvGrad:=Func.CurvGrad;
        LocalSet.PerformanceSet.AA_Level_hor:=Func.AA_Level_hor;
        LocalSet.PerformanceSet.AA_Level_ver:=Func.AA_Level_ver;
        LocalSet.PerformanceSet.AA_mode:=Func.AA_mode;
        LocalSet.PerformanceSet.ThreadCount:=Func.ThreadCount;
        LocalSet.PerformanceSet.unsharpnes:=Func.unsharpnes;
        LocalSet.PerformanceSet.CurvWidth:=Func.CurvWidth;
        Preview.SetDrawEnv2D(Func.FuncString,LocalSet,Func.IntMin,Func.IntMax);
        Preview.Bildrueckgabe(Img_Preview);
      end else
        FFuncEdit.Img_Preview.Visible:=false;
    end;

  procedure tFFuncEdit.GuiToOptions;
   var
     Drwoptn:tDrawOptions;
    begin
      DrwOptn.ignoreCols:=FFuncEdit.MM_Ignore_Cols.checked;
      DrwOptn.ignoreCurvWidth:=FFuncEdit.MM_ignore_curvWidth.checked;
      DrwOptn.ignoreInts:=FFuncEdit.MM_ignore_Intervals.checked;
      DrwOptn.ignorePerf:=FFuncEdit.MM_ignore_perf.checked;
      DrwOptn.ignoreUnsharp:=FFuncEdit.MM_ignore_unsharp.checked;
      DrwOptn.Preview:=FFuncEdit.MM_Preview.Checked;
      FuncListDB.SetDrawOptions(DrwOptn);
    end;

  procedure tFFuncEdit.OptionsToGui;
   var
     Drwoptn:tDrawOptions;
    begin
      DrwOptn:=FuncListDB.GetDrawOptions;
      FFuncEdit.MM_Ignore_Cols.checked:=Drwoptn.ignoreCols;
      FFuncEdit.MM_ignore_curvWidth.checked:=DrwOptn.ignoreCurvWidth;
      FFuncEdit.MM_ignore_Intervals.checked:=DrwOptn.ignoreInts;
      FFuncEdit.MM_ignore_perf.checked:=DrwOptn.ignorePerf;
      FFuncEdit.MM_ignore_unsharp.checked:=DrwOptn.ignoreUnsharp;
      FFuncEdit.MM_Preview.Checked:=DrwOptn.Preview;
    end;

  procedure TFFuncEdit.ShowResults (loc_List:tFuncList);
  var
    z:dWord=0;
   begin
     SG_Func.RowCount:=1;
     SG_Func.ColCount:=11;
     SG_Func.AlternateColor:=$00C3FFD0;
     SG_Func.SelectedColor:=$00FF0000;
     while z < length(loc_List) do begin
       SG_Func.InsertColRow(false,SG_Func.RowCount);
       SG_Func.Cells[0,SG_Func.RowCount-1]:=IntToStr(z);
       SG_Func.Cells[1,SG_Func.RowCount-1]:=loc_List[z].FuncString;
       SG_Func.Cells[2,SG_Func.RowCount-1]:='';
       SG_Func.Cells[3,SG_Func.RowCount-1]:=FloatToStr(loc_List[z].CurvWidth);
       SG_Func.Cells[4,SG_Func.RowCount-1]:=FloatToStr(loc_List[z].unsharpnes);
       SG_Func.Cells[5,SG_Func.RowCount-1]:=FloatToStr(loc_List[z].IntMin);
       SG_Func.Cells[6,SG_Func.RowCount-1]:=FloatToStr(loc_List[z].IntMax);
       SG_Func.Cells[7,SG_Func.RowCount-1]:=IntToStr(loc_List[z].ThreadCount);
       If Loc_List[z].AA_Mode=1 then
         SG_Func.Cells[8,SG_Func.RowCount-1]:=IntToStr(loc_List[z].AA_Level_hor)+'x'+IntToStr(loc_List[z].AA_Level_ver)
       else
         SG_Func.Cells[8,SG_Func.RowCount-1]:=IntToStr(loc_List[z].AA_Level_hor)+'x'+IntToStr(loc_List[z].AA_Level_ver)+' r';
       if loc_List[z].Active then  SG_Func.Cells[9,SG_Func.RowCount-1]:='ja' else SG_Func.Cells[9,SG_Func.RowCount-1]:='nein';
       SG_Func.Cells[10,SG_Func.RowCount-1]:=loc_List[z].FuncName;
       inc(z,1);
     end;
     SelIndex:=-1;
     SB_OK.Enabled:=false;
     SB_del.Enabled:=false;
     SG_Func.Options:=[goFixedHorzLine,goHorzLine,goFixedVertLine,goVertline,goSmoothScroll];
   end;

  procedure TFFuncEdit.TogglePreView (Prv_active:boolean);
   Var
     FMainRatio:double;
     activeFunc:tFuncSet;
  begin
    If Prv_active then begin
      FMainRatio:=Cur_Settings.MainSizing.DrawResX/Cur_Settings.MainSizing.DrawResY;
      If FMainRatio>=1then begin
        FFuncEdit.Img_Preview.width:=160;
        FFuncEdit.Img_Preview.picture.bitmap.width:=160;
        FFuncEdit.Img_Preview.Height:=round(FFuncEdit.Img_Preview.width/FMainRatio);
        FFuncEdit.Img_Preview.Picture.Bitmap.Height:=round(FFuncEdit.Img_Preview.width/FMainRatio);
      end else begin
        FFuncEdit.Img_Preview.width:=round(FFuncEdit.Img_Preview.height*FMainRatio);
        FFuncEdit.Img_Preview.picture.bitmap.width:=round(FFuncEdit.Img_Preview.height*FMainRatio);
        FFuncEdit.Img_Preview.Height:=160;
        FFuncEdit.Img_Preview.Picture.Bitmap.Height:=160;
      end;
      if preview=nil then Preview:=tDrawClass.create;
    end else begin
      If Preview<>nil then begin
        PreView.free;
        PreView:=nil;
      end;
    end;
    If SelIndex>0 then CurrentFuncToGui(WorkFuncList[SelIndex-1]) else If CurrentGuiToFunc(activeFunc)=true then CurrentFuncToGui(activeFunc) else FFuncEdit.Img_Preview.Visible:=false;
    FFuncEdit.GuiToOptions;
  end;

procedure TFFuncEdit.MM_newListClick(Sender: TObject);
begin
  FuncListDB.StartNewFile;
  SelIndex:=-1;
  FuncListDB.ListResults(WorkFuncList);
  showresults(WorkFuncList);
  FFuncEdit.OptionsToGui;
  TogglePreview(FFuncEdit.MM_Preview.Checked);
  prm_Setmanager.DelSettingsBackUps(false);
end;

procedure TFFuncEdit.MM_DrawListClick(Sender: TObject);
begin
  If FuncListDB.Ergebnisse>0 then begin
    FFuncEdit.Close;
    if Fmain.MM_opt_Source_List.Checked=false then begin
      Fmain.MM_opt_Source_Main.Checked:=false;
      Fmain.MM_opt_Source_List.Checked:=true;
    end;
    UMain.Cur_Settings:=UMain.ListSourceSettings;
    FMain.updateGraph;
  end else MessageDlg('*Leere Liste*','Die aktive Liste muss mindestens eine eingetragene Funktion aufweisen, damit diese gezeichnet werden kann.',mtinformation,[MbOk],0);
end;

procedure TFFuncEdit.MM_PreviewClick(Sender: TObject);
 var
  FMainRatio:double;
begin
  If FFuncEdit.MM_Preview.Checked=false then begin
    FFuncEdit.MM_Preview.Checked:=true;
  end else begin
    FFuncEdit.MM_Preview.Checked:=false;
  end;
  TogglePreview(FFuncEdit.MM_Preview.Checked);
end;


procedure TFFuncEdit.MM_showFileClick(Sender: TObject);
var
  strbuf:utf8string;
begin
  strbuf:=FuncListDB.ShowFile;
  if length(StrBuf)>0 then MessageDlg('Aktive Datei',strbuf, mtinformation, [mbOk] , 0) else
    MessageDlg('Aktive Datei','Es ist keine Liste aus einer Datei geladen. Bitte das Speichern nicht vergessen, falls frische Liste erstellt!', mtinformation, [mbOk] , 0);
end;

procedure TFFuncEdit.MM_OpenListClick(Sender: TObject);
var
  strBuf:UTF8String;
begin
  if OpenDialog1.Execute=true then begin
    FuncListDB.openList(OpenDialog1.FileName);
    prm_Setmanager.DelSettingsBackUps(false);
    StrBuf:=UTF8Copy(OpenDialog1.FileName,1,UTF8length(OpenDialog1.FileName)-4)+'.pflset';
    If FileExists(UTF8ToSys(StrBuf)) then begin
      If MessageDlg('?Frage?','Es ist eine Settingsdatei zu dieser Liste vorhanden. Soll diese mitgeladen werden?', mtconfirmation, [mbYes,mbNo] , 0)=MrYes then prm_setmanager.LoadIniToGlobalSet(UMain.ListSourceSettings,StrBuf) else UMain.ListSourceSettings:=Umain.MainSourceSettings;
    end;
    FuncListDB.ListResults(WorkFuncList);
    showresults(WorkFuncList);
    OptionsToGui; //Muss vor TogglePreview stehen, damit eben die MM_Preview.Checked stimmt
    TogglePreview(FFuncEdit.MM_Preview.Checked);
  end;
end;

procedure TFFuncEdit.MM_SaveClick(Sender: TObject);
 var
   StrBuf:String;
begin
  if FuncListDB.saveList('')=true then begin      //Wenn etwas gesaved wurde
    StrBuf:=Copy(FuncListDB.ShowFile,1,length(FuncListDB.ShowFile)-4)+'.pflset';
    If MessageDlg('?Frage?','Soll auch die Settings-Datei gespeichert bzw. eine angelegt werden?', mtconfirmation, [mbYes,mbNo] , 0)=MrYes then prm_setmanager.SaveGlobalSetToIni(Umain.ListSourceSettings,StrBuf);
  end;
end;

procedure TFFuncEdit.MM_SaveAsClick(Sender: TObject);
var
   StrBuf:UTF8String;
begin
  if SaveDialog1.Execute=true then begin
    if FuncListDB.saveList(SaveDialog1.FileName)=true then begin //Wenn etwas gesaved wurde
      StrBuf:=UTF8Copy(SaveDialog1.FileName,1,UTF8length(SaveDialog1.FileName)-4)+'.pflset';
      If MessageDlg('?Frage?','Soll auch die Settings-Datei angelegt werden?', mtconfirmation, [mbYes,mbNo] , 0)=MrYes then prm_setmanager.SaveGlobalSetToIni(Umain.ListSourceSettings,StrBuf);
    end;
  end;
end;

procedure TFFuncEdit.MM_IntegrateListClick(Sender: TObject);
begin
  If FuncListDB.ShowFile<>'' then begin
    if OpenDialog1.Execute=true then begin
      FuncListDB.integrateList(OpenDialog1.FileName);
    end;
    FuncListDB.ListResults(WorkFuncList);
    showresults(WorkFuncList);
  end;
end;

procedure TFFuncEdit.SB_PEditClick(Sender: TObject);
begin
  FPointEdit:=tFPointEdit.Create(1,LE_FuncText.Text);
  FPointEdit.showmodal;
  FPointEdit.free;
end;

procedure TFFuncEdit.SB_RandomColClick(Sender: TObject);
var
  actfunc:tFuncSet;
begin
  S_Col_1.Brush.Color:=RgbToColor(random(256),random(256),random(256));
  S_Col_2.Brush.Color:=RgbToColor(random(256),random(256),random(256));
  If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.SE_AA_horExit(Sender: TObject);
  var actFunc:tFuncSet;
  buf_h,buf_v:word;
begin
  If FFuncEdit<>nil then begin
    try
      buf_h:=SE_AA_hor.value;
      buf_v:=SE_AA_ver.value;
      If TB_AA_Mode_Fedit.Position=1 then begin
        If (buf_h<256) and (buf_v<256) then begin
          If buf_h*buf_v>255 then buf_v:=trunc(255/buf_h);
        end;
        SE_AA_ver.value:=buf_v;
      end;
      If TB_AA_Mode_Fedit.Position>1 then begin
        If buf_h>64 then buf_h:=64;
        If buf_h*buf_v>64 then buf_v:=trunc(64/buf_h);
        SE_AA_ver.value:=buf_v;
        SE_AA_hor.Value:=buf_h;
      end;
    except
      SE_AA_hor.value:=1;
    end;
    If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
  end;
end;

procedure TFFuncEdit.SE_AA_verExit(Sender: TObject);
var actFunc:tFuncSet;
buf_h,buf_v:word;
begin
  If FFuncEdit<>nil then begin
    try
      buf_h:=SE_AA_hor.value;
      buf_v:=SE_AA_ver.value;
      If TB_AA_Mode_Fedit.Position=1 then begin
        If (buf_h<256) and (buf_v<256) then begin
          If buf_h*buf_v>255 then buf_h:=trunc(255/buf_v);
        end;
        SE_AA_hor.value:=buf_h;
      end;
      If TB_AA_Mode_Fedit.Position>1 then begin
        If buf_v>64 then buf_v:=64;
        If buf_h*buf_v>64 then buf_h:=trunc(64/buf_v);
        SE_AA_hor.value:=buf_h;
        SE_AA_ver.Value:=buf_v;
      end;
    except
      SE_AA_ver.value:=1;
    end;
    If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
  end;
end;

procedure TFFuncEdit.SG_FuncDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
begin
  If (aCol=2)and(aRow>0) then begin
    SG_Func.Canvas.Brush.Color:=WorkFuncList[aRow-1].CurvCol;
    If WorkFuncList[aRow-1].CurvGrad=0 then
      SG_Func.Canvas.GradientFill(arect,WorkFuncList[aRow-1].CurvCol,WorkFuncList[aRow-1].CurvCol2,gdvertical);
    If WorkFuncList[aRow-1].CurvGrad=1 then
      SG_Func.Canvas.GradientFill(arect,WorkFuncList[aRow-1].CurvCol,WorkFuncList[aRow-1].CurvCol2,gdhorizontal);
    If WorkFuncList[aRow-1].CurvGrad=-1 then
      SG_Func.Canvas.FillRect(arect);
  end;
end;

procedure TFFuncEdit.SG_FuncMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Sg_Func.Options:=[goRowSelect,goFixedHorzLine,goHorzLine,goFixedVertLine,goVertline,goSmoothScroll];
end;

procedure TFFuncEdit.SG_FuncMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If SelIndex>0 then begin
    CurrentFuncToGui(WorkFuncList[SelIndex-1]);
    SB_OK.Enabled:=true;
    SB_del.Enabled:=true;
  end;
end;


procedure TFFuncEdit.SG_FuncSelection(Sender: TObject; aCol, aRow: Integer);
begin
  SelIndex:=aRow;
end;

procedure TFFuncEdit.SB_delClick(Sender: TObject);
begin
  If (length(WorkfuncList)>0)and (SelIndex>-1)then begin
    FuncListDB.deletefunc(StrToInt(SG_Func.Cells[0,SelIndex]));
    FuncListDB.ListResults(WorkFuncList);
    showresults(WorkFuncList);
    FFuncEdit.CB_Active.Checked:=true;
  end;
end;

procedure TFFuncEdit.SB_OKClick(Sender: TObject);
var
  ActFunc:tFuncSet;
begin
  if CurrentGuiToFunc(ActFunc)=true then begin
    FuncListDB.ModifyList(SelIndex-1,ActFunc);
    FuncListDB.ListResults(WorkFuncList);
    showresults(WorkFuncList);
    FFuncEdit.CB_Active.Checked:=true;
  end;
end;

procedure TFFuncEdit.SpeedButton5Click(Sender: TObject);
 var
   ActFunc:tFuncSet;
   FuncText:String;
begin
  if CurrentGuiToFunc(ActFunc)=true then begin
    SelIndex:=-1;
    FuncListDB.ModifyList(SelIndex,ActFunc);
    FuncListDB.ListResults(WorkFuncList);
    showresults(WorkFuncList);
  end;
end;

procedure TFFuncEdit.S_Col_1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var actFunc:tFuncSet;
begin
  CDiaFunc.Color:=S_Col_1.Brush.Color;
  if CDiaFunc.Execute=true then begin
    S_Col_1.Brush.Color:=CDiaFunc.Color;
    If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
  end;
end;

procedure TFFuncEdit.S_Col_2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var actFunc:tFuncSet;
begin
  CDiaFunc.Color:=S_Col_2.Brush.Color;
  if CDiaFunc.Execute=true then begin
    S_Col_2.Brush.Color:=CDiaFunc.Color;
    If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
  end;
end;

procedure TFFuncEdit.TB_AA_Mode_FeditChange(Sender: TObject);
var
  ratio:double;
  buf:longInt;
begin
  If Preview<>nil then begin
    Case TB_AA_Mode_FEdit.Position of
      1: LB_AA_Mode_Fedit.Caption:='ungepuffertes Tetragon';
      2..4: begin
           buf:=SE_AA_hor.Value*SE_AA_ver.Value;
           if buf>64 then begin
             Ratio:=64/buf;
             SE_AA_Hor.Value:=trunc(SE_AA_Hor.Value*Sqrt(Ratio));
             SE_AA_Ver.Value:=trunc(SE_AA_Ver.Value*Sqrt(Ratio));
           end;
           Case TB_AA_Mode_FEdit.Position of
             2:LB_AA_Mode_FEdit.Caption:='gepuffertes Hexagon (max. 64xAA)';
             3:LB_AA_Mode_FEdit.Caption:='gepufferter Kreis (max. 64xAA)';
             4:LB_AA_Mode_FEdit.Caption:='gepuffertes Rundeck (max. 64xAA)';
           end;
         end;
    end;
  end;

end;

procedure TFFuncEdit.TB_AA_Mode_FeditMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  actFunc:tFuncSet;
begin
  If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.TB_TCountMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var actFunc:tFuncSet;
begin
   If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  If (FuncListDB.Ergebnisse=0)and(Fmain.MM_opt_Source_List.Checked=true) then begin
    Fmain.MM_opt_Source_Main.Checked:=true;
    Fmain.MM_opt_Source_List.Checked:=false;
    Cur_Settings:=MainSourceSettings;
    FMain.updateGraph;
  end;
  If Preview<>nil then begin
    PreView.free;
    PreView:=nil;
  end;
  WorkfuncList:=nil;
end;

procedure TFFuncEdit.E_UnsharpExit(Sender: TObject);
var
  ActFunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.MyOnExit(Sender: TObject);
var actFunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;


procedure TFFuncEdit.E_XmaxExit(Sender: TObject);
var actFunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;

procedure TFFuncEdit.E_XminExit(Sender: TObject);
  var actFunc:tFuncSet;
begin
  If FFuncEdit<>nil then If CurrentGuiToFunc(actFunc)=true then CurrentFuncToGui(actFunc);
end;



initialization
  {$I ufuncedit.lrs}

end.

