{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


unit UMain;

{$mode delphi}{$H+}

interface

uses
  Classes, math, SysUtils, FileUtil, LResources, Forms, Controls, Graphics,
  Dialogs, udrawclass, ExtCtrls, StdCtrls, ComCtrls, Menus, UEinstellungen,
  uFuncEdit, u_prm_settings, uFuncListDB, uPointEdit, uKonsole, uEqEdit,
  Buttons, LclProc, Grids{, defaulttranslator};


type Vector_2D=record
  x,y:double;
end;
type

  { TFMain }

  TFMain = class(TForm)
    Button1: TButton;
    CB_Mainfunc: TComboBox;
    CB_Konsole: TComboBox;
    Im_ScaleIco: TImage;
    MM_Module_EqEdit: TMenuItem;
    MM_File_png: TMenuItem;
    MM_Module_FuncEdit: TMenuItem;
    MM_Info: TMenuItem;
    MM_Info_about: TMenuItem;
    Im_ruler_ver: TImage;
    Im_ruler_hor: TImage;
    Im_MainGraph: TImage;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    MM_File_export: TMenuItem;
    MM_File_Bmp: TMenuItem;
    MM_File_Jgeg: TMenuItem;
    MM_opt_FuncSource: TMenuItem;
    MM_opt_Source_Main: TMenuItem;
    MM_opt_Source_List: TMenuItem;
    PM_refresh: TMenuItem;
    PM_ZoomMode: TMenuItem;
    PM_MoveMode: TMenuItem;
    PM_Navigator: TMenuItem;
    PM_Navi: TMenuItem;
    PM_undo: TMenuItem;
    MM_opt_navi_zoom: TMenuItem;
    MM_opt_navi_move: TMenuItem;
    MM_Opt_Navigator: TMenuItem;
    MM_Prm_Close: TMenuItem;
    MM_Einstellungen: TMenuItem;
    MM_Optionen: TMenuItem;
    MM_File: TMenuItem;
    MM_Module: TMenuItem;
    PC_Main: TPageControl;
    PM_ImgMain: TPopupMenu;
    SD_Main: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SB_PEdit: TSpeedButton;
    SG_Konsole: TStringGrid;
    Timer1: TTimer;
    TS_Konsole: TTabSheet;
    TS_graph: TTabSheet;
    procedure Button1Click(Sender: TObject);
    procedure CB_KonsoleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CB_MainfuncKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure CB_MainfuncSelect(Sender: TObject);
    procedure CB_KonsoleKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure Im_MainGraphMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure Im_MainGraphMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure Im_MainGraphMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MM_File_pngClick(Sender: TObject);
    procedure MM_Module_EqEditClick(Sender: TObject);
    procedure MM_Module_FuncEditClick(Sender: TObject);
    procedure MM_Info_aboutClick(Sender: TObject);
    procedure MM_File_BmpClick(Sender: TObject);
    procedure MM_File_JgegClick(Sender: TObject);
    procedure MM_EinstellungenClick(Sender: TObject);
    procedure PC_MainChange(Sender: TObject);
    procedure PM_ImgMainPopup(Sender: TObject);
    procedure PM_movemodeClick(Sender: TObject);
    procedure MM_opt_navi_moveClick(Sender: TObject);
    procedure MM_opt_navi_zoomClick(Sender: TObject);
    procedure MM_Prm_CloseClick(Sender: TObject);
    procedure PM_refreshClick(Sender: TObject);
    procedure MM_opt_Source_ListClick(Sender: TObject);
    procedure MM_opt_Source_MainClick(Sender: TObject);
    procedure PM_undoClick(Sender: TObject);
    procedure PM_NaviClick(Sender: TObject);
    procedure PM_ZoommodeClick(Sender: TObject);
    procedure SG_KonsoleClick(Sender: TObject);
    procedure SG_KonsoleDblClick(Sender: TObject);
    procedure SG_KonsoleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SB_PEditClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TS_graphResize(Sender: TObject);
    procedure TS_KonsoleResize(Sender: TObject);
  private
    { private declarations }
    curspos:longInt;
    ReleaseInfo,TimeInfo:String;
    procedure SavePicture(picFormat:byte);//0=bmp, 1=jpeg, 2=png
    procedure ConsoleCom(act_command:string);
  public
    { public declarations }
    procedure updateGraph;
    procedure Main_resize;
    function Prefilter(Eingabe:String):string;    //Ruft Konsole.bios auf, aber schleift befehle zum Zeichnen um (z.B. numerisches integral)
  end; 

var
  FMain: TFMain;
  DrawClass:tDrawClass;
  Konsole:tKonsole;
  prm_setManager:tprmSettings;
  FuncListDB:tFuncListDB;
  Cur_Settings,ListSourceSettings,MainSourceSettings:tGlobalSet;
  LMBDownAndMod:boolean;//Wenn Maustaste gedrückt wird ein Graphmod solange erlaubt, bis abgeschlossen oder LMT losgelassen oder durch andere MT unterbrochen
  MouseDownPoint,MouseMovePoint:tPoint;
  MoveMode:boolean;
  FormResizeTime:tDateTime;
  SelCol:longInt;
implementation

{ TFMain }

procedure TFMain.ConsoleCom(act_command:string);
 var
   comment:longInt;
   StrBuf:string;
  begin
    Comment:=Pos('@',Act_Command);
    If Comment>0 then act_Command:=Copy(act_Command,1,Comment-1);
    SG_Konsole.Cells[0,SG_Konsole.RowCount-1]:=IntToStr(SG_Konsole.RowCount-1);
    SG_Konsole.Cells[1,SG_Konsole.RowCount-1]:=CB_Konsole.Text;
    StrBuf:=Konsole.BIOS(lowerCase(act_Command));
    If Konsole.ErrorCode=0 then SG_Konsole.Cells[2,SG_Konsole.RowCount-1]:=StrBuf else SG_Konsole.Cells[2,SG_Konsole.RowCount-1]:='Eingabe-Fehler: '+Konsole.ErrorMsg;
    SG_Konsole.RowCount:=SG_Konsole.RowCount+1;
    comment:=SG_Konsole.Height div SG_Konsole.RowHeights[0];
    If SG_Konsole.RowCount*SG_Konsole.RowHeights[0]>SG_Konsole.Height then SG_Konsole.TopRow:=SG_Konsole.RowCount-comment;
  end;

procedure TFMain.updateGraph;
   var
     s,e:extended;
     Loc_List:tFuncList;
     loc_strbuf:String;
    begin
      s:=time;
      If MM_opt_Source_Main.Checked then begin
        loc_strBuf:= Prefilter(CB_Mainfunc.Text);
        If loc_strBuf<>''then begin
          //Wenn die Eingabezeile aus der Fmain verwendet werden soll.
          Main_resize;
          MainSourceSettings:=Cur_Settings;
          If (prm_Setmanager.BackUpCount(false)=0)and(FuncListDB.Ergebnisse=0) then ListSourceSettings:=Cur_Settings;
          DrawClass.SetDrawEnv2D(loc_strbuf,Cur_Settings);
          prm_Setmanager.AddNewLastFunc(loc_strBuf);
        end else MessageDlg('*Eingabefehler*',Konsole.ErrorMsg, mtError, [mbOk] , 0);
      end else begin   //Wenn eine Funktionsliste gezeichnet werden soll
        Main_resize;
        ListSourceSettings:=Cur_Settings;
        FuncListDB.GetDrawList(Cur_settings,Loc_list);
        DrawClass.SetDrawEnv2D(Loc_List,Cur_Settings);
      end;
      loc_strBuf:=CB_Mainfunc.text;
      CB_Mainfunc.Color:=clyellow;
      CB_Mainfunc.text:=loc_strBuf+'  -  in Arbeit';
      DrawClass.Bildrueckgabe(Im_MainGraph);
      If Cur_Settings.Kartesianset.RulerMode>-1 then DrawClass.Linealrueckgabe(Im_ruler_hor,Im_ruler_ver,Im_ScaleIco);
      CB_Mainfunc.Color:=Clwindow;
      CB_Mainfunc.text:=loc_strBuf;
      e:=time;
      TimeInfo:='  Gesamtzeit: '+FloatToStr(round((e-s)*24*60*60*1000))+' ms';
      CB_Mainfunc.Repaint;
      Fmain.Caption:=ReleaseInfo+TimeInfo;
    end;

Procedure TFMain.Main_resize;
  var
    v:Word;
    genbuf:double;
  begin
    If FMain.MM_opt_Source_Main.Checked then begin
      v:=0;
      CB_Mainfunc.Visible:=true;
      Button1.Visible:=true;
      SB_PEdit.visible:=true;
    end else begin
      v:=Button1.Height+4;
      CB_Mainfunc.Visible:=false;
      Button1.Visible:=false;
      SB_PEdit.visible:=false;
    end;
    Cur_Settings.MainSizing.MainWidth:=FMain.width;
    Cur_Settings.MainSizing.MainHeight:=FMain.height;
    PC_Main.Width:=FMain.ClientWidth-FMain.PC_Main.Left-2;
    PC_Main.Height:=FMain.ClientHeight-FMain.PC_Main.Top-2;

    If PC_Main.ActivePageIndex=0 then begin
      If Cur_Settings.Kartesianset.RulerMode=-1 then begin
        Im_MainGraph.Left:=1;
        Im_MainGraph.height:=Fmain.PC_Main.ClientHeight-Im_MainGraph.Top-(CB_MainFunc.Height+2*4)+v+2;//2 Spalte noch vorhanden, daher 2*
        Im_MainGraph.Width:=FMain.PC_Main.ClientWidth-Im_MainGraph.Left-3;
        Im_MainGraph.Picture.Bitmap.Height:=Im_MainGraph.height;
        Im_MainGraph.Picture.Bitmap.width:=Im_MainGraph.Width;
        If Im_ruler_hor.Visible=true then Im_ruler_hor.Visible:=false;
        If Im_ScaleIco.Visible=true then Im_ScaleIco.Visible:=false;
      end else begin
        genbuf:=7.34+0.01812*SQRT(Fmain.PC_Main.ClientHeight*Fmain.PC_Main.ClientWidth);
        Im_Ruler_Hor.Height:=round(genbuf*Cur_Settings.FontSet.RulFontScale);
        Im_Ruler_Hor.Picture.Bitmap.Height:=Im_Ruler_Hor.Height;
        Im_Ruler_Ver.Width:=Im_Ruler_Hor.Height;
        Im_Ruler_Ver.Picture.Bitmap.Width:=Im_Ruler_Ver.Width;

        Im_MainGraph.Left:=Im_Ruler_Hor.Height+3;
        Im_MainGraph.height:=Fmain.PC_Main.ClientHeight-FMain.Im_ruler_hor.Height-Im_MainGraph.Top-CB_MainFunc.Height-(2*4)+v;
        Im_MainGraph.Width:=Fmain.PC_Main.ClientWidth-Im_MainGraph.left-3;
        Im_MainGraph.Picture.Bitmap.Height:=Im_MainGraph.height;
        Im_MainGraph.Picture.Bitmap.width:=Im_MainGraph.Width;

        Im_Ruler_Hor.Left:=Im_MainGraph.Left;
        Im_ruler_hor.Width:=Im_MainGraph.Width;
        Im_ruler_hor.Picture.Bitmap.width:=Im_MainGraph.Width;
        Im_ruler_hor.Top:=Im_MainGraph.height+IM_MainGraph.Top+2;

        Im_ruler_ver.height:=Im_MainGraph.height;
        Im_ruler_ver.Picture.Bitmap.Height:=Im_MainGraph.height;

        Im_ScaleIco.Top:=Im_ruler_hor.Top;
        Im_ScaleIco.Width:=Im_Ruler_Hor.Height;
        Im_ScaleIco.Picture.Bitmap.Width:=Im_ScaleIco.Width;
        Im_ScaleIco.Height:=Im_ScaleIco.Width;
        Im_ScaleIco.Picture.Bitmap.height:=Im_ScaleIco.Height;

        If Im_ruler_hor.Visible=false then Im_ruler_hor.Visible:=true;
        If Im_ScaleIco.Visible=false then Im_ScaleIco.Visible:=true;
      end;

    end;

    Cur_Settings.MainSizing.DrawResX:=Im_MainGraph.Width;
    Cur_Settings.MainSizing.DrawResY:=Im_MainGraph.height;
    Cur_Settings:=prm_SetManager.change_viewRange(Cur_Settings);
    LMBDownAndMod:=false;
    MouseMovePoint:=MouseDownPoint;
  end;

procedure TFMain.SavePicture(picFormat:byte);
 var
   rh_loc,rv_loc,main_loc,ico_loc,SavePic:tImage;
   Pos_buf:longint;
   Loc_List:tFuncList;
   jpeg_quality:word;
   FileName_loc,StrBuf,MainEdit_buf:String;
   loc_drwClass:tDrawClass;
   loc_settings:tGlobalSet;
   genbuf:double;
  begin
    MainEdit_buf:=''; FileName_loc:=''; rh_loc:=nil; rv_loc:=nil; ico_loc:=nil; main_loc:=nil; SavePic:=nil; loc_drwClass:=nil;
    strbuf:=IntToStr(cur_settings.MainSizing.DrawResX)+'x'+IntToStr(cur_settings.MainSizing.DrawResY);
    if inputquery('Hauptbild-Auflösung Eingeben','Beispiel: "1280x1024"',Strbuf)=true then begin
      try
        MainEdit_buf:=Prefilter(CB_Mainfunc.Text);
        loc_Settings:=Cur_Settings;
        Pos_buf:=Pos('x',StrBuf);
        If Pos_buf>0 then begin
          Loc_Settings.MainSizing.DrawResX:=StrToInt(trim(Copy(StrBuf,1,Pos_buf-1)));
          Loc_Settings.MainSizing.DrawResY:=StrToInt(trim(Copy(StrBuf,Pos_Buf+1,length(StrBuf)-Pos_Buf)));
          If picFormat=1 then jpeg_quality:=round(StrToInt(inputbox('Qualität Eingeben','Bitte die Qualität in % angeben (natürliche Zahl von 1 bis 100)','95')));
          Case PicFormat of
            0: begin
              SD_Main.Filter:='Bitmaps (*.bmp)|*.bmp';
              SD_Main.DefaultExt:='.bmp'; end;
            1: begin
              SD_Main.Filter:='jpeg-bilder (*.jpg)|*.jpg';
              SD_Main.DefaultExt:='.jpg'; end;
            2: begin
              SD_Main.Filter:='portable Network Graphics (*.png)|*.png';
              SD_Main.DefaultExt:='.png'; end;
          end;
          If SD_Main.Execute=true then FileName_loc:=SD_Main.FileName;
          If (FileName_loc<>'')and(((MainEdit_buf<>'')and(MM_opt_Source_Main.Checked))or(not MM_opt_Source_Main.Checked)) then begin
            rh_loc:=tImage.create(self); rv_loc:=tImage.create(self); main_loc:=tImage.Create(self); SavePic:=tImage.Create(self); ico_loc:=tImage.Create(self);
            loc_drwClass:=tDrawClass.create;
            If MM_opt_Source_Main.Checked then
              loc_drwClass.SetDrawEnv2D(MainEdit_buf,loc_Settings)  //Wenn die Eingabezeile aus der Fmain verwendet werden soll.
            else begin   //Wenn eine Funktionsliste gezeichnet werden soll
              FuncListDB.GetDrawList(loc_settings,Loc_list);
              loc_DrwClass.SetDrawEnv2D(Loc_List,loc_Settings);
              Loc_List:=nil;
            end;
            CB_Mainfunc.Color:=clyellow;
            CB_Mainfunc.Text:='Bitte warten, Abbildung wird gespeichert';
            CB_Mainfunc.Repaint;
            Main_loc.Width:=Loc_Settings.MainSizing.DrawResX;
            Main_loc.Picture.Bitmap.Width:=Main_loc.Width;
            Main_loc.height:=Loc_Settings.MainSizing.DrawResY;
            Main_loc.Picture.Bitmap.height:=Main_loc.height;
            If Loc_Settings.Kartesianset.RulerMode=-1 then begin
              loc_drwClass.Bildrueckgabe(Main_loc);
              SavePic.Width:=Loc_Settings.MainSizing.DrawResX;
              SavePic.Picture.Bitmap.Width:=Main_loc.Width;
              SavePic.height:=Loc_Settings.MainSizing.DrawResY;
              SavePic.Picture.Bitmap.height:=Main_loc.height;
              SavePic.Canvas.Draw(0,0,Main_loc.Picture.Bitmap);
            end else begin
              rh_loc.Width:=Loc_Settings.MainSizing.DrawResX;
              rh_loc.Picture.Bitmap.Width:=Main_loc.Width;
              genbuf:=7.2+0.019041*SQRT(loc_settings.MainSizing.DrawResX*loc_settings.MainSizing.DrawResY);
              rh_loc.height:=round(genbuf*loc_Settings.FontSet.RulFontScale);
              rh_loc.Picture.Bitmap.height:=rh_loc.height;
              ico_loc.Width:=rh_loc.height;
              ico_loc.Picture.Bitmap.Width:=rh_loc.height;
              ico_loc.height:=rh_loc.height;
              ico_loc.Picture.Bitmap.height:=rh_loc.height;
              rv_loc.Width:=rh_loc.height;
              rv_loc.Picture.Bitmap.Width:=rh_loc.height;
              rv_loc.height:=Loc_Settings.MainSizing.DrawResY;
              rv_loc.Picture.Bitmap.height:=Main_loc.height;
              loc_drwClass.Bildrueckgabe(Main_loc);
              loc_drwClass.Linealrueckgabe(rh_loc,rv_loc,ico_loc);
              SavePic.Width:=Loc_Settings.MainSizing.DrawResX+rh_loc.height+3;
              SavePic.Picture.Bitmap.Width:=SavePic.Width;
              SavePic.height:=Loc_Settings.MainSizing.DrawResY+rh_loc.height+3;
              SavePic.Picture.Bitmap.height:=SavePic.height;
              Savepic.Picture.Bitmap.Canvas.Brush.Color:=clwhite;
              SavePic.Picture.Bitmap.Canvas.FillRect(0,0,SavePic.Width-1,SavePic.Height-1);
              SavePic.Canvas.Draw(0,0,rv_loc.Picture.Bitmap);
              SavePic.Canvas.Draw(rh_loc.height+2,0,Main_loc.Picture.Bitmap);
              SavePic.Canvas.Draw(0,Loc_Settings.MainSizing.DrawResY+2,ico_loc.Picture.Bitmap);
              SavePic.Canvas.Draw(rh_loc.height+2,Loc_Settings.MainSizing.DrawResY+2,rh_loc.Picture.Bitmap);
            end;
            Case PicFormat of
              0: SavePic.Picture.Bitmap.SaveToFile(FileName_loc);
              1: begin
                SavePic.Picture.Jpeg.CompressionQuality:=jpeg_quality;
                SavePic.Picture.Jpeg.SaveToFile(FileName_loc); end;
              2: Savepic.Picture.PNG.SaveToFile(FileName_loc);
            end;
            loc_drwClass.free;
            loc_drwClass:=nil;
            rh_loc:=nil; rv_loc:=nil; main_loc:=nil; SavePic:=nil; ico_loc:=nil;
            CB_Mainfunc.Color:=clwhite;
            CB_Mainfunc.Text:=MainEdit_buf;
          end;
        end;
      except
        if loc_drwClass<>nil then begin
          loc_drwClass.free;
          loc_drwClass:=nil;
        end;
        if rh_loc<>nil then rh_loc:=nil;
        if rv_loc<>nil then rv_loc:=nil;
        if ico_loc<>nil then ico_loc:=nil;
        if main_loc<>nil then main_loc:=nil;
        if SavePic<>nil then SavePic:=nil;
        if MainEdit_buf<>'' then begin
          CB_Mainfunc.Color:=clwhite;
          CB_Mainfunc.Text:=MainEdit_buf;
        end;
        MessageDlg('*Eingabefehler*','Es wird nichts unternommen.', mtinformation, [mbOk] , 0);
      end;//Wenn nicht abgebrochen worden ist bei Auflösungseingabe
    end;
  end;

function tFMain.Prefilter(Eingabe:string):String;
 var
   w,posc,poss:dword; //posc=Position von ')' ; poss=Position von ';'
   strbuf:string;
  begin
    result:='';
    //Filterabfrage
    If (Pos('drwint(',LowerCase(Eingabe))=0) and (Pos('pointcloud(',LowerCase(Eingabe))=0) then result:=Konsole.BIOS(Eingabe) else   //Wenn PFilter=0 dann handelt es sich um einen Konsolen-Standard-Befehl, sonst wird gefiltert
    //DrwInt-Filter
    if Pos('drwint(',LowerCase(Eingabe))<>0 then  begin
      strbuf:=trim(lowercase(Eingabe));
      strbuf:=Copy(Strbuf,8,length(Strbuf)-8);
      posc:=0;
      poss:=0;
      w:=length(Strbuf);
      repeat
        If Copy(StrBuf,w,1)=')' then posc:=w;
        If Copy(StrBuf,w,1)=';' then poss:=w;
        dec(w,1);
      until (posc>0)or(w<1);
      If (Poss=0) then begin  //Sicher ohne Parameter
        StrBuf:=Konsole.BIOS(strBuf);
        result:='DrwInt('+StrBuf+')';
        If length(result)<9 then result:='';
      end else begin
        result:=Konsole.BIOS(Copy(StrBuf,1,Poss-1));
        If result<>'' then result:='DrwInt('+result+Copy(StrBuf,poss,length(Strbuf)-poss+1)+')';
      end;
    end
    //PointCloud-Filter: PointClouds werden einfach durchgeschleust, da diese in der DrawClass mit Hilfe der uNumeric aufbereitet und ein Array ausgegeben wird.
    else if Pos('pointcloud(',LowerCase(Eingabe))<>0 then result:=Eingabe;
  end;

procedure TFMain.Button1Click(Sender: TObject);
 var
   le,i:longInt;
   buf:tStrArr;
  begin
    updateGraph;
    prm_Setmanager.refreshLastFuncs(Buf);
    le:=Length(buf);
    If le>0 then begin
      CB_Mainfunc.Clear;
      For i:=0 to le-1 do begin
        CB_Mainfunc.Items.Add(Buf[i]);
      end;
      CB_Mainfunc.Text:=Buf[le-1];
    end;
end;

procedure TFMain.CB_KonsoleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CursPos:=CB_Konsole.Cursor;
end;

procedure TFMain.CB_MainfuncKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
 var
   le,i:longInt;
   buf:tStrArr;
begin
  If (key = 13) and (CB_Mainfunc.text<>'') then begin
    key:= 0; //beep abschalten
    FMain.updateGraph;
    prm_Setmanager.refreshLastFuncs(Buf);
    le:=Length(buf);
    If le>0 then begin
      CB_Mainfunc.Clear;
      For i:=0 to le-1 do begin
        CB_Mainfunc.Items.Add(Buf[i]);
      end;
      CB_Mainfunc.Text:=Buf[le-1];
    end;
  end;
end;

procedure TFMain.CB_MainfuncSelect(Sender: TObject);
begin
  updateGraph;
end;

procedure TFMain.CB_KonsoleKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If (key = 13) and (CB_Konsole.text<>'') then begin
    key:= 0; //beep abschalten
    ConsoleCom(CB_Konsole.text);
  end;
end;

procedure TFMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Prm_Setmanager.SaveGlobalSetToIni(MainSourceSettings,'defaults.ini');
  prm_Setmanager.SaveLastFuncs('LastFuncs.lstf');
  DrawClass.free;
  FuncListDB.free;
  Prm_SetManager.free;
  Konsole.free;
end;

procedure TFMain.FormCreate(Sender: TObject);
var
  i,le:longint;
  buf:tStrArr;
begin
  FormResizeTime:=now;
  SelCol:=0;
  Decimalseparator:=',';
  DrawClass:=tDrawClass.create;
  FuncListDB:=tFuncListDB.create;
  Konsole:=tKonsole.create;
  IM_MainGraph.Picture.Bitmap.PixelFormat:=pf24bit;
  MoveMode:=true;
  LMBDownAndMod:=false;
  {$ifdef linux}
    Fmain.Font.Size:=9;
    FMain.PC_Main.Color:=clWhite;
    FMain.Button1.Height:=27;
    FMain.Label3.Left:=4;
  {$endif}
  randomize;
  prm_setManager:=tPrmSettings.Create;
  prm_SetManager.LoadIniToGlobalSet(Cur_Settings,'defaults.ini');
  prm_Setmanager.LoadLastFuncs(Buf,'LastFuncs.lstf');
  le:=Length(buf);
  If le>0 then begin
    CB_Mainfunc.Clear;
    For i:=0 to le-1 do begin
      CB_Mainfunc.Items.Add(Buf[i]);
    end;
    CB_Mainfunc.Text:=Buf[le-1];
  end;
  ListSourceSettings:=Cur_Settings;
  MainSourceSettings:=Cur_Settings;
  If Cur_Settings.MainSizing.Maximized then FMain.WindowState:=wsmaximized;
  FMain.Width:=Cur_Settings.MainSizing.MainWidth;
  FMain.Height:=Cur_Settings.MainSizing.MainHeight;
  ReleaseInfo:='-Promathika-';
  FMain.Caption:=ReleaseInfo;
end;



procedure TFMain.FormResize(Sender: TObject);
begin
  LMBDownAndMod:=false;
  FormResizeTime:=now;
  Timer1.Enabled:=true;   //Diese Zeile kann durch ein simples "updateGraph" ersetzt werden, wenn der Lazarus-Bug mit ClientHeight behoben ist.
  If PC_Main.ActivePageIndex=1 then Main_Resize;
end;

procedure TFMain.FormWindowStateChange(Sender: TObject);
begin
  Cur_Settings.MainSizing.Maximized:=FMain.WindowState=wsmaximized;
  LMBDownAndMod:=false;
end;

procedure TFMain.Im_MainGraphMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If (Button=mbleft) then begin
    LMBDownAndMod:=true;
    MouseDownPoint:=Point(x,y);
    MouseMovePoint:=MouseDownPoint;
  end else begin
    if ((MouseDownPoint.x<>MouseMovePoint.x)or(MouseDownPoint.y<>MouseMovePoint.y))and(LMBDownAndMod)
      then DrawClass.PfeilOderBox(Im_MainGraph,MouseDownPoint,MouseMovePoint,MoveMode);
    MouseDownPoint:=Point(x,y);
    MouseMovePoint:=MouseDownPoint;
    LMBDownAndMod:=false;
  end;
end;

procedure TFMain.Im_MainGraphMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
    xkoord,ykoord,buf:extended;
    scaleX,scaleY:integer;
begin
  //Berechnung der Koordinaten
  ScaleX:=round(ln(Cur_Settings.Kartesianset.xmax-Cur_Settings.Kartesianset.xmin)/ln(10));
  ScaleY:=round(ln(Cur_Settings.Kartesianset.ymax-Cur_Settings.Kartesianset.ymin)/ln(10));
  buf:=Cur_Settings.Kartesianset.xmin+(Cur_Settings.Kartesianset.xmax-Cur_Settings.Kartesianset.xmin)*x/Cur_Settings.MainSizing.DrawResX;
  xkoord:=round(power(10,-ScaleX+3)*buf)/power(10,-ScaleX+3);
  buf:=Cur_Settings.Kartesianset.ymax-(Cur_Settings.Kartesianset.ymax-Cur_Settings.Kartesianset.ymin)*y/Cur_Settings.MainSizing.DrawResY;
  ykoord:=round(power(10,-ScaleY+3)*buf)/power(10,-ScaleY+3);
  Fmain.Caption:=ReleaseInfo+TimeInfo+' x: '+FloatToStr(xkoord)+' ;  y: '  +FloatToStr(ykoord);
  //Zeichen von Pfeil oder Box, wenn LMBDownAndMod (Maustaste dauerhaft gedrückt wird)
  If LMBDownAndMod then begin
    DrawClass.PfeilOderBox(Im_MainGraph,MouseDownPoint,MouseMovePoint,MoveMode);
    MouseMovePoint:=Point(x,y);
    DrawClass.PfeilOderBox(Im_MainGraph,MouseDownPoint,MouseMovePoint,MoveMode);
  end;
end;

procedure TFMain.Im_MainGraphMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
 var
   zoomx,zoomy,buffer:extended;
   ZoomRect:tRect;
begin
  If (Button=MBleft)and ((MouseDownPoint.x<>MouseMovePoint.x)or(MouseDownPoint.y<>MouseMovePoint.y)) then begin
    zoomx:=Cur_Settings.MainSizing.DrawResX/(Cur_Settings.Kartesianset.xmax-Cur_Settings.Kartesianset.xmin);             //notwendige Werte werden initialisiert
    zoomy:=Cur_Settings.MainSizing.DrawResY/(Cur_Settings.Kartesianset.ymax-Cur_Settings.Kartesianset.ymin);
    if MoveMode then begin                     //verschieben
      if ((MouseDownPoint.x<>MouseMovePoint.x)or(MouseDownPoint.y<>MouseMovePoint.y)){and(MessageDlg('Manipulator','Soll der Anzeigebereich wirklich verschoben werden?', mtconfirmation,[mbyes, mbno], 0) = MrYes)} then begin
        prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
        Cur_Settings.KartesianSet.xmin:=Cur_Settings.KartesianSet.xmin-(MouseMovePoint.x-MouseDownPoint.x)/zoomx;
        Cur_Settings.KartesianSet.xmax:=Cur_Settings.KartesianSet.xmax-(MouseMovePoint.x-MouseDownPoint.x)/zoomx;
        Cur_Settings.KartesianSet.ymin:=Cur_Settings.KartesianSet.ymin+(MouseMovePoint.y-MouseDownPoint.y)/zoomy;
        Cur_Settings.KartesianSet.ymax:=Cur_Settings.KartesianSet.ymax+(MouseMovePoint.y-MouseDownPoint.y)/zoomy;
        UpdateGraph;
        LMBDownAndMod:=false;
      end else begin
        DrawClass.PfeilOderBox(Im_MainGraph,MouseDownPoint,MouseMovePoint,MoveMode);
        MouseDownPoint:=MouseMovePoint;
        LMBDownAndMod:=false;
      end;
    end;
    If not moveMode then begin
      if ((MouseDownPoint.x<>MouseMovePoint.x)and(MouseDownPoint.y<>MouseMovePoint.y)){and(MessageDlg('Manipulator','Soll der Anzeigebereich wirklich gezoomed werden?', mtconfirmation,[mbyes, mbno], 0) = MrYes)} then begin
        prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
        If MouseDownPoint.x<MouseMovePoint.x then ZoomRect.Left:=MouseDownPoint.x else ZoomRect.Left:=MouseMovePoint.x;
        If MouseDownPoint.x>MouseMovePoint.x then ZoomRect.Right:=MouseDownPoint.x else ZoomRect.Right:=MouseMovePoint.x;
        If MouseDownPoint.y<MouseMovePoint.y then ZoomRect.Top:=MouseDownPoint.y else ZoomRect.Top:=MouseMovePoint.y;
        If MouseDownPoint.y>MouseMovePoint.y then ZoomRect.bottom:=MouseDownPoint.y else ZoomRect.Bottom:=MouseMovePoint.y;
        buffer:=Cur_Settings.KartesianSet.xmin;
        Cur_Settings.KartesianSet.xmin:=ZoomRect.left/ZoomX+buffer;     //matx:=Canvx/zoomx+xmin
        Cur_Settings.KartesianSet.xmax:=ZoomRect.right/ZoomX+buffer;
        buffer:=Cur_Settings.KartesianSet.ymax;
        Cur_Settings.KartesianSet.ymin:=(ZoomRect.bottom/zoomY-buffer)*-1;  //maty:=(Canvy/zoomy-ymax)*-1
        Cur_Settings.KartesianSet.ymax:=(ZoomRect.top/zoomY-buffer)*-1;
        updateGraph;
        LMBDownAndMod:=false;
      end else begin
        DrawClass.PfeilOderBox(Im_MainGraph,MouseDownPoint,MouseMovePoint,MoveMode);
        MouseDownPoint:=MouseMovePoint;
        LMBDownAndMod:=false;
      end;
    end;
  end else if Button=MBleft then LMBDownAndMod:=false;
end;

procedure TFMain.MM_File_pngClick(Sender: TObject);
begin
  FMain.SavePicture(2);
end;

procedure TFMain.MM_Module_EqEditClick(Sender: TObject);
begin
  FEqEdit:=tFEqEdit.Create(nil);
  FEqEdit.showmodal;
  FEqEdit.free;
end;

procedure TFMain.MM_Module_FuncEditClick(Sender: TObject);
begin
  FFuncEdit:=tFFuncEdit.Create(nil);
  FFuncEdit.showmodal;
  FFuncEdit.free;
end;

procedure TFMain.MM_Info_aboutClick(Sender: TObject);
begin
  MessageDlg('*Info*','Version 1.1.1; prm_Kernel: 2.3.83.108', mtinformation, [mbOk] , 0);
end;

procedure TFMain.MM_File_BmpClick(Sender: TObject);
begin
  FMain.SavePicture(0);
end;

procedure TFMain.MM_File_JgegClick(Sender: TObject);
begin
  Fmain.SavePicture(1);
end;

procedure TFMain.MM_EinstellungenClick(Sender: TObject);
begin
  FEinstellungen:=tFEinstellungen.Create(nil);
  FEinstellungen.showmodal;
  FEinstellungen.free;
end;

procedure TFMain.PC_MainChange(Sender: TObject);
begin
  If PC_Main.PageIndex=0 then timer1.Enabled:=true;
end;

procedure TFMain.PM_ImgMainPopup(Sender: TObject);
begin
  If prm_Setmanager.BackUpCount(FMain.MM_opt_Source_Main.Checked)>0 then PM_undo.Enabled:=true else PM_undo.Enabled:=false;
  If (MouseDownPoint.x<40)and(MouseDownPoint.y>40)and(MouseDownPoint.y<Fmain.Im_MainGraph.Height-40)then Pm_navi.Caption:='xmin' else
  If (MouseDownPoint.x>Fmain.Im_MainGraph.width-40)and(MouseDownPoint.y>40)and(MouseDownPoint.y<Fmain.Im_MainGraph.Height-40)then Pm_navi.Caption:='xmax'else
  If (MouseDownPoint.y<40)and(MouseDownPoint.x>40)and(MouseDownPoint.x<Fmain.Im_MainGraph.Width-40)then Pm_navi.Caption:='ymax'else
  If (MouseDownPoint.y>Fmain.Im_MainGraph.height-40)and(MouseDownPoint.x>40)and(MouseDownPoint.x<Fmain.Im_MainGraph.width-40)then Pm_navi.Caption:='ymin'else
  Pm_navi.Caption:='Zoom';
end;

procedure TFMain.PM_movemodeClick(Sender: TObject);
begin
  If PM_moveMode.Checked=false then begin
    PM_MoveMode.Checked:=true;
    MM_opt_navi_move.Checked:=true;
    MM_opt_navi_zoom.Checked:=false;
    PM_ZoomMode.Checked:=false;
    moveMode:=true;
  end;
end;

procedure TFMain.MM_opt_navi_moveClick(Sender: TObject);
begin
  If MM_opt_navi_move.Checked=false then begin
    PM_MoveMode.Checked:=true;
    MM_opt_navi_move.Checked:=true;
    MM_opt_navi_zoom.Checked:=false;
    PM_ZoomMode.Checked:=false;
    moveMode:=true;
  end;
end;

procedure TFMain.MM_opt_navi_zoomClick(Sender: TObject);
begin
  If MM_opt_navi_zoom.Checked=false then begin
    MM_opt_navi_zoom.Checked:=true;
    PM_ZoomMode.Checked:=true;
    MM_opt_navi_move.Checked:=false;
    PM_MoveMode.Checked:=false;
    MoveMode:=false;
  end;
end;

procedure TFMain.MM_Prm_CloseClick(Sender: TObject);
begin
  FMain.Close;
end;

procedure TFMain.PM_refreshClick(Sender: TObject);
begin
  updateGraph;
end;

procedure TFMain.MM_opt_Source_ListClick(Sender: TObject);
begin
  If (MM_opt_Source_List.Checked=false)and(FuncListDB.Ergebnisse>0) then begin
    MM_opt_Source_Main.Checked:=false;
    MM_opt_Source_List.Checked:=true;
    Cur_Settings:=ListSourceSettings;
    UpdateGraph;
  end else MessageDlg('*Info*','Es ist keine Funktionsliste geladen oder erstellt. Quelle wird nicht geändert.', mtinformation, [mbOk] , 0);
end;

procedure TFMain.MM_opt_Source_MainClick(Sender: TObject);
begin
  If MM_opt_Source_Main.Checked=false then begin
    MM_opt_Source_Main.Checked:=true;
    MM_opt_Source_List.Checked:=false;
    Cur_Settings:=MainSourceSettings;
    updateGraph;
  end;
end;

procedure TFMain.PM_undoClick(Sender: TObject);
begin
  LMBDownAndMod:=false;
  MouseDownPoint.x:=MouseMovePoint.x;
  MouseDownPoint.y:=MouseMovePoint.y;
  Cur_Settings:=prm_Setmanager.UndoSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
  updateGraph;
end;

procedure TFMain.PM_NaviClick(Sender: TObject);
var
  buf,xmitte,ymitte,dx,dy:extended;
  Input_buf:string;
begin
  If PM_Navi.Caption='Zoom' then begin
    try
      Input_buf:='1';
      If InputQuery('Zoom-Faktor Eingabe','Bitte eine reele Zahl größer 0 eingeben',Input_Buf)=true then begin
        buf:=StrToFloat(Input_buf);
        If Buf<=0 then Buf:=0; //Fehler wird Provoziert, wenn Zoom-Faktor <=0, da durch 0 geteilt wird im Anschluss
        Prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
        xmitte:=Cur_settings.Kartesianset.xmin+(Cur_settings.Kartesianset.xmax-Cur_settings.Kartesianset.xmin)/2;
        dx:=abs(Cur_settings.Kartesianset.xmax-xmitte)/buf;
        Cur_settings.Kartesianset.xmin:=xmitte-dx;
        Cur_settings.Kartesianset.xmax:=xmitte+dx;
        ymitte:=Cur_settings.Kartesianset.ymin+(Cur_settings.Kartesianset.ymax-Cur_settings.Kartesianset.ymin)/2;
        dy:=abs(Cur_settings.Kartesianset.ymax-ymitte)/buf;
        Cur_settings.Kartesianset.ymin:=ymitte-dy;
        Cur_settings.Kartesianset.ymax:=ymitte+dy;
        updateGraph;
      end;
    except
      MessageDlg('!Eingabefehler!','Ungültige Eingabe; nichts wird unternommen! Zoomwerte>1=Vergrößerung, 1>Zoomwerte>0=Verkleinerung', mtinformation, [mbOk] , 0);
    end;
  end;

  If PM_Navi.Caption='xmin' then begin
    try
      Input_buf:=FloatToStr(Cur_Settings.Kartesianset.xmin);
      If InputQuery('Neudefinition von xmin','Bitte eine reele Zahl eingeben',Input_Buf)=true then begin
        buf:=StrToFloat(Input_buf);
        If Cur_Settings.Kartesianset.xmax>buf then begin
          Prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
          Cur_Settings.Kartesianset.xmin:=buf;
          updateGraph;
        end else MessageDlg('!Eingabefehler!','Der Minimalwert darf nicht größer als der Maximalwert ('+FloatToStr(Cur_Settings.Kartesianset.xmax)+') sein', mtinformation, [mbOk] , 0);
      end;
    except
      MessageDlg('!Eingabefehler!','Ungültige Eingabe, nur Zahlen werden akzeptiert; nichts wird unternommen!', mtinformation, [mbOk] , 0);
    end;
  end;

  If PM_Navi.Caption='xmax' then begin
    try
      Input_buf:=FloatToStr(Cur_Settings.Kartesianset.xmax);
      If InputQuery('Neudefinition von xmax','Bitte eine reele Zahl eingeben',Input_Buf)=true then begin
        buf:=StrToFloat(Input_buf);
        If Cur_Settings.Kartesianset.xmin<buf then begin
          Prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
          Cur_Settings.Kartesianset.xmax:=buf;
          updateGraph;
        end else MessageDlg('!Eingabefehler!','Der Maximalwert darf nicht kleiner als der Minimalwert ('+FloatToStr(Cur_Settings.Kartesianset.xmin)+') sein', mtinformation, [mbOk] , 0);
      end;
    except
      MessageDlg('!Eingabefehler!','Ungültige Eingabe, nur Zahlen werden akzeptiert; nichts wird unternommen!', mtinformation, [mbOk] , 0);
    end;
  end;

  If PM_Navi.Caption='ymin' then begin
    try
      Input_buf:=FloatToStr(Cur_Settings.Kartesianset.ymin);
      If InputQuery('Neudefinition von ymin','Bitte eine reele Zahl eingeben',Input_Buf)=true then begin
        buf:=StrToFloat(Input_buf);
        If Cur_Settings.Kartesianset.ymax>buf then begin
          Prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
          Cur_Settings.Kartesianset.ymin:=buf;
          updateGraph;
        end else MessageDlg('!Eingabefehler!','Der Minimalwert darf nicht größer als der Maximalwert ('+FloatToStr(Cur_Settings.Kartesianset.ymax)+') sein', mtinformation, [mbOk] , 0);
      end;
    except
      MessageDlg('!Eingabefehler!','Ungültige Eingabe, nur Zahlen werden akzeptiert; nichts wird unternommen!', mtinformation, [mbOk] , 0);
    end;
  end;

  If PM_Navi.Caption='ymax' then begin
    try
      Input_buf:=FloatToStr(Cur_Settings.Kartesianset.ymax);
      If InputQuery('Neudefinition von ymax','Bitte eine reele Zahl eingeben',Input_Buf)=true then begin
        buf:=StrToFloat(Input_buf);
        If Cur_Settings.Kartesianset.ymin<buf then begin
          Prm_Setmanager.BackupSettings(FMain.MM_opt_Source_Main.Checked,Cur_Settings);
          Cur_Settings.Kartesianset.ymax:=buf;
          updateGraph;
        end else MessageDlg('!Eingabefehler!','Der Maximalwert darf nicht kleiner als der Minimalwert ('+FloatToStr(Cur_Settings.Kartesianset.ymin)+') sein', mtinformation, [mbOk] , 0);
      end;
    except
      MessageDlg('!Eingabefehler!','Ungültige Eingabe, nur Zahlen werden akzeptiert; nichts wird unternommen!', mtinformation, [mbOk] , 0);
    end;
  end;
end;

procedure TFMain.PM_ZoommodeClick(Sender: TObject);
begin
  If PM_zoommode.Checked=false then begin
    MM_opt_navi_zoom.Checked:=true;
    PM_ZoomMode.Checked:=true;
    MM_opt_navi_move.Checked:=false;
    PM_MoveMode.Checked:=false;
    MoveMode:=false;
  end;
end;

procedure TFMain.SG_KonsoleClick(Sender: TObject);
begin

end;


procedure TFMain.SG_KonsoleDblClick(Sender: TObject);
 //var
 //s:string;
begin
  If (SelCol=1)or(SelCol=2) then begin
    //s:=CB_Konsole.Text;
    //Insert(SG_Konsole.Cells[SG_Konsole.Col,SG_Konsole.Row],s,Curspos);
    CB_Konsole.Text:=CB_Konsole.Text+SG_Konsole.Cells[SG_Konsole.Col,SG_Konsole.Row];
  end;
end;

procedure TFMain.SG_KonsoleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  r:longInt;

begin
  SG_Konsole.MouseToCell(X,Y,SelCol,r);
end;



procedure TFMain.SpeedButton1Click(Sender: TObject);
begin
  ConsoleCom(CB_Konsole.text);
end;

procedure TFMain.SpeedButton2Click(Sender: TObject);
begin
  SG_Konsole.RowCount:=2;
  SG_Konsole.Clean([gzNormal]);
end;

procedure TFMain.SB_PEditClick(Sender: TObject);
begin
  FPointEdit:=tFPointEdit.Create(0,CB_Mainfunc.Text);
  FPointEdit.showmodal;
  FPointEdit.free;
end;

procedure TFMain.Timer1Timer(Sender: TObject);
begin
  If now-FormResizeTime>(1/(86400*2)) then begin   //Wenn seit Größenänderung min 0,5s vergangen
    If PC_Main.ActivePageIndex=0 then updateGraph;
    Timer1.Enabled:=false;
  end;
end;

procedure TFMain.TS_graphResize(Sender: TObject);
begin
  CB_Mainfunc.top:=FMain.PC_Main.ClientHeight-CB_MainFunc.Height-4;
  CB_Mainfunc.Width:=FMain.TS_graph.ClientWidth-154;
  FMain.Button1.Top:=FMain.PC_Main.ClientHeight-CB_MainFunc.Height-4;
  FMain.Button1.left:=FMain.TS_graph.ClientWidth-FMain.Button1.Width-2;
  FMain.SB_PEdit.Left:=FMain.Button1.left-34;
  FMain.SB_PEdit.Top:=FMain.Button1.top;
  FMain.Label3.Top:=CB_Mainfunc.top+4;
end;

procedure TFMain.TS_KonsoleResize(Sender: TObject);
var
  i:longInt;
begin
  SpeedButton1.Top:=FMain.PC_Main.ClientHeight-SpeedButton1.Height-2;
  SpeedButton2.Top:=Speedbutton1.Top;
  CB_Konsole.Top:=FMain.PC_Main.ClientHeight-SpeedButton1.Height-CB_Konsole.Height-6;
  CB_Konsole.Width:=FMain.PC_Main.ClientWidth-3-CB_Konsole.Left;
  SG_Konsole.Height:=FMain.PC_Main.ClientHeight-SG_Konsole.Top-SpeedButton1.Height-CB_Konsole.Height-12;
  SG_Konsole.Width:=CB_Konsole.Width;
  SG_Konsole.ColWidths[2]:=300;  SG_Konsole.ColWidths[1]:=SG_Konsole.Width-SG_Konsole.ColWidths[2]-SG_Konsole.DefaultColWidth-24;
  i:=SG_Konsole.Height div SG_Konsole.RowHeights[0];
  If SG_Konsole.RowCount*SG_Konsole.RowHeights[0]>SG_Konsole.Height then SG_Konsole.TopRow:=SG_Konsole.RowCount-i;
end;




initialization
  {$I umain.lrs}

end.

